// generated by Fast Light User Interface Designer (fluid) version 1.0304

#include "MasterUI.h"
// MasterUI.cc
// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2011, Alan Calvert
// Copyright 2014-2018, Will Godfrey & others

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is a derivative of the ZynAddSubFX original.

// Modified October 2018

void MasterUI::cb_masterwindow_i(Fl_Double_Window*, void*) {
  //
      bool close = true;
      if (synth->getRuntime().configChanged)
      {
          int r = fl_choice("Parameters Changed", "Save Changes", "Cancel", "Don't Save");
          switch (r)
          {
              case 0:
                  synth->getRuntime().configChanged = false;
                  // this seems backwards but it *always* saves.
                  // seeing configChanged makes it reload the old settings first.
                  break;
              case 2:
                  break;
              default:
                  close = false;
                  break;
          }
      }
      if (close)
      {
          synth->guiClosed(true);
      };
}
void MasterUI::cb_masterwindow(Fl_Double_Window* o, void* v) {
  ((MasterUI*)(o->user_data()))->cb_masterwindow_i(o,v);
}

void MasterUI::cb_About_i(Fl_Menu_*, void*) {
  //
                    Contributors->hide();
                    aboutwindow->show();
                    aboutFirst->show();
}
void MasterUI::cb_About(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_About_i(o,v);
}

void MasterUI::cb_newinstanceid_i(Fl_Menu_*, void*) {
  //
            if(synth->getIsLV2Plugin())
            {
                fl_alert("Start new instances from host");
                return;
            }
            if(synth->getUniqueId() != 0)
            {
                fl_alert("Only main instance can start others");
                return;
            }

            const char *sId = fl_input("Accept next, or enter desired instance id...", "next");
            if (sId == NULL)
                return;
            unsigned int forceId = 0;
            if (sId)
                forceId = string2uint(sId);
            send_data(MAIN::control::startInstance, forceId, TOPLEVEL::type::Integer, TOPLEVEL::section::main, UNUSED, UNUSED, TOPLEVEL::route::lowPriority);
}
void MasterUI::cb_newinstanceid(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_newinstanceid_i(o,v);
}

void MasterUI::cb_Settings_i(Fl_Menu_*, void*) {
  configui->Show();
}
void MasterUI::cb_Settings(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Settings_i(o,v);
}

void MasterUI::cb_MIDI_i(Fl_Menu_*, void*) {
  midilearnui->Show();
}
void MasterUI::cb_MIDI(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_MIDI_i(o,v);
}

void MasterUI::cb_View_i(Fl_Menu_*, void*) {
  //
            send_data(100, 0, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main, UNUSED, UNUSED, TOPLEVEL::route::lowPriority);
            return;
}
void MasterUI::cb_View(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_View_i(o,v);
}

void MasterUI::cb_E_i(Fl_Menu_*, void*) {
  masterwindow->do_callback();
}
void MasterUI::cb_E(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_E_i(o,v);
}

void MasterUI::cb_S_i(Fl_Menu_*, void*) {
  bankui->Show();
}
void MasterUI::cb_S(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_S_i(o,v);
}

void MasterUI::cb_Load_i(Fl_Menu_*, void*) {
  //
                string lastname = synth->lastItemSeen(XML_INSTRUMENT);
                if (lastname == "")
                    lastname = synth->getRuntime().userHome;
                const char *filename;
                filename = fl_file_chooser("Load:", "({*.xi*})", lastname.c_str(), 0);
                if (filename == NULL)
                    return;
                do_load_instrument(filename);
}
void MasterUI::cb_Load(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Load_i(o,v);
}

void MasterUI::cb_Save_i(Fl_Menu_*, void*) {
  //
                if (synth->part[npart]->Pname == "Simple Sound")
                {
                    fl_alert("Nothing to save!");
                    return;
                }
                string newname = synth->part[npart]->Pname;
                if (newname < "!")
                    return;
                newname = synth->getRuntime().userHome + newname;
                const char *filename;
                filename = fl_file_chooser("Save:", "({*.xi*})", newname.c_str(), 0);
                if (filename == NULL)
                    return;
                if (isRegFile(string(filename)))
                    if (fl_choice("The file exists. \nOverwrite it?", NULL, "No", "Yes") < 2)
                        return;
                send_data(MAIN::control::saveNamedInstrument, float(npartcounter->value() - 1), TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main, UNUSED, UNUSED, TOPLEVEL::route::lowPriority, miscMsgPush(string(filename)));
                return;
}
void MasterUI::cb_Save(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Save_i(o,v);
}

void MasterUI::cb_RecentInstruments_i(Fl_Menu_*, void*) {
  //
            paramsui->Recent->position(masterwindow->x() + masterwindow->w() - paramsui->Recent->w(),masterwindow->y()+20);
            paramsui->Show(XML_INSTRUMENT);
}
void MasterUI::cb_RecentInstruments(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_RecentInstruments_i(o,v);
}

void MasterUI::cb_Clear_i(Fl_Menu_*, void*) {
  //
            if(fl_choice("Clear parameters of instrument %d ?", NULL, "No", "Yes", partui->npart + 1) > 1)
                send_data(PART::control::defaultInstrument,0, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, partui->npart);
}
void MasterUI::cb_Clear(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Clear_i(o,v);
}

void MasterUI::cb_S1_i(Fl_Menu_*, void*) {
  //
            bankui->bankuiwindow->show();
}
void MasterUI::cb_S1(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_S1_i(o,v);
}

void MasterUI::cb_Load1_i(Fl_Menu_*, void*) {
  //
            do_load_master(NULL);
}
void MasterUI::cb_Load1(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Load1_i(o,v);
}

void MasterUI::cb_Save1_i(Fl_Menu_*, void*) {
  //
            bool valid = false;
            for(int npart = 0; npart < NUM_MIDI_PARTS; npart ++)
                if (synth->part[npart]->Pname != "Simple Sound")
                {
                    valid = true;
                    npart = NUM_MIDI_PARTS;
                }
            if (valid)
                do_save_master();
            else
                fl_alert("Nothing to save!");
}
void MasterUI::cb_Save1(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Save1_i(o,v);
}

void MasterUI::cb_RecentParams_i(Fl_Menu_*, void*) {
  //
            paramsui->Recent->position(masterwindow->x() + masterwindow->w() - paramsui->Recent->w(),masterwindow->y()+20);
            paramsui->Show(XML_PARAMETERS);
}
void MasterUI::cb_RecentParams(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_RecentParams_i(o,v);
}

void MasterUI::cb_Bank_i(Fl_Menu_*, void*) {
  //
            bankui->rootuiwindow->show();
}
void MasterUI::cb_Bank(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Bank_i(o,v);
}

void MasterUI::cb_Preset_i(Fl_Menu_*, void*) {
  //
            configui->presets->show();
}
void MasterUI::cb_Preset(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Preset_i(o,v);
}

void MasterUI::cb_S2_i(Fl_Menu_*, void*) {
  //
            microtonalui->Show();
}
void MasterUI::cb_S2(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_S2_i(o,v);
}

void MasterUI::cb_Load2_i(Fl_Menu_*, void*) {
  //
    string lastname = synth->lastItemSeen(XML_MICROTONAL);
    if (lastname == "")
        lastname = synth->getRuntime().userHome;

    const char *filename = fl_file_chooser("Load:", "({*.xsz})", lastname.c_str(), 0);
    if (filename != NULL)
        do_load_scale(string(filename));
}
void MasterUI::cb_Load2(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Load2_i(o,v);
}

void MasterUI::cb_Save2_i(Fl_Menu_*, void*) {
  //
                string lastname = synth->getLastfileAdded(XML_MICROTONAL);
                if (lastname == "")
                    lastname = synth->getRuntime().userHome;

                char *filename;
                filename = fl_file_chooser("Save:", "({*.xsz})", lastname.c_str(), 0);
                if (filename == NULL)
                    return;
                filename = fl_filename_setext(filename, ".xsz");
                if (isRegFile(string(filename)))
                    if (fl_choice("The file exists. \nOverwrite it?", NULL, "No", "Yes") < 2)
                        return;
                send_data(MAIN::control::saveNamedScale, 0, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main, UNUSED, UNUSED, TOPLEVEL::route::lowPriority, miscMsgPush(string(filename)));
}
void MasterUI::cb_Save2(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Save2_i(o,v);
}

void MasterUI::cb_RecentScale_i(Fl_Menu_*, void*) {
  //
            paramsui->Recent->position(masterwindow->x() + masterwindow->w() - paramsui->Recent->w(),masterwindow->y()+20);
paramsui->Show(XML_MICROTONAL);
}
void MasterUI::cb_RecentScale(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_RecentScale_i(o,v);
}

void MasterUI::cb_Clear1_i(Fl_Menu_*, void*) {
  #
            if (fl_choice("Set scales to the defaults?", NULL, "No", "Yes") > 1)
            {
                synth->microtonal.defaults();
                synth->setAllPartMaps();
                if (NULL != microtonalui)
                    delete microtonalui;
                microtonalui = new MicrotonalUI(&synth->microtonal, synth);
                send_data(SCALES::control::clearAll, 0, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::scales);
            };
}
void MasterUI::cb_Clear1(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Clear1_i(o,v);
}

void MasterUI::cb_loadState_i(Fl_Menu_*, void*) {
  // for Alessandro
            string lastname = synth->lastItemSeen(XML_STATE);
            if (lastname == "")
                lastname = synth->getRuntime().userHome;
            char *fle = fl_file_chooser("Load:", "({*.state})", lastname.c_str(), 0);
            if (fle)
            {
                setState(fle);
                RecentState->activate();
            }
            else
                refresh_master_ui(0x80 | (miscMsgPush(" ") << 8));
}
void MasterUI::cb_loadState(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_loadState_i(o,v);
}

void MasterUI::cb_saveState_i(Fl_Menu_*, void*) {
  // for Alessandro
            string lastname = synth->getLastfileAdded(XML_STATE);
            if (lastname == "")
                lastname = synth->getRuntime().userHome;
            char *fle = fl_file_chooser("Save:", "({*.state})",
                                            lastname.c_str(), 0);
            if (fle)
            {
                send_data(MAIN::control::saveNamedState, 0, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main, UNUSED, UNUSED, TOPLEVEL::route::lowPriority, miscMsgPush(string(fle)));
                RecentState->activate();
            };
}
void MasterUI::cb_saveState(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_saveState_i(o,v);
}

void MasterUI::cb_Save3_i(Fl_Menu_*, void*) {
  //
                string name = synth->getRuntime().defaultStateName;
                if (instance > 0)
                    name += ("-" + to_string(instance));
                send_data(MAIN::control::saveNamedState, 0, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main, UNUSED, UNUSED, TOPLEVEL::route::lowPriority, miscMsgPush(name + ".state"));
}
void MasterUI::cb_Save3(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Save3_i(o,v);
}

void MasterUI::cb_RecentState_i(Fl_Menu_*, void*) {
  //
            paramsui->Recent->position(masterwindow->x() + masterwindow->w() - paramsui->Recent->w(),masterwindow->y()+20);
            paramsui->Show(XML_STATE);
}
void MasterUI::cb_RecentState(Fl_Menu_* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_RecentState_i(o,v);
}

Fl_Menu_Item MasterUI::menu_mastermenu[] = {
 {"&Yoshimi", 0,  0, 0, 64, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&About...", 0,  (Fl_Callback*)MasterUI::cb_About, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&New instance...", 0,  (Fl_Callback*)MasterUI::cb_newinstanceid, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Settings...", 0,  (Fl_Callback*)MasterUI::cb_Settings, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&MIDI Learn...", 0,  (Fl_Callback*)MasterUI::cb_MIDI, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&View Manual", 0,  (Fl_Callback*)MasterUI::cb_View, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"E&xit", 0,  (Fl_Callback*)MasterUI::cb_E, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0},
 {"&Instruments", 0,  0, 0, 64, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"S&how Stored...", 0,  (Fl_Callback*)MasterUI::cb_S, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Load External...", 0,  (Fl_Callback*)MasterUI::cb_Load, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Save External...", 0,  (Fl_Callback*)MasterUI::cb_Save, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Recent Instruments...", 0,  (Fl_Callback*)MasterUI::cb_RecentInstruments, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Clear", 0,  (Fl_Callback*)MasterUI::cb_Clear, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0},
 {"&Patch Sets", 0,  0, 0, 64, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"S&how Patch Banks...", 0,  (Fl_Callback*)MasterUI::cb_S1, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Load External...", 0,  (Fl_Callback*)MasterUI::cb_Load1, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Save External...", 0,  (Fl_Callback*)MasterUI::cb_Save1, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Recent Sets...", 0,  (Fl_Callback*)MasterUI::cb_RecentParams, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0},
 {"Pat&hs", 0,  0, 0, 64, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Bank Root Dirs...", 0,  (Fl_Callback*)MasterUI::cb_Bank, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Preset Dirs...", 0,  (Fl_Callback*)MasterUI::cb_Preset, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0},
 {"&Scales", 0,  0, 0, 64, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"S&how Settings...", 0,  (Fl_Callback*)MasterUI::cb_S2, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Load...", 0,  (Fl_Callback*)MasterUI::cb_Load2, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Save...", 0,  (Fl_Callback*)MasterUI::cb_Save2, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Recent Scales...", 0,  (Fl_Callback*)MasterUI::cb_RecentScale, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Clear", 0,  (Fl_Callback*)MasterUI::cb_Clear1, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0},
 {"S&tate", 0,  0, 0, 64, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Load...", 0,  (Fl_Callback*)MasterUI::cb_loadState, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Save...", 0,  (Fl_Callback*)MasterUI::cb_saveState, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"Save as &Default", 0,  (Fl_Callback*)MasterUI::cb_Save3, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"&Recent States...", 0,  (Fl_Callback*)MasterUI::cb_RecentState, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0},
 {0,0,0,0,0,0,0,0,0}
};
Fl_Menu_Item* MasterUI::newinstanceid = MasterUI::menu_mastermenu + 2;
Fl_Menu_Item* MasterUI::Instruments = MasterUI::menu_mastermenu + 8;
Fl_Menu_Item* MasterUI::RecentInstruments = MasterUI::menu_mastermenu + 12;
Fl_Menu_Item* MasterUI::Parameters = MasterUI::menu_mastermenu + 15;
Fl_Menu_Item* MasterUI::Save = MasterUI::menu_mastermenu + 18;
Fl_Menu_Item* MasterUI::RecentParams = MasterUI::menu_mastermenu + 19;
Fl_Menu_Item* MasterUI::Scales = MasterUI::menu_mastermenu + 25;
Fl_Menu_Item* MasterUI::RecentScale = MasterUI::menu_mastermenu + 29;
Fl_Menu_Item* MasterUI::loadState = MasterUI::menu_mastermenu + 33;
Fl_Menu_Item* MasterUI::saveState = MasterUI::menu_mastermenu + 34;
Fl_Menu_Item* MasterUI::RecentState = MasterUI::menu_mastermenu + 36;

void MasterUI::cb_globalfinedetune_i(WidgetPDial* o, void*) {
  //
          send_data(MAIN::control::detune, o->value(), TOPLEVEL::type::Integer, TOPLEVEL::section::main, UNUSED, UNUSED, TOPLEVEL::route::lowPriority);
}
void MasterUI::cb_globalfinedetune(WidgetPDial* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_globalfinedetune_i(o,v);
}

void MasterUI::cb_Reset_i(Fl_Button*, void*) {
  //
          bool wasCtrl = (Fl::event_state(FL_CTRL) != 0);
          if (fl_choice("Set *ALL* dynamic values to their defaults?", NULL, "No", "Yes") > 1)
          {
              if(wasCtrl || (Fl::event_state(FL_CTRL) != 0))
                  send_data(MAIN::control::masterResetAndMlearn, 0, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main, UNUSED, UNUSED, TOPLEVEL::route::adjustAndLoopback);
              else
                  send_data(MAIN::control::masterReset, 0, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main, UNUSED, UNUSED, TOPLEVEL::route::adjustAndLoopback);};
}
void MasterUI::cb_Reset(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_Reset_i(o,v);
}

void MasterUI::cb_Stop_i(Fl_Button*, void*) {
  //
          send_data(MAIN::control::stopSound, 0, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main);
}
void MasterUI::cb_Stop(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_Stop_i(o,v);
}

void MasterUI::cb_mastervolumedial_i(WidgetPDial* o, void*) {
  //
          send_data(MAIN::control::volume, o->value(), 0, TOPLEVEL::section::main);
}
void MasterUI::cb_mastervolumedial(WidgetPDial* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_mastervolumedial_i(o,v);
}

void MasterUI::cb_Virtual_i(Fl_Button*, void*) {
  //
          virkeyboard->Show();
}
void MasterUI::cb_Virtual(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_Virtual_i(o,v);
}

void MasterUI::cb_mixerpanel_i(Fl_Button*, void*) {
  //
          updatepanel();
          panelwindow->show();
}
void MasterUI::cb_mixerpanel(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_mixerpanel_i(o,v);
}

void MasterUI::cb_Reports_i(Fl_Button*, void*) {
  //
          yoshiLog->Show();
}
void MasterUI::cb_Reports(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_Reports_i(o,v);
}

void MasterUI::cb_vectors_i(Fl_Button*, void*) {
  //
          vectorui->Show();
}
void MasterUI::cb_vectors(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_vectors_i(o,v);
}

void MasterUI::cb_sysinsgroup_i(Fl_Tabs* o, void*) {
  //
        if (o->value() == SystemEffectsGrp)
            showSysEfxUI();
        else if (o->value() == InsertionEffectsGrp)
            showInsEfxUI();
}
void MasterUI::cb_sysinsgroup(Fl_Tabs* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_sysinsgroup_i(o,v);
}

void MasterUI::cb_syseffnocounter_i(Fl_Spinner* o, void*) {
  //
            send_data(EFFECT::sysIns::effectNumber, o->value() - 1, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::systemEffects, o->value() - 1);
}
void MasterUI::cb_syseffnocounter(Fl_Spinner* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_syseffnocounter_i(o,v);
}

void MasterUI::cb_sysefftype_i(Fl_Choice* o, void*) {
  //
            send_data(EFFECT::sysIns::effectType, o->value(), TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::systemEffects, nsyseff);
}
void MasterUI::cb_sysefftype(Fl_Choice* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_sysefftype_i(o,v);
}

Fl_Menu_Item MasterUI::menu_sysefftype[] = {
 {"No Effect", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Reverb", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Echo", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Chorus", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Phaser", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"AlienWah", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Distortion", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"EQ", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"DynFilter", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void MasterUI::cb_Send_i(Fl_Button*, void*) {
  //
            syseffsendwindow->show();
}
void MasterUI::cb_Send(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_Send_i(o,v);
}

void MasterUI::cb_C_i(Fl_Button*, void*) {
  presetsui->copy(synth->sysefx[nsyseff]);
}
void MasterUI::cb_C(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_C_i(o,v);
}

void MasterUI::cb_P_i(Fl_Button*, void*) {
  //
            presetsui->paste(synth->sysefx[nsyseff], syseffectui);
}
void MasterUI::cb_P(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_P_i(o,v);
}

void MasterUI::cb_inseffnocounter_i(Fl_Spinner* o, void*) {
  //
            send_data(EFFECT::sysIns::effectNumber, o->value() - 1, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::insertEffects, o->value() - 1);
}
void MasterUI::cb_inseffnocounter(Fl_Spinner* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_inseffnocounter_i(o,v);
}

void MasterUI::cb_insefftype_i(Fl_Choice* o, void*) {
  //
            send_data(EFFECT::sysIns::effectType, o->value(), TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::insertEffects, ninseff);
}
void MasterUI::cb_insefftype(Fl_Choice* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_insefftype_i(o,v);
}

Fl_Menu_Item MasterUI::menu_insefftype[] = {
 {"No Effect", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Reverb", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Echo", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Chorus", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Phaser", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"AlienWah", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Distortion", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"EQ", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"DynFilter", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void MasterUI::cb_inseffpart_i(Fl_Choice* o, void*) {
  //
            send_data(EFFECT::sysIns::effectDestination, o->value() - 2, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::insertEffects, ninseff);
}
void MasterUI::cb_inseffpart(Fl_Choice* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_inseffpart_i(o,v);
}

void MasterUI::cb_C1_i(Fl_Button*, void*) {
  presetsui->copy(synth->insefx[ninseff]);
}
void MasterUI::cb_C1(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_C1_i(o,v);
}

void MasterUI::cb_P1_i(Fl_Button*, void*) {
  //
            presetsui->paste(synth->insefx[ninseff], inseffectui);
}
void MasterUI::cb_P1(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->parent()->user_data()))->cb_P1_i(o,v);
}

void MasterUI::cb_masterkeyshift_i(Fl_Spinner* o, void*) {
  //
        send_data(MAIN::control::keyShift, o->value(), TOPLEVEL::type::Integer, TOPLEVEL::section::main, UNUSED, UNUSED, TOPLEVEL::route::lowPriority);
}
void MasterUI::cb_masterkeyshift(Fl_Spinner* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_masterkeyshift_i(o,v);
}

void MasterUI::cb_npartcounter_i(Fl_Spinner* o, void*) {
  //
        int nval = o->value() - 1;
        activePart = nval;
        send_data(MAIN::control::partNumber, nval, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main);
}
void MasterUI::cb_npartcounter(Fl_Spinner* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_npartcounter_i(o,v);
}

void MasterUI::cb_maxparts_i(Fl_Spinner* o, void*) {
  //
        int tmp = o->value();
        if (tmp == 48)
        {
            if (partmax == 32)
                tmp = 64;
            else
                tmp = 32;
            o->value(tmp);
        }
        partmax = tmp;
        updatepart();
        updatepanel();
        setinspartlist();
        vectorui->checkParts(tmp);
        send_data(MAIN::control::availableParts, tmp, TOPLEVEL::type::Integer, TOPLEVEL::section::main);
}
void MasterUI::cb_maxparts(Fl_Spinner* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_maxparts_i(o,v);
}

void MasterUI::cb_more_i(Fl_Button*, void*) {
  //
                 Contributors->show();
                 aboutFirst->hide();
}
void MasterUI::cb_more(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->parent()->user_data()))->cb_more_i(o,v);
}

void MasterUI::cb_Close_i(Fl_Button*, void*) {
  //
        aboutwindow->hide();
}
void MasterUI::cb_Close(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Close_i(o,v);
}

void MasterUI::cb_Close1_i(Fl_Button*, void*) {
  //
        syseffsendwindow->hide();
}
void MasterUI::cb_Close1(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Close1_i(o,v);
}

void MasterUI::cb_Panelclose_i(Fl_Button*, void*) {
  //
        panelwindow->hide();
}
void MasterUI::cb_Panelclose(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Panelclose_i(o,v);
}

void MasterUI::cb_Change_i(Fl_Button*, void*) {
  //
        synth->getRuntime().single_row_panel = 1;
        updatepanel();
}
void MasterUI::cb_Change(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Change_i(o,v);
}

void MasterUI::cb_Change1_i(Fl_Button*, void*) {
  //
        synth->getRuntime().single_row_panel = 0;
        updatepanel();
}
void MasterUI::cb_Change1(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Change1_i(o,v);
}

void MasterUI::cb_Panelgroups_i(Fl_Choice* o, void*) {
  //
        panelgroup = o->value() * NUM_MIDI_CHANNELS;
        Panelsmallgroups->value(o->value());
        updatepanel();
}
void MasterUI::cb_Panelgroups(Fl_Choice* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Panelgroups_i(o,v);
}

Fl_Menu_Item MasterUI::menu_Panelgroups[] = {
 {"1 to 16", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"17 to 32", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"33 to 48", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"49 to 64", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};

void MasterUI::cb_Panelsmallgroups_i(Fl_Choice* o, void*) {
  //
        panelgroup = o->value() * NUM_MIDI_CHANNELS;
        Panelgroups->value(o->value());
        updatepanel();
}
void MasterUI::cb_Panelsmallgroups(Fl_Choice* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Panelsmallgroups_i(o,v);
}

Fl_Menu_Item MasterUI::menu_Panelsmallgroups[] = {
 {"1 to 16", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"17 to 32", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};

void MasterUI::cb_CSspinner_i(Fl_Spinner*, void*) {
  //
        CSpend->show();
}
void MasterUI::cb_CSspinner(Fl_Spinner* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_CSspinner_i(o,v);
}

void MasterUI::cb_CSpend_i(Fl_Button* o, void*) {
  //
        CS_CC = synth->getRuntime().channelSwitchCC;
        int candidate = CSspinner->value();
        if (candidate == CS_CC)
        {
            o->hide();
            return;
        }

        string name = synth->getRuntime().masterCCtest(candidate);
        if (!name.empty())
        {
            fl_alert("In use for %s",name.c_str());
            if (CS_CC < 128)
            {
                CSspinner->value(CS_CC);
                CSspinner->redraw();
            }

        }
        else
        {
            send_data(MAIN::control::soloCC, CSspinner->value(), TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main);
        };
}
void MasterUI::cb_CSpend(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_CSpend_i(o,v);
}

void MasterUI::cb_channelswitch_i(Fl_Choice* o, void*) {
  //
                send_data(MAIN::control::soloType, o->value(), TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main);
}
void MasterUI::cb_channelswitch(Fl_Choice* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_channelswitch_i(o,v);
}

Fl_Menu_Item MasterUI::menu_channelswitch[] = {
 {"Off", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"Row", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"Column", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"Loop", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {"TwoWay", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 0, 12, 0},
 {0,0,0,0,0,0,0,0,0}
};
Fl_Menu_Item* MasterUI::switchoff = MasterUI::menu_channelswitch + 0;
Fl_Menu_Item* MasterUI::switchrow = MasterUI::menu_channelswitch + 1;
Fl_Menu_Item* MasterUI::switchcolumn = MasterUI::menu_channelswitch + 2;
Fl_Menu_Item* MasterUI::switchloop = MasterUI::menu_channelswitch + 3;
Fl_Menu_Item* MasterUI::switchtwoway = MasterUI::menu_channelswitch + 4;

void MasterUI::cb_Close2_i(Fl_Button*, void*) {
  message->hide();
}
void MasterUI::cb_Close2(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_Close2_i(o,v);
}

void MasterUI::cb_cancel_i(Fl_Button* o, void*) {
  //
        send_data(MIDILEARN::control::cancelLearn, 0, 3, TOPLEVEL::section::midiLearn);
        o->hide();
}
void MasterUI::cb_cancel(Fl_Button* o, void* v) {
  ((MasterUI*)(o->parent()->user_data()))->cb_cancel_i(o,v);
}

MasterUI::MasterUI(SynthEngine *_synth) {
  //
        synth = _synth;
        presetsui = NULL;
        ninseff = 0;
        nsyseff = 0;
        npart = 0;
        panelgroup = 0;
        for (int i = 0; i < NUM_SYS_EFX; ++i)
        {
            for (int j = 0; j < NUM_SYS_EFX; ++j)
                syseffsend[i][j] = NULL;
        }
        microtonalui = NULL;
        bankui = NULL;
        virkeyboard = NULL;
        configui = NULL;
        presetsui = NULL;
        paramsui = NULL;
        activePart = 0;
        yoshiLog = NULL;
}

MasterUI::~MasterUI() {
  //
        saveWindowData();
        masterwindow->hide();
        aboutwindow->hide();
        delete aboutwindow;
        syseffsendwindow->hide();
        delete syseffsendwindow;
        panelwindow->hide();
        delete panelwindow;
        if (microtonalui)
        {
            microtonalui->Hide();
            delete microtonalui;
        }
        if (bankui)
        {
            bankui->Hide();
            delete bankui;
        }
        if (virkeyboard)
        {
            virkeyboard->Hide();
            delete virkeyboard;
        }
        if (configui)
        {
            configui->Hide();
            delete configui;
        }
        if (presetsui)
        {
            presetsui->Hide();
            delete presetsui;
        }
        if (paramsui)
        {
            paramsui->Hide();
            delete paramsui;
        }
        if (vectorui)
        {
            vectorui->Hide();
            delete vectorui;
        }
        if (midilearnui)
        {
            midilearnui->Hide();
            delete midilearnui;
        }
  
        if (yoshiLog)
        {
            yoshiLog->Hide();
            delete yoshiLog;
        }
        delete masterwindow;
}

void MasterUI::Init(const char *_label) {
  //
        instance = synth->getUniqueId();
  
        filename = synth->getRuntime().ConfigDir + "/" +synth->getRuntime().programCmd();
        if (instance > 0)
        {
            filename += ("-" + asString(instance));
        }
        partmax = synth->getRuntime().NumAvailableParts;
        filename += ".windows";
        microtonalui = new MicrotonalUI(&synth->microtonal, synth);
        bankui = new BankUI(synth);
        virkeyboard = new VirKeyboard(synth);
        configui = new ConfigUI(synth);
        presetsui = new PresetsUI(synth);
        paramsui = new ParametersUI(synth);
        vectorui = new VectorUI(synth, bankui, paramsui);
        midilearnui = new MidiLearnUI(synth);
        yoshiLog = new ConsoleUI();
        openedit = false;
  
        make_window();
        loadWindowData();
        if(synth->getIsLV2Plugin())
        {
            masterwindow->label(_label);
        }
        else
        {
            setMasterLabel(synth->getRuntime().paramsLoad);
        }
        masterwindow->show();
        // these don't have access to synth ->
        microtonalui->microtonaluiwindow->copy_label(synth->makeUniqueName("Scales").c_str());
        yoshiLog->logConsole->copy_label(synth->makeUniqueName("Console").c_str());
  
        if (panelO)
            mixerpanel->do_callback();
        if (instrumentsO)
            bankui->Show();
        if (banksO)
            bankui->bankuiwindow->show();
        if (presetsO)
            configui->presets->show();
        if (rootsO)
            bankui->rootuiwindow->show();
        if (scalesO)
            microtonalui->microtonaluiwindow->show();
        if (virkbdO)
            virkeyboard->Show();
        if (settingsO)
            configui->Show();
        if (yoshiLogO)
            yoshiLog->Show();
        if (vectorO)
            vectorui->Show();
        if (mlearnO)
            midilearnui->Show();
        if (controllersO)
            partui->ctlwindow->show();
        if (midictlO)
            partui->ctlmidi->show();
        if (inseditO)
            partui->instrumenteditwindow->show();
        //if (kitlistO)
            //partui->instrumentkitlist->show();
        //if (partfxO)
            //partui->partfx->show();
        if (synth->getRuntime().oldConfig)
        {
            string msg;
            msg = "Existing config older than V " + to_string(MIN_CONFIG_MAJOR) + "." + to_string(MIN_CONFIG_MINOR) + " \nCheck settings, save and restart.";
            message->position(masterwindow->x() + masterwindow->w() / 2 - message->w() / 2, masterwindow->y() + masterwindow->h() / 2 - message->h() / 2);
            words->copy_label(msg.c_str());
            message->show();}
}

Fl_Double_Window* MasterUI::make_window() {
  { masterwindow = new Fl_Double_Window(385, 465, "Yoshimi meets ZynAddSubFX");
    masterwindow->labelfont(13);
    masterwindow->labelsize(12);
    masterwindow->callback((Fl_Callback*)cb_masterwindow, (void*)(this));
    { Fl_Box* o = new Fl_Box(279, 28, 103, 85);
      o->box(FL_ENGRAVED_FRAME);
    } // Fl_Box* o
    { mastermenu = new ClearMenuBar(-7, 0, 395, 25);
      mastermenu->box(FL_UP_BOX);
      mastermenu->color(FL_BACKGROUND_COLOR);
      mastermenu->selection_color(FL_SELECTION_COLOR);
      mastermenu->labeltype(FL_NORMAL_LABEL);
      mastermenu->labelfont(0);
      mastermenu->labelsize(12);
      mastermenu->labelcolor(FL_FOREGROUND_COLOR);
      mastermenu->textsize(12);
      mastermenu->align(Fl_Align(FL_ALIGN_CENTER));
      mastermenu->when(FL_WHEN_RELEASE_ALWAYS);
      { Fl_Menu_Item* o = &menu_mastermenu[8];
        o = o; // suppress warning
        vector <string> listType = *synth->getHistory(XML_INSTRUMENT);
        if (listType.size() == 0) RecentInstruments->deactivate(); else RecentInstruments->activate();
      }
      { Fl_Menu_Item* o = &menu_mastermenu[15];
        o = o; // suppress warning
        vector <string> listType = *synth->getHistory(XML_PARAMETERS);
        if (listType.size() == 0) RecentParams->deactivate(); else RecentParams->activate();
      }
      { Fl_Menu_Item* o = &menu_mastermenu[25];
        o = o; // suppress warning
        vector <string> listType = *synth->getHistory(XML_MICROTONAL);
        if (listType.size() == 0) RecentScale->deactivate(); else RecentScale->activate();
      }
      { Fl_Menu_Item* o = &menu_mastermenu[32];
        o = o; // suppress warning
        vector <string> listType = *synth->getHistory(XML_STATE);
        if (listType.size() == 0) RecentState->deactivate(); else RecentState->activate();
      }
      mastermenu->menu(menu_mastermenu);
    } // ClearMenuBar* mastermenu
    { MasterControls = new Fl_Group(3, 24, 380, 91, "Master  ");
      MasterControls->labeltype(FL_NO_LABEL);
      MasterControls->labelsize(11);
      MasterControls->labelcolor((Fl_Color)96);
      MasterControls->align(Fl_Align(FL_ALIGN_BOTTOM_LEFT|FL_ALIGN_INSIDE));
      { WidgetPDial* o = globalfinedetune = new WidgetPDial(286, 32, 40, 40, "Detune");
        globalfinedetune->tooltip("Global Fine Detune");
        globalfinedetune->box(FL_ROUND_UP_BOX);
        globalfinedetune->color((Fl_Color)29);
        globalfinedetune->selection_color(FL_INACTIVE_COLOR);
        globalfinedetune->labeltype(FL_NORMAL_LABEL);
        globalfinedetune->labelfont(0);
        globalfinedetune->labelsize(10);
        globalfinedetune->labelcolor(FL_FOREGROUND_COLOR);
        globalfinedetune->maximum(127);
        globalfinedetune->step(1);
        globalfinedetune->value(64);
        globalfinedetune->callback((Fl_Callback*)cb_globalfinedetune);
        globalfinedetune->align(Fl_Align(FL_ALIGN_BOTTOM));
        globalfinedetune->when(FL_WHEN_CHANGED);
        o->setValueType(VC_GlobalFineDetune);
        o->value(synth->microtonal.Pglobalfinedetune);
      } // WidgetPDial* globalfinedetune
      { Fl_Button* o = new Fl_Button(7, 60, 70, 24, "Reset");
        o->tooltip("Clear all dynamic settings\n(+Ctrl includes MIDI-learn)");
        o->box(FL_PLASTIC_UP_BOX);
        o->color((Fl_Color)228);
        o->selection_color(FL_GRAY0);
        o->labelfont(1);
        o->labelsize(11);
        o->callback((Fl_Callback*)cb_Reset);
        o->align(Fl_Align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE));
      } // Fl_Button* o
      { Fl_Button* o = new Fl_Button(7, 30, 70, 24, "Stop!");
        o->tooltip("Cease all sound immediately!");
        o->box(FL_PLASTIC_UP_BOX);
        o->color(FL_RED);
        o->selection_color(FL_FOREGROUND_COLOR);
        o->labelfont(1);
        o->labelsize(11);
        o->callback((Fl_Callback*)cb_Stop);
        o->align(Fl_Align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE));
      } // Fl_Button* o
      { WidgetPDial* o = mastervolumedial = new WidgetPDial(335, 32, 40, 40, "Volume");
        mastervolumedial->tooltip("Master Volume");
        mastervolumedial->box(FL_ROUND_UP_BOX);
        mastervolumedial->color((Fl_Color)29);
        mastervolumedial->selection_color(FL_INACTIVE_COLOR);
        mastervolumedial->labeltype(FL_NORMAL_LABEL);
        mastervolumedial->labelfont(0);
        mastervolumedial->labelsize(10);
        mastervolumedial->labelcolor(FL_FOREGROUND_COLOR);
        mastervolumedial->maximum(127);
        mastervolumedial->step(1);
        mastervolumedial->callback((Fl_Callback*)cb_mastervolumedial);
        mastervolumedial->align(Fl_Align(FL_ALIGN_BOTTOM));
        mastervolumedial->when(FL_WHEN_CHANGED);
        o->setValueType(VC_MasterVolume);
        o->value(synth->Pvolume);
      } // WidgetPDial* mastervolumedial
      { Fl_Button* o = new Fl_Button(85, 60, 110, 24, "Virtual Keyboard");
        o->tooltip("Virtual Keyboard");
        o->box(FL_PLASTIC_UP_BOX);
        o->color((Fl_Color)228);
        o->labelsize(11);
        o->labelcolor(FL_GRAY0);
        o->callback((Fl_Callback*)cb_Virtual);
      } // Fl_Button* o
      { mixerpanel = new Fl_Button(85, 30, 110, 24, "Mixer Panel");
        mixerpanel->tooltip("Mixer Panel Window");
        mixerpanel->box(FL_PLASTIC_UP_BOX);
        mixerpanel->color((Fl_Color)228);
        mixerpanel->labelsize(11);
        mixerpanel->labelcolor(FL_GRAY0);
        mixerpanel->callback((Fl_Callback*)cb_mixerpanel);
      } // Fl_Button* mixerpanel
      { Fl_Button* o = Reports = new Fl_Button(203, 60, 70, 24, "Reports");
        Reports->tooltip("Message Log");
        Reports->box(FL_PLASTIC_UP_BOX);
        Reports->color((Fl_Color)228);
        Reports->labelsize(11);
        Reports->callback((Fl_Callback*)cb_Reports);
        if (synth->getRuntime().toConsole == false){o->deactivate();yoshiLog->Hide();}
      } // Fl_Button* Reports
      { vectors = new Fl_Button(203, 30, 70, 24, "Vectors");
        vectors->tooltip("Vector Setup Window");
        vectors->box(FL_PLASTIC_UP_BOX);
        vectors->color((Fl_Color)228);
        vectors->labelsize(11);
        vectors->labelcolor(FL_GRAY0);
        vectors->callback((Fl_Callback*)cb_vectors);
      } // Fl_Button* vectors
      MasterControls->end();
    } // Fl_Group* MasterControls
    { sysinsgroup = new Fl_Tabs(3, 88, 379, 68, "System/Insert");
      sysinsgroup->box(FL_PLASTIC_UP_BOX);
      sysinsgroup->color((Fl_Color)44);
      sysinsgroup->selection_color((Fl_Color)221);
      sysinsgroup->labeltype(FL_NO_LABEL);
      sysinsgroup->labelsize(12);
      sysinsgroup->callback((Fl_Callback*)cb_sysinsgroup);
      sysinsgroup->align(Fl_Align(FL_ALIGN_TOP_LEFT));
      { SystemEffectsGrp = new Fl_Group(3, 116, 379, 40, "  System Effects  ");
        SystemEffectsGrp->color((Fl_Color)221);
        SystemEffectsGrp->selection_color((Fl_Color)31);
        SystemEffectsGrp->labelfont(1);
        SystemEffectsGrp->labelsize(12);
        SystemEffectsGrp->align(Fl_Align(FL_ALIGN_LEFT));
        { Fl_Spinner* o = syseffnocounter = new Fl_Spinner(40, 126, 36, 20, "Effect");
          syseffnocounter->labeltype(FL_NO_LABEL);
          syseffnocounter->labelsize(11);
          syseffnocounter->maximum(4);
          syseffnocounter->textfont(1);
          syseffnocounter->textsize(11);
          syseffnocounter->callback((Fl_Callback*)cb_syseffnocounter);
          syseffnocounter->align(Fl_Align(FL_ALIGN_CENTER));
          o->range(1, NUM_SYS_EFX);
          o->value(nsyseff + 1);
        } // Fl_Spinner* syseffnocounter
        { Fl_Choice* o = sysefftype = new Fl_Choice(120, 126, 96, 20, "Type");
          sysefftype->down_box(FL_BORDER_BOX);
          sysefftype->labeltype(FL_NO_LABEL);
          sysefftype->labelsize(10);
          sysefftype->callback((Fl_Callback*)cb_sysefftype);
          sysefftype->align(Fl_Align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE));
          sysefftype->menu(menu_sysefftype);
          o->value(synth->sysefx[nsyseff]->geteffect());
        } // Fl_Choice* sysefftype
        { Fl_Button* o = new Fl_Button(256, 126, 62, 20, "Send to");
          o->box(FL_THIN_UP_BOX);
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor((Fl_Color)97);
          o->callback((Fl_Callback*)cb_Send);
        } // Fl_Button* o
        { Fl_Button* o = new Fl_Button(350, 122, 25, 14, "C");
          o->box(FL_THIN_UP_BOX);
          o->color((Fl_Color)179);
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor(FL_BACKGROUND2_COLOR);
          o->callback((Fl_Callback*)cb_C);
        } // Fl_Button* o
        { Fl_Button* o = new Fl_Button(350, 137, 25, 14, "P");
          o->box(FL_THIN_UP_BOX);
          o->color((Fl_Color)179);
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor(FL_BACKGROUND2_COLOR);
          o->callback((Fl_Callback*)cb_P);
        } // Fl_Button* o
        SystemEffectsGrp->end();
      } // Fl_Group* SystemEffectsGrp
      { InsertionEffectsGrp = new Fl_Group(3, 116, 379, 40, " Insertion Effects ");
        InsertionEffectsGrp->color((Fl_Color)221);
        InsertionEffectsGrp->selection_color((Fl_Color)31);
        InsertionEffectsGrp->labelfont(1);
        InsertionEffectsGrp->labelsize(12);
        InsertionEffectsGrp->labelcolor((Fl_Color)33);
        InsertionEffectsGrp->align(Fl_Align(FL_ALIGN_LEFT));
        InsertionEffectsGrp->hide();
        { Fl_Spinner* o = inseffnocounter = new Fl_Spinner(40, 126, 36, 20, "Effect");
          inseffnocounter->labeltype(FL_NO_LABEL);
          inseffnocounter->labelsize(11);
          inseffnocounter->maximum(8);
          inseffnocounter->textfont(1);
          inseffnocounter->textsize(11);
          inseffnocounter->callback((Fl_Callback*)cb_inseffnocounter);
          inseffnocounter->align(Fl_Align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE));
          o->range(1, NUM_INS_EFX);
          o->value(ninseff + 1);
        } // Fl_Spinner* inseffnocounter
        { Fl_Choice* o = insefftype = new Fl_Choice(120, 126, 96, 20, "Type");
          insefftype->down_box(FL_BORDER_BOX);
          insefftype->labeltype(FL_NO_LABEL);
          insefftype->labelsize(11);
          insefftype->textsize(12);
          insefftype->callback((Fl_Callback*)cb_insefftype);
          insefftype->align(Fl_Align(FL_ALIGN_CENTER));
          insefftype->menu(menu_insefftype);
          o->value(synth->insefx[ninseff]->geteffect());
          if (synth->Pinsparts[ninseff]== -1) o->deactivate();
        } // Fl_Choice* insefftype
        { Fl_Choice* o = inseffpart = new Fl_Choice(242, 126, 96, 20, "To ");
          inseffpart->down_box(FL_BORDER_BOX);
          inseffpart->labelfont(1);
          inseffpart->labelsize(10);
          inseffpart->textfont(1);
          inseffpart->textsize(11);
          inseffpart->callback((Fl_Callback*)cb_inseffpart);
          setinspartlist();
          o->value(synth->Pinsparts[ninseff]+2);
        } // Fl_Choice* inseffpart
        { Fl_Button* o = new Fl_Button(350, 122, 25, 14, "C");
          o->box(FL_THIN_UP_BOX);
          o->color((Fl_Color)179);
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor(FL_BACKGROUND2_COLOR);
          o->callback((Fl_Callback*)cb_C1);
        } // Fl_Button* o
        { Fl_Button* o = new Fl_Button(350, 137, 25, 14, "P");
          o->box(FL_THIN_UP_BOX);
          o->color((Fl_Color)179);
          o->labelfont(1);
          o->labelsize(11);
          o->labelcolor(FL_BACKGROUND2_COLOR);
          o->callback((Fl_Callback*)cb_P1);
        } // Fl_Button* o
        InsertionEffectsGrp->end();
      } // Fl_Group* InsertionEffectsGrp
      sysinsgroup->end();
    } // Fl_Tabs* sysinsgroup
    { Fl_Group* o = syseffectuigroup = new Fl_Group(3, 158, 384, 95);
      syseffectuigroup->box(FL_FLAT_BOX);
      syseffectuigroup->color((Fl_Color)48);
      syseffectuigroup->labeltype(FL_NO_LABEL);
      { EffUI* o = syseffectui = new EffUI(3, 158, 384, 95);
        syseffectui->box(FL_NO_BOX);
        syseffectui->color(FL_BACKGROUND_COLOR);
        syseffectui->selection_color(FL_BACKGROUND_COLOR);
        syseffectui->labeltype(FL_NO_LABEL);
        syseffectui->labelfont(0);
        syseffectui->labelsize(14);
        syseffectui->labelcolor(FL_FOREGROUND_COLOR);
        syseffectui->align(Fl_Align(FL_ALIGN_TOP));
        syseffectui->when(FL_WHEN_RELEASE);
        o->init(synth->sysefx[nsyseff], TOPLEVEL::section::systemEffects, nsyseff);o->activate();o->show();
        syseffectui->end();
      } // EffUI* syseffectui
      o->show();
      syseffectuigroup->end();
    } // Fl_Group* syseffectuigroup
    { Fl_Group* o = inseffectuigroup = new Fl_Group(3, 158, 384, 95);
      inseffectuigroup->box(FL_FLAT_BOX);
      inseffectuigroup->color((Fl_Color)48);
      { EffUI* o = inseffectui = new EffUI(3, 158, 379, 95);
        inseffectui->box(FL_NO_BOX);
        inseffectui->color(FL_LIGHT2);
        inseffectui->selection_color(FL_BACKGROUND_COLOR);
        inseffectui->labeltype(FL_NORMAL_LABEL);
        inseffectui->labelfont(0);
        inseffectui->labelsize(14);
        inseffectui->labelcolor(FL_FOREGROUND_COLOR);
        inseffectui->align(Fl_Align(FL_ALIGN_TOP));
        inseffectui->when(FL_WHEN_RELEASE);
        o->init(synth->insefx[ninseff], TOPLEVEL::section::insertEffects, ninseff);o->hide();
        if (synth->Pinsparts[ninseff]== -1) o->deactivate();
        inseffectui->end();
      } // EffUI* inseffectui
      o->hide();
      inseffectuigroup->end();
    } // Fl_Group* inseffectuigroup
    { partuigroup = new Fl_Group(3, 255, 380, 170);
      partuigroup->box(FL_ENGRAVED_FRAME);
      { PartUI* o = partui = new PartUI(3, 255, 379, 170);
        partui->box(FL_NO_BOX);
        partui->color(FL_DARK1);
        partui->selection_color(FL_BACKGROUND_COLOR);
        partui->labeltype(FL_NORMAL_LABEL);
        partui->labelfont(0);
        partui->labelsize(14);
        partui->labelcolor(FL_FOREGROUND_COLOR);
        partui->align(Fl_Align(FL_ALIGN_TOP));
        partui->when(FL_WHEN_RELEASE);
        o->init(synth->part[0],0,bankui);
        o->show();
        partui->end();
      } // PartUI* partui
      partuigroup->end();
    } // Fl_Group* partuigroup
    { Fl_Group* o = new Fl_Group(3, 427, 379, 36);
      o->box(FL_DOWN_BOX);
      o->color((Fl_Color)43);
      o->labelsize(12);
      { VUMeter* o = vumeter = new VUMeter(3, 429, 379, 34, "VU-Meter");
        vumeter->box(FL_NO_BOX);
        vumeter->color((Fl_Color)48);
        vumeter->selection_color((Fl_Color)75);
        vumeter->labeltype(FL_NORMAL_LABEL);
        vumeter->labelfont(0);
        vumeter->labelsize(14);
        vumeter->labelcolor(FL_FOREGROUND_COLOR);
        vumeter->align(Fl_Align(FL_ALIGN_CENTER));
        vumeter->when(FL_WHEN_RELEASE);
        o->init(-1, synth);
      } // VUMeter* vumeter
      o->end();
    } // Fl_Group* o
    { Fl_Spinner* o = masterkeyshift = new Fl_Spinner(336, 88, 38, 20, "Key Shift");
      masterkeyshift->tooltip("Shift pitch +/- N semitones");
      masterkeyshift->labelsize(10);
      masterkeyshift->minimum(-36);
      masterkeyshift->maximum(36);
      masterkeyshift->textsize(10);
      masterkeyshift->callback((Fl_Callback*)cb_masterkeyshift);
      o->range(MIN_KEY_SHIFT, MAX_KEY_SHIFT);o->step(1.0);
      o->value(synth->Pkeyshift - 64);
    } // Fl_Spinner* masterkeyshift
    { Fl_Spinner* o = npartcounter = new Fl_Spinner(36, 264, 40, 20, "Part");
      npartcounter->labelsize(11);
      npartcounter->minimum(0);
      npartcounter->maximum(127);
      npartcounter->textsize(11);
      npartcounter->callback((Fl_Callback*)cb_npartcounter);
      npartcounter->when(FL_WHEN_RELEASE_ALWAYS);
      o->range(1.0, partmax);
      o->value(synth->getRuntime().currentPart + 1);
      bankui->init(o);
    } // Fl_Spinner* npartcounter
    { Fl_Spinner* o = maxparts = new Fl_Spinner(93, 264, 40, 20, "of");
      maxparts->tooltip("Set the number of available parts");
      maxparts->labelsize(11);
      maxparts->minimum(16);
      maxparts->maximum(64);
      maxparts->step(16);
      maxparts->value(16);
      maxparts->textsize(11);
      maxparts->callback((Fl_Callback*)cb_maxparts);
      o->value(partmax);
    } // Fl_Spinner* maxparts
    masterwindow->xclass("Yoshimi");
    masterwindow->end();
  } // Fl_Double_Window* masterwindow
  { aboutwindow = new Fl_Double_Window(365, 290, "About Yoshimi");
    aboutwindow->color(FL_LIGHT3);
    aboutwindow->labelfont(13);
    aboutwindow->labelsize(13);
    aboutwindow->user_data((void*)(this));
    aboutwindow->when(FL_WHEN_NEVER);
    { aboutFirst = new Fl_Group(0, 0, 365, 290);
      aboutFirst->hide();
      { Fl_Box* o = new Fl_Box(10, 15, 345, 70, "Yoshimi\nmeets\nZynAddSubFX");
        o->labelfont(9);
        o->labelsize(18);
        o->labelcolor(FL_BLUE);
        o->align(Fl_Align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE));
        o->when(FL_WHEN_NEVER);
      } // Fl_Box* o
      { Fl_Box* o = new Fl_Box(25, 90, 315, 91, "Copyright 2002-2009, Nasca O. Paul and others\nCopyright 2009-2011, Alan Calv\
ert\nCopyright 2012-2013, Jeremy Jongepier and others\nCopyright 2014-2018, Wi\
ll Godfrey and others\nLV2 plugin Copyright 2014, Andrew Deryabin\nSplash Imag\
e Copyright 2017, Jesper Lloyd");
        o->color((Fl_Color)51);
        o->selection_color((Fl_Color)30);
        o->labelfont(13);
        o->labelsize(11);
      } // Fl_Box* o
      { Fl_Box* o = new Fl_Box(10, 190, 340, 53, "This is free software, and comes with ABSOLUTELY NO\nWARRANTY; you may redist\
ribute it and/or modify it\nunder the terms of GPL version 2, or (at your opti\
on)\nany later version.");
        o->labelsize(11);
      } // Fl_Box* o
      { Fl_Box* o = new Fl_Box(61, 254, 240, 20, " version");
        o->labelfont(1);
        o->labelsize(12);
        o->labelcolor((Fl_Color)145);
        //
            o->copy_label((string("Yoshimi version ")
                           + string( YOSHIMI_VERSION )).c_str());
      } // Fl_Box* o
      { Fl_Button* o = new Fl_Button(15, 253, 43, 22, "more");
        o->tooltip("Yoshimi\'s little band of helpers");
        o->labelsize(11);
        o->callback((Fl_Callback*)cb_more);
      } // Fl_Button* o
      aboutFirst->end();
    } // Fl_Group* aboutFirst
    { Contributors = new Fl_Group(5, 5, 355, 280);
      Contributors->box(FL_FLAT_BOX);
      Contributors->color(FL_BACKGROUND2_COLOR);
      Contributors->labelcolor(FL_BACKGROUND2_COLOR);
      Contributors->hide();
      { Fl_Box* o = new Fl_Box(12, 8, 340, 57, "Some people who have helped Yoshimi\n in various ways since\nAlan Calvert sta\
rted the project");
        o->color(FL_BACKGROUND2_COLOR);
        o->labelfont(9);
        o->labelsize(15);
        o->labelcolor((Fl_Color)4);
      } // Fl_Box* o
      { Fl_Box* o = new Fl_Box(25, 70, 155, 200, "Chris Ahlstrom\nKristian Amlie\nJonathan Brickman\nJeanette Claassen\nRob Cou\
to\nAndrew Deryabin\nJ\303\266rn Eichler\nCsaba Erdei\nJames Fraser\nWill Godf\
rey\nAlexander Hirsch\nJeremy Jongepier\nTobias Kortkamp\nTito Latini");
        o->labelsize(12);
      } // Fl_Box* o
      { Fl_Box* o = new Fl_Box(194, 70, 155, 200, "Jesper Lloyd\nLars Luthman\nHolger Marzen\nLieven Moors\nHarry Nakos\nIurie N\
istor\nStephen Parry\nLorenzo Sutton\nHermann Vo\303\237""eler\nNikita Zlobin\
\n\n\n\n ");
        o->labelsize(12);
      } // Fl_Box* o
      Contributors->end();
    } // Fl_Group* Contributors
    { Fl_Button* o = new Fl_Button(305, 253, 43, 22, "Close");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(11);
      o->callback((Fl_Callback*)cb_Close);
    } // Fl_Button* o
    aboutwindow->end();
  } // Fl_Double_Window* aboutwindow
  { syseffsendwindow = new Fl_Double_Window(120, 250, "Sys Send");
    syseffsendwindow->labelfont(13);
    syseffsendwindow->labelsize(13);
    syseffsendwindow->user_data((void*)(this));
    { Fl_Scroll* o = new Fl_Scroll(10, 45, 107, 170);
      o->box(FL_FLAT_BOX);
      //
            for (int neff1 = 0; neff1 < NUM_SYS_EFX; neff1++)
                for (int neff2 = neff1 + 1; neff2 < NUM_SYS_EFX; neff2++)
      {
                syseffsend[neff1][neff2] =
                    new SysEffSend(o->x()+(neff2 - 1) * 35, o->y() + 20 + neff1 * 52, 30, 30);
                syseffsend[neff1][neff2]->label("aaa");
                syseffsend[neff1][neff2]->init(neff1, neff2, synth);
                syseffsend[neff1][neff2]->setValueType(VC_FXSysSend);
            }
      o->end();
    } // Fl_Scroll* o
    { Fl_Button* o = new Fl_Button(20, 220, 80, 25, "Close");
      o->box(FL_THIN_UP_BOX);
      o->callback((Fl_Callback*)cb_Close1);
    } // Fl_Button* o
    { Fl_Box* o = new Fl_Box(5, 5, 110, 35, "Send system effect\'s output to other system effects");
      o->labelsize(10);
      o->align(Fl_Align(192));
    } // Fl_Box* o
    syseffsendwindow->end();
  } // Fl_Double_Window* syseffsendwindow
  { Fl_Double_Window* o = panelwindow = new Fl_Double_Window(550, 670, "Yoshimi Mixer Panel");
    panelwindow->labelfont(13);
    panelwindow->labelsize(13);
    panelwindow->user_data((void*)(this));
    { Fl_Pack* o = Panelpack1 = new Fl_Pack(8, 10, 533, 286);
      Panelpack1->type(1);
      //
          for (int i = 0; i < 8; i++)
          {
              panellistitem[i] = new Panellistitem(0, 0, 70, 260, "");
              panellistitem[i]->init(i, bankui, synth);
          }
      o->spacing(-3);
      Panelpack1->end();
    } // Fl_Pack* Panelpack1
    { Fl_Pack* o = Panelpack2 = new Fl_Pack(8, 325, 533, 286);
      Panelpack2->type(1);
      //
            for (int i = 8; i < 16; i++)
            {
                 panellistitem[i] = new Panellistitem(0, 0, 70, 260, "");
                 panellistitem[i]->init(i, bankui, synth);
            }
      o->spacing(-3);
      Panelpack2->end();
    } // Fl_Pack* Panelpack2
    { Panelclose = new Fl_Button(482, 646, 55, 25, "Close");
      Panelclose->box(FL_THIN_UP_BOX);
      Panelclose->labelsize(13);
      Panelclose->callback((Fl_Callback*)cb_Panelclose);
    } // Fl_Button* Panelclose
    { Fl_Button* o = new Fl_Button(354, 640, 118, 25, "Change to 1 x 16");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(13);
      o->callback((Fl_Callback*)cb_Change);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(821, 319, 116, 25, "Change to 2 x 8");
      o->box(FL_THIN_UP_BOX);
      o->labelsize(13);
      o->callback((Fl_Callback*)cb_Change1);
    } // Fl_Button* o
    { Panelgroups = new Fl_Choice(12, 650, 86, 18, "Part Group");
      Panelgroups->down_box(FL_BORDER_BOX);
      Panelgroups->labelsize(12);
      Panelgroups->textsize(12);
      Panelgroups->callback((Fl_Callback*)cb_Panelgroups);
      Panelgroups->align(Fl_Align(FL_ALIGN_TOP));
      Panelgroups->menu(menu_Panelgroups);
    } // Fl_Choice* Panelgroups
    { Panelsmallgroups = new Fl_Choice(12, 650, 86, 18, "Part Group");
      Panelsmallgroups->down_box(FL_BORDER_BOX);
      Panelsmallgroups->labelsize(12);
      Panelsmallgroups->textsize(12);
      Panelsmallgroups->callback((Fl_Callback*)cb_Panelsmallgroups);
      Panelsmallgroups->align(Fl_Align(FL_ALIGN_TOP));
      Panelsmallgroups->menu(menu_Panelsmallgroups);
    } // Fl_Choice* Panelsmallgroups
    { Fl_Spinner* o = CSspinner = new Fl_Spinner(216, 650, 50, 18, "CC");
      CSspinner->labelsize(12);
      CSspinner->minimum(0);
      CSspinner->maximum(127);
      CSspinner->value(115);
      CSspinner->textsize(12);
      CSspinner->callback((Fl_Callback*)cb_CSspinner);
      CSspinner->align(Fl_Align(FL_ALIGN_TOP));
      CS_CC = synth->getRuntime().channelSwitchCC;
      if (CS_CC < 128) o->value(CS_CC); else o->value(115);
    } // Fl_Spinner* CSspinner
    { CSpend = new Fl_Button(276, 651, 70, 20, "Pending");
      CSpend->tooltip("Click to set");
      CSpend->box(FL_PLASTIC_UP_BOX);
      CSpend->color((Fl_Color)90);
      CSpend->labelsize(12);
      CSpend->callback((Fl_Callback*)cb_CSpend);
      CSpend->hide();
    } // Fl_Button* CSpend
    { Fl_Choice* o = channelswitch = new Fl_Choice(125, 650, 74, 18, "Solo");
      channelswitch->tooltip("Assign groups of parts to Ch 1, singly enabled by MIDI");
      channelswitch->down_box(FL_BORDER_BOX);
      channelswitch->labelsize(12);
      channelswitch->textsize(12);
      channelswitch->callback((Fl_Callback*)cb_channelswitch);
      channelswitch->align(Fl_Align(FL_ALIGN_TOP));
      channelswitch->menu(menu_channelswitch);
      o->value(synth->getRuntime().channelSwitchType);
      if (o->value() == 0) CSspinner->hide(); else CSspinner->show();
      CS_CC = o->value();
    } // Fl_Choice* channelswitch
    //if (synth->getRuntime().single_row_panel) ;
    o->copy_label(synth->makeUniqueName("Mixer Panel").c_str());
    panelwindow->end();
  } // Fl_Double_Window* panelwindow
  { Fl_Double_Window* o = message = new Fl_Double_Window(290, 85, "Yoshimi");
    message->labelsize(12);
    message->user_data((void*)(this));
    { words = new Fl_Box(5, 9, 280, 45, "?");
      words->color((Fl_Color)55);
      words->selection_color((Fl_Color)55);
      words->labelfont(1);
      words->labelsize(12);
      words->align(Fl_Align(133|FL_ALIGN_INSIDE));
    } // Fl_Box* words
    { Fl_Button* o = new Fl_Button(211, 60, 70, 20, "Close");
      o->callback((Fl_Callback*)cb_Close2);
    } // Fl_Button* o
    { cancel = new Fl_Button(130, 60, 70, 20, "Cancel");
      cancel->callback((Fl_Callback*)cb_cancel);
      cancel->hide();
    } // Fl_Button* cancel
    o->copy_label(synth->makeUniqueName("").c_str());
    message->end();
  } // Fl_Double_Window* message
  return message;
}

void MasterUI::send_data(int control, float value, int type, int part , int engine , int insert , int parameter , int par2 ) {
  //
          type |= TOPLEVEL::type::Write;
          if (control <= MAIN::control::soloType)
              type |= Fl::event_button();
          if (parameter == 0)
          {
              collect_data(synth, 0, type, control, part, UNUSED, UNUSED, UNUSED, UNUSED, par2);
              return;
          }
  
          collect_data(synth, value, type, control, part, UNUSED, engine, insert, parameter, par2);
}

void MasterUI::returns_update(CommandBlock *getData) {
  //
      float value = getData->data.value;
      bool wasFromHere = getData->data.type & TOPLEVEL::source::GUI;
      unsigned char control = getData->data.control;
      unsigned char newpart = getData->data.part;
      unsigned char kititem = getData->data.kit;
      unsigned char engine = getData->data.engine;
      unsigned char insert = getData->data.insert;
      unsigned char parameter = getData->data.parameter;
      unsigned char par2 = getData->data.par2;
      int value_int = lrint(value);
      int chan = kititem & 0x3f;
      bool isSingle = kititem >= 0x40;
      int mask = NUM_MIDI_CHANNELS - 1;
  
      if (newpart == TOPLEVEL::section::midiIn)
      {
          if (engine == MIDI::CC::volume && partui->part->ctl->volume.receive == 0)
              return; // disabled
          if (engine == MIDI::CC::expression && partui->part->ctl->expression.receive == 0)
              return; // disabled
  
          float vol = (value * synth->part[npart]->ctl->volume.data) / 127;
          if (control == MIDI::control::controller)
          { // panel entries only
              for (int i = 0; i < NUM_MIDI_CHANNELS; ++i)
              {
                  if(true)//panellistitem[i]->partenabled->value() != 0)
                  {
                      if((isSingle && i == (chan & mask)
                                   && panellistitem[i]->partrcv->value() == (chan & mask)
                                   && (chan / NUM_MIDI_CHANNELS) == (panelgroup / NUM_MIDI_CHANNELS))
                           || (!isSingle && panellistitem[i]->partrcv->value() == (chan & mask)))
                      {
                          if (engine == MIDI::CC::volume)
                              panellistitem[i]->partvolume->value(vol);
                          else if (engine == MIDI::CC::panning)
                              panellistitem[i]->partpanning->value(value);
                      }
                  }
              }
          }
  
          bool isForUs = (isSingle && chan == npart)
               || (!isSingle &&  (partui->midich->value() == (chan & mask) + 1));// && partui->partGroupEnable->value() != 0);
          switch(control)
          {
              case MIDI::control::noteOn:
              case MIDI::control::noteOff:
                  break;
              case MIDI::control::controller:
                  //cout << " Value " << value_int << "  kit " << int(kititem) << "  npart " << int(npart) << endl;
                  if(engine <= 119 && engine == synth->getRuntime().channelSwitchCC)
                  { // it's a valid channel switch
                      int newch = partui->midich->value() - 1;
                      switch (synth->getRuntime().channelSwitchType)
                      {
                          case 1: // row
                              if (npart < NUM_MIDI_CHANNELS)
                              {
                                  if (npart != value_int)
                                      newch = NUM_MIDI_CHANNELS;
                                  else
                                      newch = 0;
                              }
                              break;
  
                          case 2: // column
                              if(value_int == npart)
                                  newch = (value_int & mask);
                              else if((value_int & mask) == (npart & mask))
                                  newch = (value_int & mask) + NUM_MIDI_CHANNELS;
                              break;
  
                          case 3: // loop
                          case 4: // twoway
                              if (npart < NUM_MIDI_CHANNELS)
                              {
                                  if (npart == synth->getRuntime().channelSwitchValue)
                                      newch = 0;
                                  else if (value_int > 0)
                                      newch = NUM_MIDI_CHANNELS;
                              }
                              break;
                      }
                      partui->midich->value(newch + 1);
  
                      if (newch < NUM_MIDI_CHANNELS)
                          partui->midich->textcolor(FL_BLACK);
                      else
                          partui->midich->textcolor(FL_WHITE);
                      updatepanel();
                  }
                  else if (isForUs)
                  {
                      switch(engine)
                      {
                          case MIDI::CC::modulation:
                              partui->modulation->value(value);
                              break;
                          case MIDI::CC::volume:
                              partui->partvol->value(vol);
                              break;
                          case MIDI::CC::panning:
                              partui->partpan->value(value);
                              break;
                          case MIDI::CC::expression:
                              partui->expression->value(value);
                              break;
                          case MIDI::CC::legato:
                          {
                              int mode = synth->ReadPartKeyMode(npart);
                              partui->legatoMode->labelcolor(FL_BLACK);
                              if (mode > 1)
                              {
                                  partui->keymode->value(2);
                                  if (partui->drumMode->value() != 0)
                                      partui->legatoMode->labelcolor(FL_RED);
                              }
                              else
                                  partui->keymode->value(mode);
                              //partui->keymode->damage(1);
                              break;
                          }
                          case MIDI::CC::filterQ:
                              partui->filterq->value(value);
                              break;
                          case MIDI::CC::filterCutoff:
                              partui->filtercutoff->value(value);
                              break;
                          case MIDI::CC::bandwidth:
                              partui->masterbandwidth->value(value);
                              break;
                      }
                  }
                  break;
              case MIDI::control::programChange:
                  if (insert != UNUSED)
                  {
                      ;// updateBankRootDirs() // apparently not needed!
                  }
                  if (engine != UNUSED)
                      bankui->readbankcfg();
                  if (insert != UNUSED || engine != UNUSED)
                      bankui->rescan_for_banks(false);
                  if (value_int != UNUSED || par2 != UNUSED)
                  {
                      updatepartprogram(kititem);
                      RecentInstruments->activate();
                  }
          }
          return;
      }
      if (newpart == TOPLEVEL::section::systemEffects)
      {
          if (insert == TOPLEVEL::insert::systemEffectSend)
          {
              if (true)//!wasFromHere) // TODO to sort this properly
                  syseffsend[engine][control]->value(value);
          }
          else
          {
              if (control == EFFECT::sysIns::effectNumber)
              {
                  syseffnocounter->value(engine + 1);
                  nsyseff = engine;
                  sysefftype->value(synth->sysefx[nsyseff]->geteffect());
                  syseffectui->refresh(synth->sysefx[nsyseff], TOPLEVEL::section::systemEffects, nsyseff);
              }
              else if (control == EFFECT::sysIns::effectType)
              {
                  syseffnocounter->value(engine + 1);
                  nsyseff = engine;
                  sysefftype->value(value_int);
                  syseffectui->refresh(synth->sysefx[nsyseff], TOPLEVEL::section::systemEffects, nsyseff);
                  showSysEfxUI();
              }
          }
          return;
      }
      else if (newpart == TOPLEVEL::section::insertEffects)
      {
          if (control == EFFECT::sysIns::effectNumber)
          {
              ninseff = engine;
              setInsEff(ninseff);
              showInsEfxUI();
          }
          else if (control == EFFECT::sysIns::effectType)
          {
              inseffnocounter->value(engine + 1);
              ninseff = engine;
              insefftype->value(value_int);
              setInsEff(ninseff);
              showInsEfxUI();
          }
          else if (control == EFFECT::sysIns::effectDestination)
          {
              inseffpart->value(value_int + 2);
              if (value_int == -1)
                  insefftype->deactivate();
              else
              {
                  insefftype->activate();
                  setInsEff(ninseff);
                  showInsEfxUI();
              }
          }
          return;
      }
      string name;
      switch(control)
      {
          case MAIN::control::volume:
              mastervolumedial->value(value);
              break;
  
          case MAIN::control::partNumber:
              partuigroup->remove(partui);
              delete partui;
              partui = new PartUI(0, 0, 765, 525);
              partuigroup->add(partui);
              partui->init(synth->part[value_int], value_int, bankui);
              partui->redraw();
              partui->npart = value_int;
              activePart = value_int;
              npartcounter->value(value_int + 1);
              npartcounter->redraw();
              updatepanel();
              if (openedit)
              {
                  partui->instrumenteditwindow->show();
                  openedit = false;
              }
              break;
  
          case MAIN::control::availableParts:
              partmax = value_int;
              npartcounter->range(1, partmax);
              updatepart();
              updatepanel();
              setinspartlist();
              vectorui->checkParts(value_int);
              break;
  
          case MAIN::control::detune:
              globalfinedetune->value(value);
              break;
  
          case MAIN::control::keyShift:
              masterkeyshift->value(value_int);
              break;
  
          case MAIN::control::soloType:
              channelswitch->value(value_int);
              if (value_int == 0)
              {
                  CS_CC = 128;
                  CSspinner->value(115); // default
                  CSspinner->hide();
                  CSpend->hide();
                  for (int i = 0; i < NUM_MIDI_CHANNELS; ++i)
                      setPanelPartMidiWidget(i, i);
              }
              else
              {
                  CS_CC = 115;
                  CSspinner->value(115);
                  CSpend->show();
                  CSspinner->show();
                  for (int i = 1; i < NUM_MIDI_CHANNELS; ++i)
                  {
                      if (value_int == 2)
                          setPanelPartMidiWidget(i, i);
                      else
                          setPanelPartMidiWidget(i, 16);
                  }
              }
              panelwindow->changed();
              break;
          case MAIN::control::soloCC:
              updatepanel();
              break;
          case MAIN::control::exportBank:
              name = miscMsgPop(par2);
              if (wasFromHere)
                  fl_alert("%s",name.c_str());
              break;
          case MAIN::control::importBank: // import bank
              name = miscMsgPop(par2);
              if (wasFromHere)
              {
                  if (name.find("FAILED") == 1)
                      fl_alert("%s",name.c_str());
                  else
                  {
                      unsigned int other = name.find(" : ");
                      if (other < 1024) // a bit of a hack :(
                      {
                          name = name.substr(other + 3);
                          fl_alert("%s",name.c_str());
                      }
                  }
              }
              bankui->rescan_for_banks(false);
              break;
          case MAIN::control::deleteBank: // delete bank and contents
              name = miscMsgPop(par2);
              if (name.find("FAILED") == 1)
              {
                  if (wasFromHere)
                      fl_alert("%s",name.c_str());
              }
              bankui->rescan_for_banks(false);
              bankui->set_bank_slot();
              break;
          case MAIN::control::setCurrentRootBank: // set current root and/or bank
              if (kititem != UNUSED)
              {
                  ; // do both
              }
              else if (engine != UNUSED)
              {
                  ; // just bank
              }
              break;
          case MAIN::control::saveInstrument: // save instrument to bank
              name = miscMsgPop(par2);
              if (npart == parameter)
                  partui->setinstrumentlabel();
              if((parameter & 0x30) == panelgroup)
                  panellistitem[parameter % NUM_MIDI_CHANNELS]->setPartLabel(parameter);
              if (kititem == synth->ReadBankRoot() && engine == synth->ReadBank())
                  bankui->refreshbankslot(insert);
          break;
          case MAIN::control::loadNamedInstrument: // load instrument
              if (name.find("FAILED") == 1)
              {
                  if (wasFromHere)
                      fl_alert("%s",name.c_str());
              }
              else
                  RecentInstruments->activate();
              break;
  
          case MAIN::control::saveNamedInstrument: // save instrument
              name = miscMsgPop(par2);
              if (name.find("FAILED") == 1)
              {
                  if (wasFromHere)
                      fl_alert("%s",name.c_str());
              }
              else
              {
                  partui->setinstrumentlabel();
                  panellistitem[newpart % NUM_MIDI_CHANNELS]->refresh();
                  RecentInstruments->activate();
              }
              break;
  
          case MAIN::control::loadNamedPatchset: // load patchset
              name = miscMsgPop(par2);
              if (name.find("FAILED") == 1)
              {
                  if (wasFromHere)
                      fl_alert("%s",name.c_str());
              }
              else
              {
                  vectorui->RefreshChans();
                  RecentParams->activate();
                  setMasterLabel(findleafname(name));
                  refresh_master_ui(2);
              }
  
              break;
  
          case MAIN::control::saveNamedPatchset: // save patch set
              name = miscMsgPop(par2);
              if (name.find("FAILED") == 1)
              {
                  if (wasFromHere)
                      fl_alert("%s",name.c_str());
              }
              else
              {
                  setMasterLabel(findleafname(name));
                  RecentParams->activate();
                  updatepanel(); // why?
              }
              break;
  
          case MAIN::control::loadNamedVector: // load vector
              name = miscMsgPop(par2);
              if (name.find("FAILED") == 1)
              {
                  if (wasFromHere)
                      fl_alert("%s",name.c_str());
              }
              else
              {
                  vectorui->setLoadLabelRemote(insert, synth->getRuntime().vectordata.Name[insert]);
                  setMasterLabel(findleafname(name) + " - Vector " + to_string(int(insert) + 1));
                  vectorui->recenthistory->activate();
                  refresh_master_ui(5);
              }
              break;
  
          case MAIN::control::saveNamedVector: // save vector
              name = miscMsgPop(par2);
              if (name.find("FAILED") == 1)
              {
                  if (wasFromHere)
                      fl_alert("%s",name.c_str());
              }
              else
              {
                  setMasterLabel(findleafname(name) + " - Vector " + to_string(int(insert) + 1));
                  vectorui->recenthistory->activate();
              }
              break;
  
          case MAIN::control::loadNamedScale: // load scales
              name = miscMsgPop(par2);
              if (name.find("FAILED") == 1)
              {
                  if (wasFromHere)
                      fl_alert("%s",name.c_str());
              }
              else
              {
                  RecentScale->activate();
                  microtonalui->Hide();
                  microtonalui->make_window();
              }
              break;
  
          case MAIN::control::saveNamedScale: // save scales
              name = miscMsgPop(par2);
              if (wasFromHere && name.find("FAILED") == 1)
                  fl_alert("%s",name.c_str());
              else
                  RecentScale->activate();
              break;
  
          case MAIN::control::loadNamedState: // load state
              name = miscMsgPop(par2);
              if (wasFromHere && name.find("FAILED") == 1)
              {
                  fl_alert("%s",name.c_str());
                  refresh_master_ui(1);
              }
              else
              {
                  setMasterLabel(findleafname(name) + " - State");
                  refresh_master_ui(0x14);
              }
              break;
  
          case MAIN::control::saveNamedState: // save state
              name = miscMsgPop(par2);
              if (wasFromHere && name.find("FAILED") == 1)
                  fl_alert("%s",name.c_str());
              else
                  setMasterLabel(findleafname(name) + " - State");
              break;
  
          case MAIN::control::masterReset:
              if (newpart == TOPLEVEL::section::main)
              {
                  refresh_master_ui(1);
                  vumeter->init(-1, synth);
                  resetPartsClip();
              }
              else if (newpart < NUM_MIDI_PARTS)
                  partNew(newpart);
              setMasterLabel("");
              break;
  
          case MAIN::control::masterResetAndMlearn:
              refresh_master_ui(1);
              resetPartsClip();
              if (midilearnui)
                  midilearnui->Hide();
              setMasterLabel("");
              break;
  
          case MAIN::control::openManualPDF:
              if (par2 != NO_MSG)
                  fl_alert("%s", miscMsgPop(par2).c_str());
              break;
  
          case MAIN::control::startInstance: // new instance (do nothing here)
              break;
  
          case MAIN::control::stopSound:
              virkeyboard->relaseallkeys();
              vumeter->init(-1, synth);
              resetPartsClip();
              break;
      }
}

void MasterUI::updatesendwindow() {
  //
      for (int neff1 = 0; neff1 < NUM_SYS_EFX; ++neff1)
          for (int neff2 = neff1 + 1; neff2 < NUM_SYS_EFX; ++neff2)
              syseffsend[neff1][neff2]->value(synth->Psysefxsend[neff1][neff2]);
}

void MasterUI::updatelistitem(int part) {
  //
      int tmp = part % NUM_MIDI_CHANNELS;
      panellistitem[tmp]->refresh();
}

void MasterUI::updatepanel(bool full ) {
  //
      if (synth->getRuntime().single_row_panel)
      {
              panelwindow->size(1085,350);
              Panelpack2->position(544,10);
              Panelclose->position(1018,319);
              Panelgroups->position(12,327);
              Panelsmallgroups->position(12,327);
              channelswitch->position(130,327);
              CSspinner->position(216,327);
              CSpend->position(276,325);
      }
      else
      {
              panelwindow->size(550,670);
              Panelpack2->position(8,325);
              Panelclose->position(482,639);
              Panelgroups->position(12,645);
              Panelsmallgroups->position(12,645);
              channelswitch->position(130,645);
              CSspinner->position(216,645);
              CSpend->position(275,643);
      }
  
      for (int npart = 0; npart < partmax; ++npart)
      {
          if (npart < NUM_MIDI_CHANNELS)
              panellistitem[npart]->refresh();
          vectorui->setInstrumentLabel(npart);
      }
  
      if (partmax == 64)
          Panelgroups->show();
      else
          Panelgroups->hide();
      if (partmax == 32)
          Panelsmallgroups->show();
      else
          Panelsmallgroups->hide();
  
      int oldswitch = channelswitch->value();
      channelswitch->value(synth->getRuntime().channelSwitchType);
      if (full)
      {
          oldswitch = channelswitch->value(); // disables 'pending'
          CS_CC = synth->getRuntime().channelSwitchCC;
      }
      if (synth->getRuntime().channelSwitchType > 0)
      {
          if (oldswitch == 0)
          {
              CSspinner->value(115);
              CSpend->show();
          }
          else
          {
              CSspinner->value(synth->getRuntime().channelSwitchCC);
              CSpend->hide();
          }
          CSspinner->show();
      }
      else
      {
          synth->getRuntime().channelSwitchCC = 128;
          CSspinner->hide();
          CSpend->hide();
      }
      panelwindow->changed();
}

void MasterUI::partNew(int _npart) {
  //
      int nval = _npart;
      partuigroup->remove(partui);
      delete partui;
      partui = new PartUI(0, 0, 765, 525);
      partuigroup->add(partui);
      partui->init(synth->part[nval], nval, bankui);
      partui->redraw();
      npartcounter->value(nval + 1);
      npartcounter->redraw();
      updatelistitem(npart);
      updatelistitem(nval);
      activePart = nval;
      npart = nval;
}

void MasterUI::updatepart() {
  //
      if (checkmaxparts())
      {
          npart = 0;
          npartcounter->value(npart + 1);
          npartcounter->do_callback();
          maxparts->value(partmax);
          maxparts->redraw();
          return;
      }
  
      if (synth->partonoffRead(npart))
          partui->partgroupui->activate();
      else
          partui->partgroupui->deactivate();
  
      partui->partGroupEnable->value(synth->partonoffRead(npart));
      partui->partpan->value(synth->part[npart]->Ppanning);
      partui->partvol->value(synth->part[npart]->Pvolume);
      partui->partkeylimit->value(synth->part[npart]->Pkeylimit);
      partui->velocitysense->value(synth->part[npart]->Pvelsns);
      partui->velocityoffset->value(synth->part[npart]->Pveloffs);
      partui->partkeyshift->value(synth->part[npart]->Pkeyshift - 64);
      partui->minkcounter->value(synth->part[npart]->Pminkey);
      partui->maxkcounter->value(synth->part[npart]->Pmaxkey);
      partui->enportamento->value(synth->part[npart]->ctl->portamento.portamento);
  
      partui->keymode->value(synth->part[npart]->Pkeymode & 3);
  
      maxparts->value(partmax);
      maxparts->redraw();
      npartcounter->value(npart + 1);
      activePart = npart;
      npartcounter->redraw();
      partui->checkEngines();
}

void MasterUI::updatepartprogram(int _npart) {
  //
      if (vectorui)
          vectorui->setInstrumentLabel(_npart);
      /*if (_npart != npart) // not needed?
      {
          updatelistitem(_npart);
          return;
      }*/
  
      if (partui->part->Prcvchn <  NUM_MIDI_CHANNELS)
      {
          partui->midich->value(partui->part->Prcvchn + 1);
          partui->midich->textcolor(FL_BLACK);
      }
      else
      {
           partui->midich->textcolor(FL_WHITE);
           partui->midich->redraw();
      }
      partNew(_npart);
}

void MasterUI::updateeffects(int data) {
  //
      int partnum = data >> 24;
      int effclass = (data >> 22) & 3;
      int parameter = (data >> 8) & 0x7f;
  
      if (effclass == 2)
      {
           // will be part effects
      }
      else if (effclass == 1)
      {
          ninseff = parameter & 0x3f;
          sysinsgroup->value(InsertionEffectsGrp);
          showInsEfxUI();
          inseffnocounter->value(ninseff + 1);
          inseffpart->value(partnum);
          if (partnum != 1) // off
          {
              insefftype->activate();
              inseffectui->activate();
          }
          else
          {
              insefftype->deactivate();
              inseffectui->deactivate();
          }
          insefftype->value(synth->insefx[ninseff]->geteffect());
          inseffectui->refresh(synth->insefx[ninseff], TOPLEVEL::section::insertEffects, ninseff);
      }
      else
      {
          nsyseff = parameter & 0x3f;
          sysinsgroup->value(SystemEffectsGrp);
          syseffnocounter->value(nsyseff + 1);
          sysefftype->value(synth->sysefx[nsyseff]->geteffect());
          syseffectui->refresh(synth->sysefx[nsyseff], TOPLEVEL::section::systemEffects, nsyseff);
          showSysEfxUI();
      }
}

void MasterUI::updatecontrollers(int _npart) {
  //
      if (npart == _npart)
          partui->ctlmidirefresh();
}

void MasterUI::setMasterLabel(string name) {
  //
      string prefix;
      string panel;
      if  (name.size())
      {
          prefix = synth->makeUniqueName(name);
          panel = synth->makeUniqueName("Mixer Panel - "+name);
      }
      else
      {
          prefix = synth->makeUniqueName("");
          prefix = prefix.substr(0, prefix.length() - 3);
          panel = prefix + " : Mixer Panel";
      }
      masterwindow->copy_label(prefix.c_str());
      panelwindow->copy_label(panel.c_str());
      masterwindow->changed();
}

void MasterUI::do_load_scale(string fname) {
  //
      send_data(MAIN::control::loadNamedScale, 0, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main, UNUSED, UNUSED, TOPLEVEL::route::lowPriority, miscMsgPush(fname));
}

void MasterUI::do_load_instrument(string fname) {
  //
      int npart = partui->npart;
      if ((npart /  NUM_MIDI_CHANNELS) == (panelgroup  /  NUM_MIDI_CHANNELS))
      {
          int displaypart = npart % NUM_MIDI_CHANNELS;
          panellistitem[displaypart]->partenabled->value(0);
          panellistitem[displaypart]->panellistitemgroup->deactivate();
      }
      partui->partGroupEnable->value(0);
      partui->partgroup->deactivate();
      send_data(MAIN::control::loadNamedInstrument, npart, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main, UNUSED, UNUSED, UNUSED, miscMsgPush(fname));
}

void MasterUI::do_load_master(const char* file) {
  //
      const char *fname;
      string lastname = synth->lastItemSeen(XML_PARAMETERS);
      if (lastname == "")
          lastname = synth->getRuntime().userHome;
      if (NULL != file)
          fname = file;
      else
      {
          fname = fl_file_chooser("Load:", "({*.xmz})", lastname.c_str(), 0);
          if (fname == NULL)
              return;
      }
      send_data(MAIN::control::loadNamedPatchset, 0, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main, UNUSED, UNUSED, TOPLEVEL::route::adjustAndLoopback, miscMsgPush(fname));
}

void MasterUI::do_save_master(const char* file ) {
  //
      const char *fname;
      string lastname = synth->getLastfileAdded(XML_PARAMETERS);
      if (lastname == "")
          lastname = synth->getRuntime().userHome;
      bool result = false;
      if (file == NULL)
      {
          char *tmp = fl_file_chooser("Save:", "({*.xmz})", lastname.c_str(), 0);
          if (tmp == NULL)
              return;
          tmp = fl_filename_setext(tmp, ".xmz");
          fname = tmp;
          result = isRegFile(tmp);
          if (result)
          {
              result = false;
              if (fl_choice("The file exists. Overwrite it?", NULL, "No", "Yes") < 2)
                  return;
          }
      }
      else
          fname = file;
      // RecentScale->activate();
      send_data(MAIN::control::saveNamedPatchset, 0, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main, UNUSED, UNUSED, TOPLEVEL::route::lowPriority, miscMsgPush(string(fname)));
}

void MasterUI::refresh_master_ui(int type) {
  //
      if (microtonalui) // not taking chances!
          delete microtonalui;
      partmax = synth->getRuntime().NumAvailableParts;
      maxparts->value(partmax);
      checkmaxparts();
  
      npartcounter->value((synth->getRuntime().currentPart) + 1);
      int nval = synth->getRuntime().currentPart;
      partNew(nval);
      activePart = nval;
  
      nsyseff = 0;
      syseffnocounter->value(nsyseff + 1);
      sysefftype->value(synth->sysefx[nsyseff]->geteffect());
      syseffectui->refresh(synth->sysefx[nsyseff], TOPLEVEL::section::systemEffects, nsyseff);
  
      ninseff = 0;
      inseffnocounter->value(nsyseff + 1);
      setInsEff(ninseff);
  
      sysinsgroup->value(SystemEffectsGrp);
      showSysEfxUI();
  
      masterkeyshift->value(synth->Pkeyshift - 64);
      mastervolumedial->value(synth->Pvolume);
      globalfinedetune->value(synth->microtonal.Pglobalfinedetune);
      microtonalui = new MicrotonalUI(&synth->microtonal, synth);
      if (type & 0x80)
          setMasterLabel(miscMsgPop((type >> 8) & UNUSED));
      updatesendwindow();
      updatepanel(type > 0);
      if (type != 5)
          vectorui->RefreshChans();
      bankui->Hide();
      if (synth->getRuntime().toConsole == false)
          Reports->deactivate();
      else
          Reports->activate();
      if (type == 0x14)
      {
          for (int i = 1; i < 6; ++i)
              configui->update_config(i);
      }
}

bool MasterUI::checkmaxparts() {
  //
      bool changed = false;
      if(panelgroup >= partmax)
      {
          panelgroup = 0;
          Panelgroups->value(0);
          Panelsmallgroups->value(0);
          changed = true;
      }
      npartcounter->range(1, partmax);
      if (npart >= partmax)
      {
          npartcounter->value(1);
          activePart = 0;
          changed = true;
      }
      return changed;
}

void MasterUI::strategicRetreat(void) {
  fl_alert("Bad things happened,\nYoshimi strategically retreats.");
}

void MasterUI::Log(string msg) {
  yoshiLog->log(msg);
}

void MasterUI::showSysEfxUI(void) {
  //
      inseffectui->hide();
      inseffectui->deactivate();
      inseffectuigroup->hide();
      inseffectuigroup->deactivate();
  
      syseffectui->activate();
      syseffectui->show();
      syseffectuigroup->activate();
      syseffectuigroup->show();
}

void MasterUI::showInsEfxUI(void) {
  //
      syseffectui->hide();
      syseffectui->deactivate();
      syseffectuigroup->hide();
      syseffectuigroup->deactivate();
  
      inseffectui->activate();
      inseffectui->show();
      inseffectuigroup->activate();
      inseffectuigroup->show();
}

void MasterUI::setinspartlist() {
  //
      inseffpart->clear();
      inseffpart->add("Master Out");
      inseffpart->add("Off");
      int size = synth->getRuntime().NumAvailableParts;
      for (int i = 0; i < size; ++i)
      {
          string num = string("00") + asString(i + 1);
          inseffpart->add((string("Part ") + asString(i + 1)).c_str());
      }
      int current = synth->Pinsparts[ninseff];
      if (current >= size)
      {
          current = -1; // off is safe
          synth->Pinsparts[ninseff] = current;
      }
      inseffpart->value(current + 2);
}

PresetsUI * MasterUI::getPresetsUi() {
  //
      return presetsui;
}

void MasterUI::resetPartsClip() {
  //
      for (int i = 0; i < NUM_MIDI_CHANNELS; i++)
      {
          if(panellistitem[i] && panellistitem[i]->partVUMeter)
          {
              panellistitem[i]->partVUMeter->resetPart(true);
          }
      }
}

void MasterUI::setInsEff(int effnum) {
  //
      int ninseff = effnum;
      insefftype->value(synth->insefx[ninseff]->geteffect());
      inseffpart->value(synth->Pinsparts[ninseff] + 2);
      inseffectui->refresh(synth->insefx[ninseff], TOPLEVEL::section::insertEffects, ninseff);
      if (synth->Pinsparts[ninseff] != -1)
      {
          insefftype->activate();
          inseffectui->activate();
          inseffectuigroup->activate();
      }
      else
      {
          insefftype->deactivate();
          inseffectui->deactivate();
          inseffectuigroup->deactivate();
      }
}

void MasterUI::setState(string filename) {
  //
      send_data(MAIN::control::loadNamedState, 0, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, TOPLEVEL::section::main, UNUSED, UNUSED, TOPLEVEL::route::adjustAndLoopback, miscMsgPush(filename));
}

string MasterUI::setPartWindowTitle(string prefix) {
  //
      string extension = " - Part " + asString(partui->npart + 1) + " " + partui->part->Pname;
      if (partui->part->Pkitmode)
      {
          extension += ", Kit ";
          if (partui->lastkititem >= 0)
          {
              extension += to_string(partui->lastkititem + 1);
              if (partui->kitname > "")
                  extension += (" - " + partui->kitname);
          }
      }
      return synth->makeUniqueName(prefix + extension);
}

void MasterUI::setPartActive(int _npart, bool active) {
  //
      if (_npart == npart)
      {
          partui->partGroupEnable->value(active);
          if (active)
          {
              partui->partgroupui->activate();
              partui->toSysEfx->activate();
          }
          else
          {
              partui->partgroupui->deactivate();
              partui->toSysEfx->deactivate();
          }
      }
}

void MasterUI::setPartVolWidget(int _npart, float _value) {
  //
      if (_npart == npart)
          partui->partvol->value(_value);
}

void MasterUI::setPartPanWidget(int _npart, float _value) {
  //
      if (_npart == npart)
          partui->partpan->value(_value);
}

void MasterUI::setPanelPartVolWidget(int _npart, float _value) {
  //
      panellistitem[_npart]->partvolume->value(_value);
}

void MasterUI::setPanelPartPanWidget(int _npart, float _value) {
  //
      panellistitem[_npart]->partpanning->value(_value);
}

void MasterUI::setPartMidiWidget(int _npart, unsigned char _value) {
  //
      if (_npart == npart)
          partui->midich->value(_value);
      partui->midich->textcolor(FL_BLACK);
}

void MasterUI::setPanelPartMidiWidget(int _npart, unsigned char _value) {
  //
      panellistitem[_npart]->partrcv->value(_value);
      panellistitem[_npart]->partrcv->textcolor(FL_BLACK);
      panellistitem[_npart]->partrcv->redraw();
}

void MasterUI::setLogging(bool isConsole) {
  //
      if (isConsole)
      {
          Reports->activate();
          yoshiLog->Show();
      }
      else
      {
          Reports->deactivate();
          yoshiLog->Hide();
      }
}

void MasterUI::updateBankRootDirs() {
  bankui->readbankcfg();
}

void MasterUI::updatepaths(int type) {
  //
      if (type == 0)
      {
          bankui->readbankcfg();
          bankui-> rescan_for_banks(false);
      }
}

void MasterUI::ShowAlert(int num) {
  fl_alert("%s", miscMsgPop(num).c_str());
}

SynthEngine * MasterUI::getSynth() {
  return synth;
}

void MasterUI::loadWindowData() {
  //
  
      bool ok = false;
      bool tmpWindows;
      int masterX;
      int masterY;
      int masterO;
  
      windows = fopen(filename.c_str(), "r");
      if (windows == NULL)
          NewWindows = true;
      else
          NewWindows = false;
      ok = !NewWindows;
      tmpWindows = NewWindows;
      // we carry on anyway to set defaults
      ok = getData(ok,
                  "master",
                   masterX,
                   masterY,
                   masterO);
      ok = getData(ok,
                  "panel",
                   panelX,
                   panelY,
                   panelO);
      ok = getData(ok,
                  "instruments",
                   instrumentsX,
                   instrumentsY,
                   instrumentsO);
      ok = getData(ok,
                  "banks",
                   banksX,
                   banksY,
                   banksO);
      ok = getData(ok,
                  "roots",
                   rootsX,
                   rootsY,
                   rootsO);
      ok = getData(ok,
                  "presets",
                   presetsX,
                   presetsY,
                   presetsO);
      ok = getData(ok,
                  "scales",
                   scalesX,
                   scalesY,
                   scalesO);
      if (NewWindows)
      {
           NewWindows = false;
           virkbdX = 400;
           virkbdY = 1;
           virkbdO = 1;
      }
      ok = getData(ok,
                  "virtkeybd",
                   virkbdX,
                   virkbdY,
                   virkbdO);
      NewWindows = tmpWindows;
      ok = getData(ok,
                  "settings",
                   settingsX,
                   settingsY,
                   settingsO);
      ok = getData(ok,
                  "yoshiLog",
                   yoshiLogX,
                   yoshiLogY,
                   yoshiLogO);
      ok = getData(ok,
                  "vectors",
                   vectorX,
                   vectorY,
                   vectorO);
      ok = getData(ok,
                  "MIDIlearn",
                   mlearnX,
                   mlearnY,
                   mlearnO);
      ok = getData(ok,
                  "controllers",
                   controllersX,
                   controllersY,
                   controllersO);
      ok = getData(ok,
                  "midicontrols",
                   midictlX,
                   midictlY,
                   midictlO);
      ok = getData(ok,
                  "instrumentedit",
                   inseditX,
                   inseditY,
                   inseditO);
      ok = getData(ok,
                  "kitlist",
                   kitlistX,
                   kitlistY,
                   kitlistO);
      ok = getData(ok,
                  "partFX",
                   partfxX,
                   partfxY,
                   partfxO);
  
      ok = getData(ok,
                  "SUBnote",
                   subNoteX,
                   subNoteY,
                   subNoteO);
      ok = getData(ok,
                  "PADnote",
                   padNoteX,
                   padNoteY,
                   padNoteO);
      ok = getData(ok,
                  "ADDnote",
                   addNoteX,
                   addNoteY,
                   addNoteO);
  
     if (windows != NULL)
          fclose(windows);
  
      masterwindow->position(masterX, masterY);
      panelwindow->position(panelX, panelY);
      bankui->instrumentuiwindow->position(instrumentsX, instrumentsY);
      bankui->bankuiwindow->position(banksX, banksY);
      bankui->rootuiwindow->position(rootsX, rootsY);
      configui->presets->position(presetsX, presetsY);
      microtonalui->microtonaluiwindow->position(scalesX, scalesY);
      virkeyboard->virkeyboardwindow->position(virkbdX, virkbdY);
      configui->configwindow->position(settingsX, settingsY);
      yoshiLog->logConsole->position(yoshiLogX, yoshiLogY);
      vectorui->vectorwindow->position(vectorX, vectorY);
      midilearnui->midilearnwindow->position(mlearnX, mlearnY);
      partui->ctlwindow->position(controllersX, controllersY);
      partui->ctlmidi->position(midictlX, midictlY);
      partui->instrumenteditwindow->position(inseditX, inseditY);
      partui->instrumentkitlist->position(kitlistX, kitlistY);
      partui->partfx->position(partfxX, partfxY);
}

void MasterUI::saveWindowData() {
  //
      windows = fopen(filename.c_str(), "w");
  
      putData("master",
               masterwindow->x(),
               masterwindow->y(),
               masterwindow->visible());
      putData("panel",
               panelwindow->x(),
               panelwindow->y(),
               panelwindow->visible());
      putData("instruments",
               bankui->instrumentuiwindow->x(),
               bankui->instrumentuiwindow->y(),
               bankui->instrumentuiwindow->visible());
      putData("banks",
               bankui->bankuiwindow->x(),
               bankui->bankuiwindow->y(),
               bankui->bankuiwindow->visible());
      putData("roots",
               bankui->rootuiwindow->x(),
               bankui->rootuiwindow->y(),
               bankui->rootuiwindow->visible());
      putData("presets",
               configui->presets->x(),
               configui->presets->y(),
               configui->presets->visible());
      putData("scales",
               microtonalui->microtonaluiwindow->x(),
               microtonalui->microtonaluiwindow->y(),
               microtonalui->microtonaluiwindow->visible());
      putData("virtkeybd",
               virkeyboard->virkeyboardwindow->x(),
               virkeyboard->virkeyboardwindow->y(),
               virkeyboard->virkeyboardwindow->visible());
      putData("settings",
               configui->configwindow->x(),
               configui->configwindow->y(),
               configui->configwindow->visible());
      putData("yoshiLog",
               yoshiLog->logConsole->x(),
               yoshiLog->logConsole->y(),
               yoshiLog->logConsole->visible());
      putData("vectors",
               vectorui->vectorwindow->x(),
               vectorui->vectorwindow->y(),
               vectorui->vectorwindow->visible());
      putData("MIDIlearn",
               midilearnui->midilearnwindow->x(),
               midilearnui->midilearnwindow->y(),
               midilearnui->midilearnwindow->visible());
  
      if (partui->ctlwindow->x())
          putData("controllers",
                   partui->ctlwindow->x(),
                   partui->ctlwindow->y(),
                   partui->ctlwindow->visible());
      else // no window so store previous values
          putData("controllers",
                   controllersX,
                   controllersY,
                   controllersO);
  
      if (partui->ctlwindow->x())
          putData("midcontrols",
                   partui->ctlmidi->x(),
                   partui->ctlmidi->y(),
                   partui->ctlmidi->visible());
      else // no window so store previous values
          putData("controllers",
                   midictlX,
                   midictlY,
                   midictlO);
  
      if (partui->instrumenteditwindow->x())
          putData("instrumentedit",
                   partui->instrumenteditwindow->x(),
                   partui->instrumenteditwindow->y(),
                   partui->instrumenteditwindow->visible());
      else
          putData("instrumentedit",
                   inseditX,
                   inseditY,
                   inseditO);
  
      if (partui->instrumentkitlist->x())
          putData("kitlist",
                   partui->instrumentkitlist->x(),
                   partui->instrumentkitlist->y(),
                   partui->instrumentkitlist->visible());
      else
          putData("kitlist",
                   kitlistX,
                   kitlistY,
                   kitlistO);
  
      if(partui->partfx->x())
          putData("partFX",
                   partui->partfx->x(),
                   partui->partfx->y(),
                   partui->partfx->visible());
      else
          putData("partFX",
                   partfxX,
                   partfxY,
                   partfxO);
  
      putData("SUBnote",
               subNoteX,
               subNoteY,
               subNoteO);
      putData("PADnote",
               padNoteX,
               padNoteY,
               padNoteO);
      putData("ADDnote",
               addNoteX,
               addNoteY,
               addNoteO);
  
     fclose(windows);
}

bool MasterUI::getData(bool ok, string name, int& X, int& Y, int& O) {
  //
      if (NewWindows)
      {
          X = 1;
          Y = 1;
          O = 0;
      }
      if (!ok)
          return false;
  
      ok = (fgets(word, 20, windows) != NULL);
      if (ok)
          ok = strstr(word, name.c_str());
      if (true)
      {
          ok = false;
          if (fgets(word, 20, windows) != NULL)
              X = atoi(word);
          if (fgets(word, 20, windows) != NULL)
              Y = atoi(word);
          if (fgets(word, 20, windows) != NULL)
          {
              O = atoi(word);
              ok = true;
          }
      }
      return ok;
}

void MasterUI::putData(string name, int X, int Y, int O) {
  //
      string tosend = name + "\n"
                    + asString(X)+ "\n"
                    + asString(Y) + "\n"
                    + asString(O) + "\n";
      fputs(tosend.c_str(), windows);
}

void MasterUI::checkBuffer(void) {
  //
  read_updates(synth);
}
