// generated by Fast Light User Interface Designer (fluid) version 1.0304

#include "PartUI.h"
// PartUI.cc
// Original ZynAddSubFX author Nasca Octavian Paul
// Copyright (C) 2002-2005 Nasca Octavian Paul
// Copyright 2009-2011, Alan Calvert
// Copyright 2014-2018, Will Godfrey

// This file is part of yoshimi, which is free software: you can redistribute
// it and/or modify it under the terms of the GNU Library General Public
// License as published by the Free Software Foundation; either version 2 of
// the License, or (at your option) any later version.

// yoshimi is distributed in the hope that it will be useful, but WITHOUT ANY
// WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
// FOR A PARTICULAR PURPOSE.   See the GNU General Public License (version 2 or
// later) for more details.

// You should have received a copy of the GNU General Public License along with
// yoshimi; if not, write to the Free Software Foundation, Inc., 51 Franklin
// Street, Fifth Floor, Boston, MA  02110-1301, USA.

// This file is derivative of ZynAddSubFX original code.

// Modified October 2018

#include <FL/fl_ask.H>
    #include "Misc/Config.h"
    #include "Misc/SynthEngine.h"
#include "MasterUI.h"

void PartSysEffSend::cb_sysend_i(WidgetPDial* o, void*) {
  //
        send_data(neff, o->value(), TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet);
}
void PartSysEffSend::cb_sysend(WidgetPDial* o, void* v) {
  ((PartSysEffSend*)(o->parent()->user_data()))->cb_sysend_i(o,v);
}

Fl_Group* PartSysEffSend::make_window() {
  { syseffsend = new Fl_Group(0, 0, 50, 80);
    syseffsend->box(FL_FLAT_BOX);
    syseffsend->color(FL_BACKGROUND_COLOR);
    syseffsend->selection_color(FL_BACKGROUND_COLOR);
    syseffsend->labeltype(FL_NO_LABEL);
    syseffsend->labelfont(0);
    syseffsend->labelsize(14);
    syseffsend->labelcolor(FL_FOREGROUND_COLOR);
    syseffsend->user_data((void*)(this));
    syseffsend->align(Fl_Align(FL_ALIGN_TOP));
    syseffsend->when(FL_WHEN_RELEASE);
    { WidgetPDial* o = sysend = new WidgetPDial(0, 0, 25, 25, "01");
      sysend->box(FL_ROUND_UP_BOX);
      sysend->color(FL_BACKGROUND_COLOR);
      sysend->selection_color(FL_INACTIVE_COLOR);
      sysend->labeltype(FL_NORMAL_LABEL);
      sysend->labelfont(0);
      sysend->labelsize(10);
      sysend->labelcolor(FL_FOREGROUND_COLOR);
      sysend->maximum(127);
      sysend->step(1);
      sysend->callback((Fl_Callback*)cb_sysend);
      sysend->align(Fl_Align(FL_ALIGN_BOTTOM));
      sysend->when(FL_WHEN_CHANGED);
      o->value(synth->Psysefxvol[neff][npart]);
      o->copy_label(asString(neff + 1).c_str());
      o->setValueType(VC_FXSysSend);
    } // WidgetPDial* sysend
    syseffsend->end();
  } // Fl_Group* syseffsend
  return syseffsend;
}

PartSysEffSend::PartSysEffSend(int x, int y, int w, int h) :
    Fl_Group(x, y, w, h, NULL) {
  //
      neff = 0;
      npart = 0;
}

void PartSysEffSend::send_data(int control, float value, int type) {
  //
      type |= TOPLEVEL::type::Write;
          collect_data(synth, value, (Fl::event_button() | type), control + PART::control::partToSystemEffect1, npart);
}

void PartSysEffSend::init(int npart_, int neff_, SynthEngine *_synth) {
  //
      synth = _synth;
      npart = npart_;
      neff = neff_;
      make_window();
      syseffsend->show();
      end();
}

PartSysEffSend::~PartSysEffSend() {
  //
      syseffsend->hide();
}

void PartUI_::showparameters(int /* kititem */,int /* engine */) {
  ;
}

void PartKitItem::cb_mutedcheck_i(Fl_Check_Button* o, void*) {
  //
          send_data(PART::control::kitItemMute, o->value(), TOPLEVEL::type::Integer, n, UNUSED, TOPLEVEL::insert::kitGroup);
}
void PartKitItem::cb_mutedcheck(Fl_Check_Button* o, void* v) {
  ((PartKitItem*)(o->parent()->parent()->user_data()))->cb_mutedcheck_i(o,v);
}

void PartKitItem::cb_labelbutton_i(Fl_Button* o, void*) {
  //
          const char *tmp = fl_input("Kit item name:", part->kit[n].Pname.c_str());
          if (tmp != NULL)
          {
              send_data(PART::control::instrumentName, 0, TOPLEVEL::type::Integer, n, UNUSED, TOPLEVEL::insert::kitGroup, TOPLEVEL::route::lowPriority + 1, miscMsgPush(string(tmp)));
              o->copy_label(tmp);
          };
}
void PartKitItem::cb_labelbutton(Fl_Button* o, void* v) {
  ((PartKitItem*)(o->parent()->parent()->user_data()))->cb_labelbutton_i(o,v);
}

void PartKitItem::cb_minkcounter_i(Fl_Counter* o, void*) {
  //
          int tmp = o->value();
          int other = maxkcounter->value();
          if (tmp >= other)
          {
              tmp = other;
              o->value(tmp);
          }

          send_data(PART::control::minNote, tmp, TOPLEVEL::type::Integer, n, UNUSED, TOPLEVEL::insert::kitGroup);
}
void PartKitItem::cb_minkcounter(Fl_Counter* o, void* v) {
  ((PartKitItem*)(o->parent()->parent()->user_data()))->cb_minkcounter_i(o,v);
}

void PartKitItem::cb_m_i(Fl_Button*, void*) {
  //
          int last = part->lastnote;
          if (last <= 0)
              return;
          int tmp;
          int other = maxkcounter->value();
          if (last >= other)
              tmp = other;
          else
              tmp = last;
          minkcounter->value(tmp);

          send_data(PART::control::minToLastKey, tmp, TOPLEVEL::type::Integer, n, UNUSED, TOPLEVEL::insert::kitGroup);
}
void PartKitItem::cb_m(Fl_Button* o, void* v) {
  ((PartKitItem*)(o->parent()->parent()->user_data()))->cb_m_i(o,v);
}

void PartKitItem::cb_M_i(Fl_Button*, void*) {
  //
          int last = part->lastnote;
          if (last <= 0)
              return;
          int tmp;
          int other = minkcounter->value();
          if (last <= other)
              tmp = other;
          else
              tmp = last;
          maxkcounter->value(tmp);

          send_data(PART::control::maxToLastKey, tmp, TOPLEVEL::type::Integer, n, UNUSED, TOPLEVEL::insert::kitGroup);
}
void PartKitItem::cb_M(Fl_Button* o, void* v) {
  ((PartKitItem*)(o->parent()->parent()->user_data()))->cb_M_i(o,v);
}

void PartKitItem::cb_R_i(Fl_Button* o, void*) {
  //
          minkcounter->value(0);
          maxkcounter->value(127);

          send_data(PART::control::resetMinMaxKey, o->value(), TOPLEVEL::type::Integer, n, UNUSED, TOPLEVEL::insert::kitGroup);
}
void PartKitItem::cb_R(Fl_Button* o, void* v) {
  ((PartKitItem*)(o->parent()->parent()->user_data()))->cb_R_i(o,v);
}

void PartKitItem::cb_maxkcounter_i(Fl_Counter* o, void*) {
  //
          int tmp = o->value();
          int other = minkcounter->value();
          if (tmp <= other)
          {
              tmp = other;
              o->value(tmp);
          }
          send_data(PART::control::maxNote, tmp, TOPLEVEL::type::Integer, n, UNUSED, TOPLEVEL::insert::kitGroup);
}
void PartKitItem::cb_maxkcounter(Fl_Counter* o, void* v) {
  ((PartKitItem*)(o->parent()->parent()->user_data()))->cb_maxkcounter_i(o,v);
}

void PartKitItem::cb_adeditbutton_i(Fl_Button*, void*) {
  //
          partui->showparameters(n,0);
          if ((Fl::event_button() == 3))
              synth->getGuiMaster()->partui->instrumentkitlist->hide();
}
void PartKitItem::cb_adeditbutton(Fl_Button* o, void* v) {
  ((PartKitItem*)(o->parent()->parent()->user_data()))->cb_adeditbutton_i(o,v);
}

void PartKitItem::cb_adcheck_i(Fl_Check_Button* o, void*) {
  //
          int x = o->value();
          if (x)
              adeditbutton->activate();
          else
              adeditbutton->deactivate();
          if (n == 0)
          {
              synth->getGuiMaster()->partui->adsynenabledcheck->value(x);
              if (x)
                  synth->getGuiMaster()->partui->adeditbutton->activate();
              else
                  synth->getGuiMaster()->partui->adeditbutton->deactivate();
          }
          synth->getGuiMaster()->partui->checkEngines();
          send_data(PART::control::enable, o->value(), TOPLEVEL::type::Integer, n, 0, TOPLEVEL::insert::kitGroup);
}
void PartKitItem::cb_adcheck(Fl_Check_Button* o, void* v) {
  ((PartKitItem*)(o->parent()->parent()->user_data()))->cb_adcheck_i(o,v);
}

void PartKitItem::cb_subeditbutton_i(Fl_Button*, void*) {
  //
          partui->showparameters(n,1);
          if ((Fl::event_button() == 3))
              synth->getGuiMaster()->partui->instrumentkitlist->hide();
}
void PartKitItem::cb_subeditbutton(Fl_Button* o, void* v) {
  ((PartKitItem*)(o->parent()->parent()->user_data()))->cb_subeditbutton_i(o,v);
}

void PartKitItem::cb_subcheck_i(Fl_Check_Button* o, void*) {
  //
          int x = o->value();
          if (x)
              subeditbutton->activate();
          else
              subeditbutton->deactivate();
          if (n == 0)
          {
              synth->getGuiMaster()->partui->subsynenabledcheck->value(x);
              if (x)
                  synth->getGuiMaster()->partui->subeditbutton->activate();
              else
                  synth->getGuiMaster()->partui->subeditbutton->deactivate();
          }
          synth->getGuiMaster()->partui->checkEngines();
          send_data(PART::control::enable, o->value(), TOPLEVEL::type::Integer, n, 1, TOPLEVEL::insert::kitGroup);
}
void PartKitItem::cb_subcheck(Fl_Check_Button* o, void* v) {
  ((PartKitItem*)(o->parent()->parent()->user_data()))->cb_subcheck_i(o,v);
}

void PartKitItem::cb_padeditbutton_i(Fl_Button*, void*) {
  //
          partui->showparameters(n,2);
          if ((Fl::event_button() == 3))
              synth->getGuiMaster()->partui->instrumentkitlist->hide();
}
void PartKitItem::cb_padeditbutton(Fl_Button* o, void* v) {
  ((PartKitItem*)(o->parent()->parent()->user_data()))->cb_padeditbutton_i(o,v);
}

void PartKitItem::cb_padcheck_i(Fl_Check_Button* o, void*) {
  //
          int x = o->value();
          if (x)
              padeditbutton->activate();
          else
              padeditbutton->deactivate();
          if (n == 0)
          {
              synth->getGuiMaster()->partui->padsynenabledcheck->value(x);
              if (x)
                  synth->getGuiMaster()->partui->padeditbutton->activate();
              else
                  synth->getGuiMaster()->partui->padeditbutton->deactivate();
          }
          synth->getGuiMaster()->partui->checkEngines();
          send_data(PART::control::enable, o->value(), TOPLEVEL::type::Integer, n, 2, TOPLEVEL::insert::kitGroup);
}
void PartKitItem::cb_padcheck(Fl_Check_Button* o, void* v) {
  ((PartKitItem*)(o->parent()->parent()->user_data()))->cb_padcheck_i(o,v);
}

void PartKitItem::cb_sendtoeffect_i(Fl_Choice* o, void*) {
  //
          send_data(PART::control::kitEffectNum, o->value(), TOPLEVEL::type::Integer, n, UNUSED, TOPLEVEL::insert::kitGroup);
}
void PartKitItem::cb_sendtoeffect(Fl_Choice* o, void* v) {
  ((PartKitItem*)(o->parent()->parent()->user_data()))->cb_sendtoeffect_i(o,v);
}

void PartKitItem::cb_enabledcheck_i(Fl_Check_Button* o, void*) {
  //
        int answer = 1;
        if (o->value() == 0)
            answer = (fl_choice("Delete the item?", NULL,"No","Yes") > 1);
        if (answer != 0)
        {
            if (o->value() == 0)
                clearLine();
            else
                partkititemgroup->activate();
            o->redraw();
            partui->showparameters(n, -1); // use to delete the ui, if it is not to item 0
        }
        else
            o->value(1);
        send_data(PART::control::enable, o->value(), TOPLEVEL::type::Integer, n, UNUSED, TOPLEVEL::insert::kitGroup);
}
void PartKitItem::cb_enabledcheck(Fl_Check_Button* o, void* v) {
  ((PartKitItem*)(o->parent()->user_data()))->cb_enabledcheck_i(o,v);
}

Fl_Group* PartKitItem::make_window() {
  { partkititem = new Fl_Group(0, 0, 670, 30);
    partkititem->box(FL_FLAT_BOX);
    partkititem->color(FL_BACKGROUND_COLOR);
    partkititem->selection_color(FL_BACKGROUND_COLOR);
    partkititem->labeltype(FL_NO_LABEL);
    partkititem->labelfont(0);
    partkititem->labelsize(14);
    partkititem->labelcolor(FL_FOREGROUND_COLOR);
    partkititem->user_data((void*)(this));
    partkititem->align(Fl_Align(FL_ALIGN_TOP));
    partkititem->when(FL_WHEN_RELEASE);
    { Fl_Group* o = partkititemgroup = new Fl_Group(55, 0, 605, 20);
      partkititemgroup->box(FL_FLAT_BOX);
      { Fl_Check_Button* o = mutedcheck = new Fl_Check_Button(60, 0, 17, 15);
        mutedcheck->box(FL_THIN_UP_BOX);
        mutedcheck->down_box(FL_DOWN_BOX);
        mutedcheck->color((Fl_Color)237);
        mutedcheck->labelfont(1);
        mutedcheck->labelsize(11);
        mutedcheck->callback((Fl_Callback*)cb_mutedcheck);
        mutedcheck->align(Fl_Align(FL_ALIGN_LEFT));
        o->value(part->kit[n].Pmuted);
      } // Fl_Check_Button* mutedcheck
      { Fl_Button* o = labelbutton = new Fl_Button(90, 0, 130, 15, "Bass Drum");
        labelbutton->box(FL_THIN_DOWN_BOX);
        labelbutton->down_box(FL_FLAT_BOX);
        labelbutton->color(FL_BACKGROUND2_COLOR);
        labelbutton->labelfont(1);
        labelbutton->labelsize(10);
        labelbutton->callback((Fl_Callback*)cb_labelbutton);
        labelbutton->align(Fl_Align(FL_ALIGN_LEFT|FL_ALIGN_INSIDE));
        o->copy_label(part->kit[n].Pname.c_str());
      } // Fl_Button* labelbutton
      { Fl_Counter* o = minkcounter = new Fl_Counter(225, 0, 55, 15);
        minkcounter->type(1);
        minkcounter->minimum(0);
        minkcounter->maximum(128);
        minkcounter->step(1);
        minkcounter->callback((Fl_Callback*)cb_minkcounter);
        o->value(part->kit[n].Pminkey);
      } // Fl_Counter* minkcounter
      { Fl_Button* o = new Fl_Button(285, 3, 15, 12, "m");
        o->tooltip("set the minimum key to the last pressed key");
        o->box(FL_THIN_UP_BOX);
        o->labelsize(10);
        o->callback((Fl_Callback*)cb_m);
      } // Fl_Button* o
      { Fl_Button* o = new Fl_Button(315, 3, 15, 12, "M");
        o->tooltip("set the maximum key to the last pressed key");
        o->box(FL_THIN_UP_BOX);
        o->labelsize(10);
        o->callback((Fl_Callback*)cb_M);
      } // Fl_Button* o
      { Fl_Button* o = new Fl_Button(300, 3, 15, 12, "R");
        o->tooltip("reset the minimum key to 0 and maximum key to 127");
        o->box(FL_THIN_UP_BOX);
        o->labelfont(1);
        o->labelsize(10);
        o->callback((Fl_Callback*)cb_R);
      } // Fl_Button* o
      { Fl_Counter* o = maxkcounter = new Fl_Counter(335, 0, 55, 15);
        maxkcounter->type(1);
        maxkcounter->minimum(0);
        maxkcounter->maximum(128);
        maxkcounter->step(1);
        maxkcounter->callback((Fl_Callback*)cb_maxkcounter);
        o->value(part->kit[n].Pmaxkey);
      } // Fl_Counter* maxkcounter
      { Fl_Button* o = adeditbutton = new Fl_Button(420, 0, 40, 15, "edit");
        adeditbutton->box(FL_THIN_UP_BOX);
        adeditbutton->labelsize(11);
        adeditbutton->callback((Fl_Callback*)cb_adeditbutton);
        if (part->kit[n].Padenabled==0) o->deactivate();
      } // Fl_Button* adeditbutton
      { Fl_Check_Button* o = adcheck = new Fl_Check_Button(400, 0, 17, 15);
        adcheck->box(FL_THIN_UP_BOX);
        adcheck->down_box(FL_DOWN_BOX);
        adcheck->color((Fl_Color)237);
        adcheck->labelfont(1);
        adcheck->labelsize(11);
        adcheck->callback((Fl_Callback*)cb_adcheck);
        adcheck->align(Fl_Align(FL_ALIGN_LEFT));
        o->value(part->kit[n].Padenabled);
      } // Fl_Check_Button* adcheck
      { Fl_Button* o = subeditbutton = new Fl_Button(490, 0, 40, 15, "edit");
        subeditbutton->box(FL_THIN_UP_BOX);
        subeditbutton->labelsize(11);
        subeditbutton->callback((Fl_Callback*)cb_subeditbutton);
        if (part->kit[n].Psubenabled==0) o->deactivate();
      } // Fl_Button* subeditbutton
      { Fl_Check_Button* o = subcheck = new Fl_Check_Button(470, 0, 17, 15);
        subcheck->box(FL_THIN_UP_BOX);
        subcheck->down_box(FL_DOWN_BOX);
        subcheck->color((Fl_Color)237);
        subcheck->labelfont(1);
        subcheck->labelsize(11);
        subcheck->callback((Fl_Callback*)cb_subcheck);
        subcheck->align(Fl_Align(FL_ALIGN_LEFT));
        o->value(part->kit[n].Psubenabled);
      } // Fl_Check_Button* subcheck
      { Fl_Button* o = padeditbutton = new Fl_Button(560, 0, 40, 15, "edit");
        padeditbutton->box(FL_THIN_UP_BOX);
        padeditbutton->labelsize(11);
        padeditbutton->callback((Fl_Callback*)cb_padeditbutton);
        if (part->kit[n].Ppadenabled==0) o->deactivate();
      } // Fl_Button* padeditbutton
      { Fl_Check_Button* o = padcheck = new Fl_Check_Button(540, 0, 17, 15);
        padcheck->box(FL_THIN_UP_BOX);
        padcheck->down_box(FL_DOWN_BOX);
        padcheck->color((Fl_Color)237);
        padcheck->labelfont(1);
        padcheck->labelsize(11);
        padcheck->callback((Fl_Callback*)cb_padcheck);
        padcheck->align(Fl_Align(FL_ALIGN_LEFT));
        o->value(part->kit[n].Ppadenabled);
      } // Fl_Check_Button* padcheck
      { Fl_Choice* o = sendtoeffect = new Fl_Choice(615, 0, 45, 15);
        sendtoeffect->down_box(FL_BORDER_BOX);
        sendtoeffect->labelsize(10);
        sendtoeffect->textfont(1);
        sendtoeffect->textsize(10);
        sendtoeffect->callback((Fl_Callback*)cb_sendtoeffect);
        sendtoeffect->align(Fl_Align(FL_ALIGN_TOP_LEFT));
        o->add("OFF"); char nrstr[10]; for(int i = 0; i < NUM_PART_EFX; i++) {sprintf(nrstr,"FX%d",i+1);o->add(nrstr);};
        o->value(part->kit[n].Psendtoparteffect+1);if (part->kit[n].Psendtoparteffect==127) o->value(0);
      } // Fl_Choice* sendtoeffect
      if (part->kit[n].Penabled == 0) o->deactivate();
      partkititemgroup->end();
    } // Fl_Group* partkititemgroup
    { Fl_Check_Button* o = enabledcheck = new Fl_Check_Button(30, 0, 20, 15, "01");
      enabledcheck->down_box(FL_DOWN_BOX);
      enabledcheck->labeltype(FL_EMBOSSED_LABEL);
      enabledcheck->labelfont(1);
      enabledcheck->labelsize(13);
      enabledcheck->callback((Fl_Callback*)cb_enabledcheck);
      enabledcheck->align(Fl_Align(FL_ALIGN_LEFT));
      snprintf(label,10,"%d",n+1);o->label(label);
      o->value(part->kit[n].Penabled);
      if (n==0) o->hide();
      if (o->value() == 0) labelbutton->color(FL_WHITE);
    } // Fl_Check_Button* enabledcheck
    partkititem->end();
  } // Fl_Group* partkititem
  return partkititem;
}

void PartKitItem::send_data(int control, float value, int type, int kititem , int engine , int insert , int parameter , int par2 ) {
  //
          type |= TOPLEVEL::type::Write;
          collect_data(synth, value, (Fl::event_button() | type), control, npart, kititem, engine, insert, parameter, par2);
}

PartKitItem::PartKitItem(int x,int y, int w, int h, const char *label):Fl_Group(x,y,w,h,label) {
  //
      n=0;part=NULL;
}

void PartKitItem::clearLine() {
  //
      partkititemgroup->deactivate();
      mutedcheck->value(0);
      labelbutton->copy_label("");
      minkcounter->value(0);
      maxkcounter->value(127);
      adcheck->value(0);
      adeditbutton->deactivate();
      subcheck->value(0);
      subeditbutton->deactivate();
      padcheck->value(0);
      padeditbutton->deactivate();
      sendtoeffect->value(1);
}

void PartKitItem::init(Part *part_, int n_, int npart_, PartUI_ *partui_) {
  //
      synth = part_->getSynthEngine();
      part = part_;
      n = n_;
      npart = npart_;
      partui = partui_;
      make_window();
      end();
}

PartKitItem::~PartKitItem() {
  //
      partkititem->hide();
}

void PartUI::cb_Edit_i(Fl_Button*, void*) {
  //
        bool divert = true;
        if (lastkey >= 49 && lastkey <= 56)
        { // not working yet :(
            /*int voiceNum = lastkey - 49;
            if (Fl::event_button() == 3)
            {
                send_data(PART::control::enable, 1, TOPLEVEL::type::Integer, UNUSED, 0);
                adsynenabledcheck->value(1);
                send_data(PART::control::volumeEnable, voiceNum, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet);
                //synth->getGuiMaster()->partui->adnoteui->advoice->nvoice = voiceNum;
                //synth->getGuiMaster()->partui->adnoteui->advoice->voiceonbutton->value(1);
            }
            if (adsynenabledcheck->value() == 1)
            {
                ;
            }*/
            lastkey = -1;
        }
        switch(lastkey)
        {
            case 97: // a
                if (Fl::event_button() == 3)
                {
                    send_data(PART::control::enable, 1, TOPLEVEL::type::Integer, UNUSED, 0);
                    adsynenabledcheck->value(1);
                }

                lastkey = -1;
                if (adsynenabledcheck->value() == 1)
                {
                    showparameters(0,0);
                    checkEngines();
                    seteditname();
                }
                else
                    divert = false;
                break;
            case 115: // s
                if (Fl::event_button() == 3)
                {
                    send_data(PART::control::enable, 1, TOPLEVEL::type::Integer, UNUSED, 1);
                    subsynenabledcheck->value(1);
                }
                lastkey = -1;
                if (subsynenabledcheck->value() == 1)
                {
                showparameters(0,1);
                checkEngines();
                seteditname();
                }
                else
                    divert = false;
                break;
            case 100: // d
            case 112: // p
                if (Fl::event_button() == 3)
                {
                    send_data(PART::control::enable, 1, TOPLEVEL::type::Integer, UNUSED, 2);
                    padsynenabledcheck->value(1);
                }
                lastkey = -1;
                if (padsynenabledcheck->value() == 1)
                {
                    showparameters(0,2);
                    checkEngines();
                    seteditname();
                    lastkey = -1;
                }
                else
                    divert = false;
                break;
            case 107: // k
                lastkey = -1;
                instrumentkitlist->show();
                break;
            case 101: // e
                lastkey = -1;
                partfx->show();
                break;
            default:
                divert = false;
                break;
        }
        if (!divert)
        {
            lastkey = -1;
            instrumenteditwindow->show();
        };
}
void PartUI::cb_Edit(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_Edit_i(o,v);
}

void PartUI::cb_buttontop_i(Fl_Button*, void*) {
  //
          int event = Fl::event_button();
          const char *tmp;
          if (event == FL_LEFT_MOUSE)
          {
              synth->getGuiMaster()->activePart = npart;
              bankui->Show();
          }
          else if (event == FL_RIGHT_MOUSE)
          {
              string oldName =  part->Pname;
              tmp = oldName.c_str();
              tmp = fl_input("Instrument name:", tmp);
              if (tmp != NULL)
              {
                  if( !string(tmp).empty() && string(tmp) != oldName )
                  {
                      if (string(tmp) == "Simple Sound")
                          fl_alert("Can't use name of default sound");
                      else
                      {
                          unsigned char id = miscMsgPush(string(tmp));
                          send_data(PART::control::instrumentName, 0, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, UNUSED, UNUSED, UNUSED, TOPLEVEL::route::lowPriority, id);
                      }
                  }
              }
          };
}
void PartUI::cb_buttontop(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_buttontop_i(o,v);
}

void PartUI::cb_velocitysense_i(WidgetPDial* o, void*) {
  //
          send_data(PART::control::velocitySense, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_velocitysense(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_velocitysense_i(o,v);
}

void PartUI::cb_velocityoffset_i(WidgetPDial* o, void*) {
  //
          send_data(PART::control::velocityOffset, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_velocityoffset(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_velocityoffset_i(o,v);
}

void PartUI::cb_partpan_i(WidgetPDial* o, void*) {
  //;
          if (npart >= *plgroup && npart < (*plgroup + NUM_MIDI_CHANNELS))
              synth->getGuiMaster()->setPanelPartPanWidget(npart % NUM_MIDI_CHANNELS, o->value());

          send_data(PART::control::panning, o->value(), 0);
}
void PartUI::cb_partpan(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_partpan_i(o,v);
}

void PartUI::cb_partvol_i(WidgetPDial* o, void*) {
  //;
          if (npart >= *plgroup && npart < (*plgroup + NUM_MIDI_CHANNELS))
          synth->getGuiMaster()->setPanelPartVolWidget(npart % NUM_MIDI_CHANNELS, o->value());

          send_data(0, o->value(), 0);
}
void PartUI::cb_partvol(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_partvol_i(o,v);
}

void PartUI::cb_enportamento_i(Fl_Check_Button* o, void*) {
  //
          send_data(PART::control::portamento, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_enportamento(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_enportamento_i(o,v);
}

void PartUI::cb_midich_i(Fl_Spinner* o, void*) {
  //
          int tmp = ((int)o->value() -1);
          if (tmp > 15)
          {
              tmp &= 15;
              o->value(tmp +1);
          }
          o->textcolor(FL_BLACK);
          if (npart >= *plgroup && npart < (*plgroup + NUM_MIDI_CHANNELS))
              synth->getGuiMaster()->setPanelPartMidiWidget(npart % NUM_MIDI_CHANNELS, tmp);

          send_data(PART::control::midiChannel, tmp, TOPLEVEL::type::Integer);
}
void PartUI::cb_midich(Fl_Spinner* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_midich_i(o,v);
}

void PartUI::cb_keymode_i(Fl_Choice* o, void*) {
  //
          if (o->value() > 1 && drumMode->value() != 0)
              legatoMode->labelcolor(FL_RED);
          else
              legatoMode->labelcolor(FL_BLACK);
          send_data(PART::control::keyMode, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_keymode(Fl_Choice* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_keymode_i(o,v);
}

Fl_Menu_Item PartUI::menu_keymode[] = {
 {"Poly", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Mono", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Legato", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {0,0,0,0,0,0,0,0,0}
};
Fl_Menu_Item* PartUI::legatoMode = PartUI::menu_keymode + 2;

void PartUI::cb_Controllers_i(Fl_Button*, void*) {
  //
          if (Fl::event_button() != 3)
              ctlwindow->show();
          else
              ctlmidi->show();
}
void PartUI::cb_Controllers(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_Controllers_i(o,v);
}

void PartUI::cb_partkeyshift_i(Fl_Spinner* o, void*) {
  //
          send_data(PART::control::keyShift, o->value(), TOPLEVEL::type::Integer, UNUSED, UNUSED, UNUSED, TOPLEVEL::route::lowPriority);
}
void PartUI::cb_partkeyshift(Fl_Spinner* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_partkeyshift_i(o,v);
}

void PartUI::cb_partkeylimit_i(Fl_Spinner* o, void*) {
  //
          send_data(PART::control::maxNotes, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_partkeylimit(Fl_Spinner* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_partkeylimit_i(o,v);
}

void PartUI::cb_minkcounter1_i(Fl_Spinner* o, void*) {
  //
          int tmp = o->value();
          int other = maxkcounter->value();
          if (tmp > other)
          {
              tmp = other;
              o->value(tmp);
          }

          send_data(PART::control::minNote, tmp, TOPLEVEL::type::Integer);
}
void PartUI::cb_minkcounter1(Fl_Spinner* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_minkcounter1_i(o,v);
}

void PartUI::cb_maxkcounter1_i(Fl_Spinner* o, void*) {
  //
          int tmp = o->value();
          int other = minkcounter->value();
          if (tmp < other)
          {
              tmp = other;
              o->value(tmp);
          }

          send_data(PART::control::maxNote, tmp, TOPLEVEL::type::Integer);
}
void PartUI::cb_maxkcounter1(Fl_Spinner* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_maxkcounter1_i(o,v);
}

void PartUI::cb_Set_i(Fl_Button* o, void*) {
  //
          if (part->lastnote >= 0)
              minkcounter->value(part->lastnote);

          send_data(PART::control::minToLastKey, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_Set(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_Set_i(o,v);
}

void PartUI::cb_R1_i(Fl_Button* o, void*) {
  //
          minkcounter->value(0);
          maxkcounter->value(127);

          send_data(PART::control::resetMinMaxKey, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_R1(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_R1_i(o,v);
}

void PartUI::cb_Set1_i(Fl_Button* o, void*) {
  //
          if (part->lastnote >= 0) maxkcounter->value(part->lastnote);

          send_data(PART::control::maxToLastKey, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_Set1(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_Set1_i(o,v);
}

void PartUI::cb_partGroupEnable_i(Fl_Check_Button* o, void*) {
  //;
        if (o->value() != 1)
        {
            partgroupui->deactivate();
            toSysEfx->deactivate();
        }
        else
        {
            partgroupui->activate();
            toSysEfx->activate();
        }

        if (npart >= *plgroup && npart < (*plgroup + NUM_MIDI_CHANNELS))
        {
            synth->getGuiMaster()->panellistitem[npart % NUM_MIDI_CHANNELS]->partenabled->value(o->value());
            if (o->value() != 1)
                synth->getGuiMaster()->panellistitem[npart % NUM_MIDI_CHANNELS]->panellistitemgroup->deactivate();
            else
            synth->getGuiMaster()->panellistitem[npart % NUM_MIDI_CHANNELS]->panellistitemgroup->activate();
        }

        send_data(PART::control::enable, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_partGroupEnable(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_partGroupEnable_i(o,v);
}

void PartUI::cb_volrng_i(WidgetPDial* o, void*) {
  //
        send_data(PART::control::volumeRange, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_volrng(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_volrng_i(o,v);
}

void PartUI::cb_vol_i(Fl_Check_Button* o, void*) {
  //
        send_data(PART::control::volumeEnable, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_vol(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_vol_i(o,v);
}

void PartUI::cb_panwidth_i(WidgetPDial* o, void*) {
  //
        send_data(PART::control::panningWidth, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_panwidth(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_panwidth_i(o,v);
}

void PartUI::cb_modwh_i(WidgetPDial* o, void*) {
  //
        send_data(PART::control::modWheelDepth, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_modwh(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_modwh_i(o,v);
}

void PartUI::cb_expmwh_i(Fl_Check_Button* o, void*) {
  //
        send_data(PART::control::exponentialModWheel, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_expmwh(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_expmwh_i(o,v);
}

void PartUI::cb_bwdpth_i(WidgetPDial* o, void*) {
  //
        send_data(PART::control::bandwidthDepth, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_bwdpth(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_bwdpth_i(o,v);
}

void PartUI::cb_expbw_i(Fl_Check_Button* o, void*) {
  //
        send_data(134, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_expbw(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_expbw_i(o,v);
}

void PartUI::cb_expr_i(Fl_Check_Button* o, void*) {
  //
        send_data(135, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_expr(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_expr_i(o,v);
}

void PartUI::cb_fmamp_i(Fl_Check_Button* o, void*) {
  //
        send_data(PART::control::FMamplitudeEnable, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_fmamp(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_fmamp_i(o,v);
}

void PartUI::cb_sustain_i(Fl_Check_Button* o, void*) {
  //
        send_data(137, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_sustain(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_sustain_i(o,v);
}

void PartUI::cb_breath_i(Fl_Check_Button* o, void*) {
  //
        send_data(141, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_breath(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_breath_i(o,v);
}

void PartUI::cb_pwheelbrng_i(Fl_Counter* o, void*) {
  //
        send_data(PART::control::pitchWheelRange, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_pwheelbrng(Fl_Counter* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_pwheelbrng_i(o,v);
}

void PartUI::cb_filtq_i(WidgetPDial* o, void*) {
  //
        send_data(PART::control::filterQdepth, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_filtq(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_filtq_i(o,v);
}

void PartUI::cb_fltcut_i(WidgetPDial* o, void*) {
  //
        send_data(PART::control::filterCutoffDepth, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_fltcut(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_fltcut_i(o,v);
}

void PartUI::cb_Close_i(Fl_Button*, void*) {
  //
        ctlwindow->hide();
}
void PartUI::cb_Close(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_Close_i(o,v);
}

void PartUI::cb_Reset_i(Fl_Button* o, void*) {
  //
        send_data(PART::control::resetAllControllers, o->value(), TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet);
}
void PartUI::cb_Reset(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_Reset_i(o,v);
}

void PartUI::cb_cfdpth_i(WidgetPDial* o, void*) {
  //
          send_data(PART::control::resonanceCenterFrequencyDepth, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_cfdpth(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_cfdpth_i(o,v);
}

void PartUI::cb_rbwdpth_i(WidgetPDial* o, void*) {
  //
          send_data(PART::control::resonanceBandwidthDepth, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_rbwdpth(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_rbwdpth_i(o,v);
}

void PartUI::cb_prtime_i(WidgetPDial* o, void*) {
  //
          send_data(PART::control::portamentoTime, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_prtime(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_prtime_i(o,v);
}

void PartUI::cb_timedu_i(WidgetPDial* o, void*) {
  //
          send_data(PART::control::portamentoTimeStretch, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_timedu(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_timedu_i(o,v);
}

void PartUI::cb_thresh_i(Fl_Counter* o, void*) {
  //
          send_data(PART::control::portamentoThreshold, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_thresh(Fl_Counter* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_thresh_i(o,v);
}

void PartUI::cb_thtype_i(Fl_Check_Button* o, void*) {
  //
          send_data(PART::control::portamentoThresholdType, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_thtype(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_thtype_i(o,v);
}

void PartUI::cb_propta_i(WidgetPDial* o, void*) {
  //
          send_data(PART::control::proportionalPortamentoRate, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_propta(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_propta_i(o,v);
}

void PartUI::cb_proptb_i(WidgetPDial* o, void*) {
  //
          send_data(PART::control::proportionalPortamentoDepth, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_proptb(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_proptb_i(o,v);
}

void PartUI::cb_rcv_i(Fl_Check_Button* o, void*) {
  //
          send_data(PART::control::receivePortamento, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_rcv(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_rcv_i(o,v);
}

void PartUI::cb_proprt_i(Fl_Check_Button* o, void*) {
  //
          if(o->value())
          {
              propta->activate();
              proptb->activate();
          }
          else
          {
              propta->deactivate();
              proptb->deactivate();
          }
          send_data(PART::control::enableProportionalPortamento, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_proprt(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_proprt_i(o,v);
}

void PartUI::cb_modulation_i(WidgetPDial* o, void*) {
  //
        send_data(PART::control::midiModWheel, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_modulation(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_modulation_i(o,v);
}

void PartUI::cb_expression_i(WidgetPDial* o, void*) {
  //
        send_data(PART::control::midiExpression,  o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_expression(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_expression_i(o,v);
}

void PartUI::cb_filterq_i(WidgetPDial* o, void*) {
  //
        send_data(PART::control::midiFilterQ, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_filterq(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_filterq_i(o,v);
}

void PartUI::cb_filtercutoff_i(WidgetPDial* o, void*) {
  //
        send_data(PART::control::midiFilterCutoff, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_filtercutoff(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_filtercutoff_i(o,v);
}

void PartUI::cb_masterbandwidth_i(WidgetPDial* o, void*) {
  //
        send_data(PART::control::midiBandwidth, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_masterbandwidth(WidgetPDial* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_masterbandwidth_i(o,v);
}

void PartUI::cb_Close1_i(Fl_Button*, void*) {
  //
        ctlmidi->hide();
}
void PartUI::cb_Close1(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_Close1_i(o,v);
}

void PartUI::cb_inseffnocounter_i(Fl_Spinner* o, void*) {
  //
        ninseff = o->value() - 1;
        insefftype->value(part->partefx[ninseff]->geteffect());

        inseffectui->refresh(part->partefx[ninseff], npart, ninseff);
        int x = part->Pefxroute[ninseff];
        if (x == 127)
            x = 1;
        bypasseff->value(part->Pefxbypass[ninseff]);
        sendtochoice->value(x);

        send_data(PART::control::effectNumber, ninseff, TOPLEVEL::type::Integer, UNUSED, ninseff, TOPLEVEL::insert::partEffectSelect);
}
void PartUI::cb_inseffnocounter(Fl_Spinner* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_inseffnocounter_i(o,v);
}

void PartUI::cb_insefftype_i(Fl_Choice* o, void*) {
  //
        send_data(PART::control::effectType, o->value(), TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, UNUSED, ninseff, TOPLEVEL::insert::partEffectSelect);
}
void PartUI::cb_insefftype(Fl_Choice* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_insefftype_i(o,v);
}

Fl_Menu_Item PartUI::menu_insefftype[] = {
 {"No Effect", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Reverb", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Echo", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Chorus", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Phaser", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"AlienWah", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Distortion", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"EQ", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"DynFilter", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void PartUI::cb_Close2_i(Fl_Button*, void*) {
  //
        partfx->hide();
        if ((Fl::event_button() == 3))
            synth->getGuiMaster()->partui->instrumenteditwindow->show();
}
void PartUI::cb_Close2(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_Close2_i(o,v);
}

void PartUI::cb_sendtochoice_i(Fl_Choice* o, void*) {
  //
        send_data(PART::control::effectDestination, o->value(), TOPLEVEL::type::Integer, UNUSED, ninseff, TOPLEVEL::insert::partEffectSelect);
}
void PartUI::cb_sendtochoice(Fl_Choice* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_sendtochoice_i(o,v);
}

Fl_Menu_Item PartUI::menu_sendtochoice[] = {
 {"Next Effect", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Part Out", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {"Dry Out", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 10, 0},
 {0,0,0,0,0,0,0,0,0}
};

void PartUI::cb_bypasseff_i(Fl_Check_Button* o, void*) {
  //
        send_data(PART::control::effectBypass, o->value(), TOPLEVEL::type::Integer, UNUSED, ninseff, TOPLEVEL::insert::partEffectSelect);
}
void PartUI::cb_bypasseff(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_bypasseff_i(o,v);
}

void PartUI::cb_C_i(Fl_Button*, void*) {
  //
        synth->getGuiMaster()->getPresetsUi()->copy(part->partefx[ninseff]);
}
void PartUI::cb_C(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_C_i(o,v);
}

void PartUI::cb_P_i(Fl_Button*, void*) {
  //
        synth->getGuiMaster()->getPresetsUi()->paste(part->partefx[ninseff], inseffectui);
}
void PartUI::cb_P(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_P_i(o,v);
}

void PartUI::cb_Close3_i(Fl_Button*, void*) {
  //
        instrumentkitlist->hide();
        if ((Fl::event_button() == 3))
        synth->getGuiMaster()->partui->instrumenteditwindow->show();
}
void PartUI::cb_Close3(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_Close3_i(o,v);
}

void PartUI::cb_kitMode_i(Fl_Choice* o, void*) {
  //
        int tmp = o->value();
        partKitOn = tmp > 0;
        if (partKitOn)
            kitlist->activate();
        else
            kitlist->deactivate();

        send_data(PART::control::kitMode, tmp, TOPLEVEL::type::Integer);
}
void PartUI::cb_kitMode(Fl_Choice* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_kitMode_i(o,v);
}

Fl_Menu_Item PartUI::menu_kitMode[] = {
 {"     Off", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"    Multi", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"  Single", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Crossfade", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {0,0,0,0,0,0,0,0,0}
};

void PartUI::cb_drumMode_i(Fl_Check_Button* o, void*) {
  //
        send_data(PART::control::drumMode, o->value(), TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet);
}
void PartUI::cb_drumMode(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_drumMode_i(o,v);
}

void PartUI::cb_adsynenabledcheck_i(Fl_Check_Button* o, void*) {
  //
            int x = o->value();
            if (x == 0)
                adeditbutton->deactivate();
            else
                adeditbutton->activate();
            partkititem[0]->adcheck->value(x);
            if (partKitOn)
            {
            if (x == 0)
                partkititem[0]->adeditbutton->deactivate();
            else
                partkititem[0]->adeditbutton->activate();
            }
            checkEngines();

            send_data(PART::control::enable, o->value(), TOPLEVEL::type::Integer, UNUSED, 0);
}
void PartUI::cb_adsynenabledcheck(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->parent()->user_data()))->cb_adsynenabledcheck_i(o,v);
}

void PartUI::cb_adeditbutton1_i(Fl_Button*, void*) {
  //
            showparameters(0,0);
            checkEngines();
            seteditname();
            if ((Fl::event_button() == 3))
                instrumenteditwindow->hide();
}
void PartUI::cb_adeditbutton1(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->parent()->user_data()))->cb_adeditbutton1_i(o,v);
}

void PartUI::cb_subsynenabledcheck_i(Fl_Check_Button* o, void*) {
  //
            int x = o->value();
            if (x == 0)
                subeditbutton->deactivate();
            else
                subeditbutton->activate();
            partkititem[0]->subcheck->value(x);
            if (partKitOn)
            {
            if (x == 0)
                partkititem[0]->subeditbutton->deactivate();
            else
                partkititem[0]->subeditbutton->activate();
            }
            checkEngines();

            send_data(PART::control::enable, o->value(), TOPLEVEL::type::Integer, UNUSED, 1);
}
void PartUI::cb_subsynenabledcheck(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->parent()->user_data()))->cb_subsynenabledcheck_i(o,v);
}

void PartUI::cb_subeditbutton1_i(Fl_Button*, void*) {
  //
            showparameters(0,1);
            checkEngines();
            seteditname();
            if ((Fl::event_button() == 3))
                instrumenteditwindow->hide();
}
void PartUI::cb_subeditbutton1(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->parent()->user_data()))->cb_subeditbutton1_i(o,v);
}

void PartUI::cb_padsynenabledcheck_i(Fl_Check_Button* o, void*) {
  //
            int x = o->value();
            if (x == 0)
                padeditbutton->deactivate();
            else
                padeditbutton->activate();
            partkititem[0]->padcheck->value(x);
            if (partKitOn)
            {
            if (x == 0)
                partkititem[0]->padeditbutton->deactivate();
            else
                partkititem[0]->padeditbutton->activate();
            }
            checkEngines();

            send_data(PART::control::enable, o->value(), TOPLEVEL::type::Integer, UNUSED, 2);
}
void PartUI::cb_padsynenabledcheck(Fl_Check_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->parent()->user_data()))->cb_padsynenabledcheck_i(o,v);
}

void PartUI::cb_padeditbutton1_i(Fl_Button*, void*) {
  //
            showparameters(0,2);
            checkEngines();
            seteditname();
            if ((Fl::event_button() == 3))
                instrumenteditwindow->hide();
}
void PartUI::cb_padeditbutton1(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->parent()->user_data()))->cb_padeditbutton1_i(o,v);
}

void PartUI::cb_Kit_i(Fl_Button*, void*) {
  //
          instrumentkitlist->show();
          if ((Fl::event_button() == 3))
              instrumenteditwindow->hide();
}
void PartUI::cb_Kit(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_Kit_i(o,v);
}

void PartUI::cb_Effects_i(Fl_Button*, void*) {
  //
          partfx->show();
          if ((Fl::event_button() == 3))
              instrumenteditwindow->hide();
}
void PartUI::cb_Effects(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_Effects_i(o,v);
}

void PartUI::cb_Default_i(Fl_Button*, void*) {
  //
            int param = 128;
            if (Fl::event_state(FL_CTRL))
            param = 129;
            send_data(PART::control::defaultInstrumentCopyright, 0, TOPLEVEL::type::Integer | TOPLEVEL::source::UpdateAfterSet, 255, 255, 255, param);
}
void PartUI::cb_Default(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_Default_i(o,v);
}

void PartUI::cb_copyright_i(Fl_Input* o, void*) {
  //
          part->info.Pauthor = string(o->value());
}
void PartUI::cb_copyright(Fl_Input* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_copyright_i(o,v);
}

void PartUI::cb_Comments_i(Fl_Input* o, void*) {
  //
          part->info.Pcomments = string(o->value());
}
void PartUI::cb_Comments(Fl_Input* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_Comments_i(o,v);
}

void PartUI::cb_Type_i(Fl_Choice* o, void*) {
  //
          part->info.Ptype=o->value();
}
void PartUI::cb_Type(Fl_Choice* o, void* v) {
  ((PartUI*)(o->parent()->parent()->user_data()))->cb_Type_i(o,v);
}

Fl_Menu_Item PartUI::menu_Type[] = {
 {"--------------------------", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Piano", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Chromatic Percussion", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Organ", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Guitar", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Bass", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Solo Strings", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Ensemble", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Brass", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Reed", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Pipe", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Synth Lead", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Synth Pad", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Synth Effects", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Ethnic", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Percussive", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {"Sound Effects", 0,  0, 0, 0, (uchar)FL_NORMAL_LABEL, 1, 11, 0},
 {0,0,0,0,0,0,0,0,0}
};

void PartUI::cb_humanise_i(mwheel_val_slider_rev* o, void*) {
  //

        send_data(PART::control::humanise, o->value(), TOPLEVEL::type::Integer);
}
void PartUI::cb_humanise(mwheel_val_slider_rev* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_humanise_i(o,v);
}

void PartUI::cb_Close4_i(Fl_Button*, void*) {
  instrumenteditwindow->hide();
}
void PartUI::cb_Close4(Fl_Button* o, void* v) {
  ((PartUI*)(o->parent()->user_data()))->cb_Close4_i(o,v);
}

Fl_Group* PartUI::make_window() {
  { partgroup = new Fl_Group(0, 0, 380, 170);
    partgroup->box(FL_NO_BOX);
    partgroup->color(FL_BACKGROUND_COLOR);
    partgroup->selection_color(FL_BACKGROUND_COLOR);
    partgroup->labeltype(FL_NO_LABEL);
    partgroup->labelfont(0);
    partgroup->labelsize(14);
    partgroup->labelcolor(FL_FOREGROUND_COLOR);
    partgroup->user_data((void*)(this));
    partgroup->align(Fl_Align(FL_ALIGN_TOP));
    partgroup->when(FL_WHEN_RELEASE);
    { Fl_Group* o = partgroupui = new Fl_Group(0, 0, 378, 168);
      { Fl_Button* o = new Fl_Button(330, 6, 42, 22, "Edit");
        o->box(FL_PLASTIC_UP_BOX);
        o->color((Fl_Color)22);
        o->labelfont(1);
        o->labelsize(12);
        o->callback((Fl_Callback*)cb_Edit);
      } // Fl_Button* o
      { instrumentaddbox = new Fl_Box(136, 9, 63, 16);
        instrumentaddbox->box(FL_FLAT_BOX);
      } // Fl_Box* instrumentaddbox
      { instrumentsubbox = new Fl_Box(199, 9, 63, 16);
        instrumentsubbox->box(FL_FLAT_BOX);
      } // Fl_Box* instrumentsubbox
      { instrumentpadbox = new Fl_Box(262, 9, 63, 16);
        instrumentpadbox->box(FL_FLAT_BOX);
      } // Fl_Box* instrumentpadbox
      { instrumentlabel = new Fl_Button(134, 7, 192, 20);
        instrumentlabel->tooltip("Left mouse button: choose/save/.. from/to bank, Right button: instrument name");
        instrumentlabel->box(FL_THIN_DOWN_FRAME);
        instrumentlabel->labelsize(12);
        instrumentlabel->align(Fl_Align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE));
        setinstrumentlabel();
      } // Fl_Button* instrumentlabel
      { buttontop = new Fl_Button(134, 7, 192, 20);
        buttontop->tooltip("Left mouse button: choose/save/.. from/to bank, Right button: instrument name");
        buttontop->box(FL_THIN_DOWN_FRAME);
        buttontop->labeltype(FL_NO_LABEL);
        buttontop->labelsize(12);
        buttontop->callback((Fl_Callback*)cb_buttontop);
        buttontop->align(Fl_Align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE));
      } // Fl_Button* buttontop
      { WidgetPDial* o = velocitysense = new WidgetPDial(200, 40, 28, 28, "Velocity\nSense");
        velocitysense->box(FL_ROUND_UP_BOX);
        velocitysense->color(FL_BACKGROUND_COLOR);
        velocitysense->selection_color(FL_INACTIVE_COLOR);
        velocitysense->labeltype(FL_NORMAL_LABEL);
        velocitysense->labelfont(0);
        velocitysense->labelsize(10);
        velocitysense->labelcolor(FL_FOREGROUND_COLOR);
        velocitysense->maximum(127);
        velocitysense->step(1);
        velocitysense->callback((Fl_Callback*)cb_velocitysense);
        velocitysense->align(Fl_Align(FL_ALIGN_BOTTOM));
        velocitysense->when(FL_WHEN_CHANGED);
        o->value(part->Pvelsns);
        o->setValueType(VC_AmpVelocitySense);
      } // WidgetPDial* velocitysense
      { WidgetPDial* o = velocityoffset = new WidgetPDial(244, 40, 28, 28, "Velocity\nOffset");
        velocityoffset->box(FL_ROUND_UP_BOX);
        velocityoffset->color(FL_BACKGROUND_COLOR);
        velocityoffset->selection_color(FL_INACTIVE_COLOR);
        velocityoffset->labeltype(FL_NORMAL_LABEL);
        velocityoffset->labelfont(0);
        velocityoffset->labelsize(10);
        velocityoffset->labelcolor(FL_FOREGROUND_COLOR);
        velocityoffset->maximum(127);
        velocityoffset->step(1);
        velocityoffset->callback((Fl_Callback*)cb_velocityoffset);
        velocityoffset->align(Fl_Align(FL_ALIGN_BOTTOM));
        velocityoffset->when(FL_WHEN_CHANGED);
        o->value(part->Pveloffs);
      } // WidgetPDial* velocityoffset
      { WidgetPDial* o = partpan = new WidgetPDial(289, 39, 32, 32, "Pan");
        partpan->box(FL_ROUND_UP_BOX);
        partpan->color(FL_BACKGROUND_COLOR);
        partpan->selection_color(FL_INACTIVE_COLOR);
        partpan->labeltype(FL_NORMAL_LABEL);
        partpan->labelfont(0);
        partpan->labelsize(10);
        partpan->labelcolor(FL_FOREGROUND_COLOR);
        partpan->maximum(127);
        partpan->step(1);
        partpan->callback((Fl_Callback*)cb_partpan);
        partpan->align(Fl_Align(FL_ALIGN_BOTTOM));
        partpan->when(FL_WHEN_CHANGED);
        o->setValueType(VC_PanningStd);
        o->value(part->Ppanning);
      } // WidgetPDial* partpan
      { WidgetPDial* o = partvol = new WidgetPDial(335, 39, 32, 32, "Volume");
        partvol->box(FL_ROUND_UP_BOX);
        partvol->color(FL_BACKGROUND_COLOR);
        partvol->selection_color(FL_INACTIVE_COLOR);
        partvol->labeltype(FL_NORMAL_LABEL);
        partvol->labelfont(0);
        partvol->labelsize(10);
        partvol->labelcolor(FL_FOREGROUND_COLOR);
        partvol->maximum(127);
        partvol->step(1);
        partvol->callback((Fl_Callback*)cb_partvol);
        partvol->align(Fl_Align(FL_ALIGN_BOTTOM));
        partvol->when(FL_WHEN_CHANGED);
        o->setValueType(VC_PartVolume);
        o->value(part->Pvolume);
      } // WidgetPDial* partvol
      { Fl_Check_Button* o = enportamento = new Fl_Check_Button(83, 61, 17, 15, "Portamento");
        enportamento->tooltip("Enable/Disable the portamento");
        enportamento->box(FL_THIN_UP_BOX);
        enportamento->down_box(FL_DOWN_BOX);
        enportamento->color((Fl_Color)237);
        enportamento->labelsize(11);
        enportamento->callback((Fl_Callback*)cb_enportamento);
        enportamento->align(Fl_Align(FL_ALIGN_RIGHT));
        o->value(part->ctl->portamento.portamento);
      } // Fl_Check_Button* enportamento
      { Fl_Spinner* o = midich = new Fl_Spinner(31, 36, 40, 19, "Midi");
        midich->tooltip("MIDI channel for this part");
        midich->labelsize(11);
        midich->maximum(16);
        midich->textsize(11);
        midich->callback((Fl_Callback*)cb_midich);
        o->value(part->Prcvchn + 1);
        if (part->Prcvchn < NUM_MIDI_CHANNELS) o->textcolor(FL_BLACK); else o->textcolor(FL_WHITE);
      } // Fl_Spinner* midich
      { Fl_Choice* o = keymode = new Fl_Choice(83, 36, 68, 19, "Mode");
        keymode->tooltip("Poly, Mono or Legato mode");
        keymode->down_box(FL_BORDER_BOX);
        keymode->selection_color(FL_BACKGROUND_COLOR);
        keymode->labelsize(11);
        keymode->textfont(1);
        keymode->textsize(11);
        keymode->callback((Fl_Callback*)cb_keymode);
        keymode->align(Fl_Align(FL_ALIGN_RIGHT));
        keymode->menu(menu_keymode);
        int tmp = synth->ReadPartKeyMode(npart);
        if (tmp > 1) o->value(2); else o->value(tmp);
      } // Fl_Choice* keymode
      { Fl_Button* o = new Fl_Button(8, 81, 167, 25, "Controllers");
        o->tooltip("Left mouse button: Controller range settings, Right mouse button: MIDI CCs");
        o->box(FL_PLASTIC_UP_BOX);
        o->color((Fl_Color)222);
        o->labelsize(12);
        o->callback((Fl_Callback*)cb_Controllers);
      } // Fl_Button* o
      { Fl_Spinner* o = partkeyshift = new Fl_Spinner(194, 111, 38, 20, "Key Shift");
        partkeyshift->labelsize(10);
        partkeyshift->minimum(-36);
        partkeyshift->maximum(36);
        partkeyshift->textsize(11);
        partkeyshift->callback((Fl_Callback*)cb_partkeyshift);
        o->range(MIN_KEY_SHIFT, MAX_KEY_SHIFT);o->step(1.0);
        o->value(part->Pkeyshift - 64);
      } // Fl_Spinner* partkeyshift
      { Fl_Spinner* o = partkeylimit = new Fl_Spinner(194, 143, 38, 20, "Key Limit");
        partkeylimit->tooltip("Maximum keys for this part");
        partkeylimit->labelsize(10);
        partkeylimit->value(20);
        partkeylimit->textsize(11);
        partkeylimit->callback((Fl_Callback*)cb_partkeylimit);
        o->range(1, POLIPHONY - 20); // enough for one part!
        o->value(part->Pkeylimit);
      } // Fl_Spinner* partkeylimit
      { Fl_Spinner* o = minkcounter = new Fl_Spinner(57, 111, 42, 20, "Min Note");
        minkcounter->tooltip("Minimum note the part receives");
        minkcounter->labelsize(10);
        minkcounter->minimum(0);
        minkcounter->maximum(127);
        minkcounter->textsize(11);
        minkcounter->callback((Fl_Callback*)cb_minkcounter1);
        o->range(0.0, 127.0);o->step(1.0);
        o->value(part->Pminkey);
      } // Fl_Spinner* minkcounter
      { Fl_Spinner* o = maxkcounter = new Fl_Spinner(57, 143, 42, 20, "Max Note");
        maxkcounter->tooltip("Maximum note the part receives");
        maxkcounter->labelsize(10);
        maxkcounter->minimum(0);
        maxkcounter->maximum(127);
        maxkcounter->textsize(11);
        maxkcounter->callback((Fl_Callback*)cb_maxkcounter1);
        o->range(0.0, 127.0);o->step(1.0);
        o->value(part->Pmaxkey);
      } // Fl_Spinner* maxkcounter
      { Fl_Button* o = new Fl_Button(104, 111, 30, 16, "Set");
        o->tooltip("Set minimum note to the last note played");
        o->box(FL_PLASTIC_UP_BOX);
        o->labelsize(10);
        o->callback((Fl_Callback*)cb_Set);
      } // Fl_Button* o
      { Fl_Button* o = new Fl_Button(104, 129, 30, 16, "R");
        o->tooltip("Reset the minimum key to 0 and maximum key to 127");
        o->box(FL_PLASTIC_UP_BOX);
        o->labelfont(1);
        o->labelsize(11);
        o->callback((Fl_Callback*)cb_R1);
      } // Fl_Button* o
      { Fl_Button* o = new Fl_Button(104, 147, 30, 16, "Set");
        o->tooltip("Set maximum note to the last note played");
        o->box(FL_PLASTIC_UP_BOX);
        o->labelsize(10);
        o->callback((Fl_Callback*)cb_Set1);
      } // Fl_Button* o
      { Fl_Box* o = new Fl_Box(240, 96, 134, 69);
        o->box(FL_ENGRAVED_FRAME);
      } // Fl_Box* o
      if (part->Penabled != 1) o->deactivate();
      partgroupui->end();
    } // Fl_Group* partgroupui
    { Fl_Check_Button* o = partGroupEnable = new Fl_Check_Button(58, 59, 20, 20, "Enabled");
      partGroupEnable->down_box(FL_DOWN_BOX);
      partGroupEnable->labelsize(11);
      partGroupEnable->callback((Fl_Callback*)cb_partGroupEnable);
      partGroupEnable->align(Fl_Align(FL_ALIGN_LEFT));
      o->value(part->Penabled == 1);
    } // Fl_Check_Button* partGroupEnable
    { toSysEfx = new Fl_Scroll(245, 114, 125, 48, "System Effect Sends");
      toSysEfx->labelsize(11);
      { Fl_Pack* o = new Fl_Pack(247, 118, 122, 39, "To Sys Efx");
        o->type(1);
        o->labeltype(FL_NO_LABEL);
        o->labelsize(11);
        o->align(Fl_Align(FL_ALIGN_CENTER));
        o->spacing(7);
        //
              for (int i = 0; i < NUM_SYS_EFX; ++i)
            {
              psyef[i] = new PartSysEffSend(0, 0, 25, 25);
              psyef[i]->init(npart, i, synth);
            }
        o->end();
      } // Fl_Pack* o
      if (part->Penabled != 1)
        {
            toSysEfx->deactivate();
        }
        else
        {
           toSysEfx->activate();
        }
      toSysEfx->end();
    } // Fl_Scroll* toSysEfx
    partgroup->end();
  } // Fl_Group* partgroup
  { Fl_Double_Window* o = ctlwindow = new Fl_Double_Window(505, 130, "Controllers");
    ctlwindow->user_data((void*)(this));
    { WidgetPDial* o = volrng = new WidgetPDial(132, 55, 30, 30, "Vol Rng");
      volrng->tooltip("Volume Range");
      volrng->box(FL_OVAL_BOX);
      volrng->color(FL_BACKGROUND_COLOR);
      volrng->selection_color(FL_INACTIVE_COLOR);
      volrng->labeltype(FL_NORMAL_LABEL);
      volrng->labelfont(0);
      volrng->labelsize(10);
      volrng->labelcolor(FL_FOREGROUND_COLOR);
      volrng->minimum(64);
      volrng->maximum(127);
      volrng->step(1);
      volrng->callback((Fl_Callback*)cb_volrng);
      volrng->align(Fl_Align(FL_ALIGN_BOTTOM));
      volrng->when(FL_WHEN_CHANGED);
      o->value(part->ctl->volume.data);
    } // WidgetPDial* volrng
    { Fl_Check_Button* o = vol = new Fl_Check_Button(175, 81, 45, 18, "Vol");
      vol->tooltip("Volume enable");
      vol->box(FL_THIN_UP_BOX);
      vol->down_box(FL_DOWN_BOX);
      vol->labelsize(10);
      vol->callback((Fl_Callback*)cb_vol);
      o->value(part->ctl->volume.receive);
    } // Fl_Check_Button* vol
    { WidgetPDial* o = panwidth = new WidgetPDial(10, 55, 30, 30, "PanWdth");
      panwidth->tooltip("Panning Width");
      panwidth->box(FL_OVAL_BOX);
      panwidth->color(FL_BACKGROUND_COLOR);
      panwidth->selection_color(FL_INACTIVE_COLOR);
      panwidth->labeltype(FL_NORMAL_LABEL);
      panwidth->labelfont(0);
      panwidth->labelsize(10);
      panwidth->labelcolor(FL_FOREGROUND_COLOR);
      panwidth->maximum(64);
      panwidth->step(1);
      panwidth->callback((Fl_Callback*)cb_panwidth);
      panwidth->align(Fl_Align(FL_ALIGN_BOTTOM));
      panwidth->when(FL_WHEN_CHANGED);
      o->value(part->ctl->panning.depth);
    } // WidgetPDial* panwidth
    { WidgetPDial* o = modwh = new WidgetPDial(50, 10, 30, 30, "ModWh");
      modwh->tooltip("Modulation Wheel depth");
      modwh->box(FL_OVAL_BOX);
      modwh->color(FL_BACKGROUND_COLOR);
      modwh->selection_color(FL_INACTIVE_COLOR);
      modwh->labeltype(FL_NORMAL_LABEL);
      modwh->labelfont(0);
      modwh->labelsize(10);
      modwh->labelcolor(FL_FOREGROUND_COLOR);
      modwh->maximum(127);
      modwh->step(1);
      modwh->callback((Fl_Callback*)cb_modwh);
      modwh->align(Fl_Align(FL_ALIGN_BOTTOM));
      modwh->when(FL_WHEN_CHANGED);
      o->value(part->ctl->modwheel.depth);
    } // WidgetPDial* modwh
    { Fl_Check_Button* o = expmwh = new Fl_Check_Button(10, 15, 40, 25, "Exp MWh");
      expmwh->tooltip("Exponential modulation wheel");
      expmwh->down_box(FL_DOWN_BOX);
      expmwh->labelsize(10);
      expmwh->callback((Fl_Callback*)cb_expmwh);
      expmwh->align(Fl_Align(132|FL_ALIGN_INSIDE));
      o->value(part->ctl->modwheel.exponential);
    } // Fl_Check_Button* expmwh
    { WidgetPDial* o = bwdpth = new WidgetPDial(132, 10, 30, 30, "BwDpth");
      bwdpth->tooltip("BandWidth depth");
      bwdpth->box(FL_OVAL_BOX);
      bwdpth->color(FL_BACKGROUND_COLOR);
      bwdpth->selection_color(FL_INACTIVE_COLOR);
      bwdpth->labeltype(FL_NORMAL_LABEL);
      bwdpth->labelfont(0);
      bwdpth->labelsize(10);
      bwdpth->labelcolor(FL_FOREGROUND_COLOR);
      bwdpth->maximum(127);
      bwdpth->step(1);
      bwdpth->callback((Fl_Callback*)cb_bwdpth);
      bwdpth->align(Fl_Align(FL_ALIGN_BOTTOM));
      bwdpth->when(FL_WHEN_CHANGED);
      o->value(part->ctl->bandwidth.depth);
    } // WidgetPDial* bwdpth
    { Fl_Check_Button* o = expbw = new Fl_Check_Button(92, 15, 35, 25, "Exp BW");
      expbw->tooltip("Exponential BandWidth Controller");
      expbw->down_box(FL_DOWN_BOX);
      expbw->labelsize(10);
      expbw->callback((Fl_Callback*)cb_expbw);
      expbw->align(Fl_Align(132|FL_ALIGN_INSIDE));
      o->value(part->ctl->bandwidth.exponential);
    } // Fl_Check_Button* expbw
    { Fl_Check_Button* o = expr = new Fl_Check_Button(175, 59, 45, 18, "Expr");
      expr->tooltip("Expression enable");
      expr->box(FL_THIN_UP_BOX);
      expr->down_box(FL_DOWN_BOX);
      expr->labelsize(10);
      expr->callback((Fl_Callback*)cb_expr);
      o->value(part->ctl->expression.receive);
    } // Fl_Check_Button* expr
    { Fl_Check_Button* o = fmamp = new Fl_Check_Button(225, 59, 60, 18, "FMamp");
      fmamp->tooltip("FM amplitude enable");
      fmamp->box(FL_THIN_UP_BOX);
      fmamp->down_box(FL_DOWN_BOX);
      fmamp->labelsize(10);
      fmamp->callback((Fl_Callback*)cb_fmamp);
      o->value(part->ctl->fmamp.receive);
    } // Fl_Check_Button* fmamp
    { Fl_Check_Button* o = sustain = new Fl_Check_Button(225, 81, 60, 18, "Sustain");
      sustain->tooltip("Sustain pedal enable");
      sustain->box(FL_THIN_UP_BOX);
      sustain->down_box(FL_DOWN_BOX);
      sustain->labelsize(10);
      sustain->callback((Fl_Callback*)cb_sustain);
      o->value(part->ctl->sustain.receive);
    } // Fl_Check_Button* sustain
    { Fl_Check_Button* o = breath = new Fl_Check_Button(225, 38, 60, 18, "Breath");
      breath->tooltip("Breath Control enable");
      breath->box(FL_THIN_UP_BOX);
      breath->down_box(FL_DOWN_BOX);
      breath->labelsize(10);
      breath->callback((Fl_Callback*)cb_breath);
      o->value(part->PbreathControl == 2);
    } // Fl_Check_Button* breath
    { Fl_Counter* o = pwheelbrng = new Fl_Counter(174, 15, 110, 20, "PWheel Rng (cents)");
      pwheelbrng->tooltip("Pitch Wheel Bend Range (cents)");
      pwheelbrng->color((Fl_Color)237);
      pwheelbrng->selection_color(FL_FOREGROUND_COLOR);
      pwheelbrng->labelsize(10);
      pwheelbrng->minimum(-6400);
      pwheelbrng->maximum(6400);
      pwheelbrng->step(1);
      pwheelbrng->callback((Fl_Callback*)cb_pwheelbrng);
      pwheelbrng->align(Fl_Align(FL_ALIGN_TOP));
      o->value(part->ctl->pitchwheel.bendrange);
      o->lstep(100);
    } // Fl_Counter* pwheelbrng
    { WidgetPDial* o = filtq = new WidgetPDial(50, 55, 30, 30, "FltQ");
      filtq->tooltip("Filter Q depth");
      filtq->box(FL_OVAL_BOX);
      filtq->color(FL_BACKGROUND_COLOR);
      filtq->selection_color(FL_INACTIVE_COLOR);
      filtq->labeltype(FL_NORMAL_LABEL);
      filtq->labelfont(0);
      filtq->labelsize(10);
      filtq->labelcolor(FL_FOREGROUND_COLOR);
      filtq->maximum(127);
      filtq->step(1);
      filtq->callback((Fl_Callback*)cb_filtq);
      filtq->align(Fl_Align(FL_ALIGN_BOTTOM));
      filtq->when(FL_WHEN_CHANGED);
      o->value(part->ctl->filterq.depth);
    } // WidgetPDial* filtq
    { WidgetPDial* o = fltcut = new WidgetPDial(90, 55, 30, 30, "FltCut");
      fltcut->tooltip("Filter Cutoff depth");
      fltcut->box(FL_OVAL_BOX);
      fltcut->color(FL_BACKGROUND_COLOR);
      fltcut->selection_color(FL_INACTIVE_COLOR);
      fltcut->labeltype(FL_NORMAL_LABEL);
      fltcut->labelfont(0);
      fltcut->labelsize(10);
      fltcut->labelcolor(FL_FOREGROUND_COLOR);
      fltcut->maximum(127);
      fltcut->step(1);
      fltcut->callback((Fl_Callback*)cb_fltcut);
      fltcut->align(Fl_Align(FL_ALIGN_BOTTOM));
      fltcut->when(FL_WHEN_CHANGED);
      o->value(part->ctl->filtercutoff.depth);
    } // WidgetPDial* fltcut
    { Fl_Button* o = new Fl_Button(405, 105, 95, 20, "Close");
      o->box(FL_THIN_UP_BOX);
      o->callback((Fl_Callback*)cb_Close);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(5, 105, 210, 20, "Reset all controllers");
      o->box(FL_THIN_UP_BOX);
      o->callback((Fl_Callback*)cb_Reset);
    } // Fl_Button* o
    { Fl_Group* o = new Fl_Group(290, 15, 45, 85, "Resonance");
      o->box(FL_ENGRAVED_BOX);
      o->labelfont(1);
      o->labelsize(10);
      o->align(Fl_Align(FL_ALIGN_TOP_LEFT));
      { WidgetPDial* o = cfdpth = new WidgetPDial(300, 20, 25, 25, "CFdpth");
        cfdpth->tooltip("Center Frequency controller Depth");
        cfdpth->box(FL_OVAL_BOX);
        cfdpth->color(FL_BACKGROUND_COLOR);
        cfdpth->selection_color(FL_INACTIVE_COLOR);
        cfdpth->labeltype(FL_NORMAL_LABEL);
        cfdpth->labelfont(0);
        cfdpth->labelsize(10);
        cfdpth->labelcolor(FL_FOREGROUND_COLOR);
        cfdpth->maximum(127);
        cfdpth->step(1);
        cfdpth->callback((Fl_Callback*)cb_cfdpth);
        cfdpth->align(Fl_Align(FL_ALIGN_BOTTOM));
        cfdpth->when(FL_WHEN_CHANGED);
        o->value(part->ctl->resonancecenter.depth);
      } // WidgetPDial* cfdpth
      { WidgetPDial* o = rbwdpth = new WidgetPDial(300, 60, 25, 25, "BWdpth");
        rbwdpth->tooltip("BandWidth controller depth");
        rbwdpth->box(FL_OVAL_BOX);
        rbwdpth->color(FL_BACKGROUND_COLOR);
        rbwdpth->selection_color(FL_INACTIVE_COLOR);
        rbwdpth->labeltype(FL_NORMAL_LABEL);
        rbwdpth->labelfont(0);
        rbwdpth->labelsize(10);
        rbwdpth->labelcolor(FL_FOREGROUND_COLOR);
        rbwdpth->maximum(127);
        rbwdpth->step(1);
        rbwdpth->callback((Fl_Callback*)cb_rbwdpth);
        rbwdpth->align(Fl_Align(FL_ALIGN_BOTTOM));
        rbwdpth->when(FL_WHEN_CHANGED);
        o->value(part->ctl->resonancebandwidth.depth);
      } // WidgetPDial* rbwdpth
      o->end();
    } // Fl_Group* o
    { Fl_Group* o = new Fl_Group(340, 15, 160, 85, "Portamento");
      o->box(FL_ENGRAVED_FRAME);
      o->labelfont(1);
      o->labelsize(10);
      { Fl_Box* o = new Fl_Box(400, 50, 55, 15, "x100 cnt.");
        o->labelsize(10);
        o->align(Fl_Align(FL_ALIGN_CENTER|FL_ALIGN_INSIDE));
      } // Fl_Box* o
      { WidgetPDial* o = prtime = new WidgetPDial(345, 60, 25, 25, "time");
        prtime->tooltip("Portamento time");
        prtime->box(FL_OVAL_BOX);
        prtime->color(FL_BACKGROUND_COLOR);
        prtime->selection_color(FL_INACTIVE_COLOR);
        prtime->labeltype(FL_NORMAL_LABEL);
        prtime->labelfont(0);
        prtime->labelsize(10);
        prtime->labelcolor(FL_FOREGROUND_COLOR);
        prtime->maximum(127);
        prtime->step(1);
        prtime->callback((Fl_Callback*)cb_prtime);
        prtime->align(Fl_Align(FL_ALIGN_BOTTOM));
        prtime->when(FL_WHEN_CHANGED);
        o->value(part->ctl->portamento.time);
      } // WidgetPDial* prtime
      { WidgetPDial* o = timedu = new WidgetPDial(375, 60, 25, 25, "t.dn/up");
        timedu->tooltip("Portamento time stretch (up/down)");
        timedu->box(FL_OVAL_BOX);
        timedu->color(FL_BACKGROUND_COLOR);
        timedu->selection_color(FL_INACTIVE_COLOR);
        timedu->labeltype(FL_NORMAL_LABEL);
        timedu->labelfont(0);
        timedu->labelsize(10);
        timedu->labelcolor(FL_FOREGROUND_COLOR);
        timedu->maximum(127);
        timedu->step(1);
        timedu->callback((Fl_Callback*)cb_timedu);
        timedu->align(Fl_Align(FL_ALIGN_BOTTOM));
        timedu->when(FL_WHEN_CHANGED);
        o->value(part->ctl->portamento.updowntimestretch);
      } // WidgetPDial* timedu
      { Fl_Counter* o = thresh = new Fl_Counter(400, 20, 50, 20, "Thresh");
        thresh->tooltip("Minimum or max. difference of the notes in order to do the portamento (x 100 \
cents)");
        thresh->type(1);
        thresh->color((Fl_Color)237);
        thresh->selection_color(FL_FOREGROUND_COLOR);
        thresh->labelsize(10);
        thresh->minimum(0);
        thresh->maximum(127);
        thresh->step(1);
        thresh->callback((Fl_Callback*)cb_thresh);
        o->value(part->ctl->portamento.pitchthresh);
      } // Fl_Counter* thresh
      { Fl_Check_Button* o = thtype = new Fl_Check_Button(425, 68, 15, 15, "th.type");
        thtype->tooltip("Threshold type (min/max)");
        thtype->down_box(FL_DOWN_BOX);
        thtype->labelsize(10);
        thtype->callback((Fl_Callback*)cb_thtype);
        thtype->align(Fl_Align(FL_ALIGN_BOTTOM));
        o->value(part->ctl->portamento.pitchthreshtype);
      } // Fl_Check_Button* thtype
      { WidgetPDial* o = propta = new WidgetPDial(463, 20, 25, 25, "Prp.Rate");
        propta->tooltip("Distance required to double change from nonpropotinal portamento time");
        propta->box(FL_OVAL_BOX);
        propta->color(FL_BACKGROUND_COLOR);
        propta->selection_color(FL_INACTIVE_COLOR);
        propta->labeltype(FL_NORMAL_LABEL);
        propta->labelfont(0);
        propta->labelsize(9);
        propta->labelcolor(FL_FOREGROUND_COLOR);
        propta->maximum(127);
        propta->step(1);
        propta->callback((Fl_Callback*)cb_propta);
        propta->align(Fl_Align(FL_ALIGN_BOTTOM));
        propta->when(FL_WHEN_CHANGED);
        o->value(part->ctl->portamento.propRate);
      } // WidgetPDial* propta
      { WidgetPDial* o = proptb = new WidgetPDial(463, 60, 25, 25, "Prp.Dpth");
        proptb->tooltip("The difference from nonproportinal portamento");
        proptb->box(FL_OVAL_BOX);
        proptb->color(FL_BACKGROUND_COLOR);
        proptb->selection_color(FL_INACTIVE_COLOR);
        proptb->labeltype(FL_NORMAL_LABEL);
        proptb->labelfont(0);
        proptb->labelsize(9);
        proptb->labelcolor(FL_FOREGROUND_COLOR);
        proptb->maximum(127);
        proptb->step(1);
        proptb->callback((Fl_Callback*)cb_proptb);
        proptb->align(Fl_Align(FL_ALIGN_BOTTOM));
        proptb->when(FL_WHEN_CHANGED);
        o->value(part->ctl->portamento.propDepth);
      } // WidgetPDial* proptb
      { Fl_Check_Button* o = rcv = new Fl_Check_Button(345, 20, 40, 18, "Rcv");
        rcv->tooltip("Receive Portamento Controllers");
        rcv->box(FL_THIN_UP_BOX);
        rcv->down_box(FL_DOWN_BOX);
        rcv->labelsize(10);
        rcv->callback((Fl_Callback*)cb_rcv);
        o->value(part->ctl->portamento.receive);
      } // Fl_Check_Button* rcv
      { Fl_Check_Button* o = proprt = new Fl_Check_Button(345, 40, 50, 18, "Proprt.");
        proprt->tooltip("Enable Proportinal Portamento (over fixed Portamento)");
        proprt->box(FL_THIN_UP_BOX);
        proprt->down_box(FL_DOWN_BOX);
        proprt->labelsize(9);
        proprt->callback((Fl_Callback*)cb_proprt);
        o->value(part->ctl->portamento.proportional);
        if(o->value()){propta->activate();proptb->activate();}
        else {propta->deactivate();proptb->deactivate();}
      } // Fl_Check_Button* proprt
      o->end();
    } // Fl_Group* o
    o->copy_label(synth->getGuiMaster()->setPartWindowTitle("Controllers").c_str());
    o->position(synth->getGuiMaster()->controllersX, synth->getGuiMaster()->controllersY);
    ctlwindow->end();
  } // Fl_Double_Window* ctlwindow
  { Fl_Double_Window* o = ctlmidi = new Fl_Double_Window(365, 60, "MIDI Controls");
    ctlmidi->user_data((void*)(this));
    { WidgetPDial* o = modulation = new WidgetPDial(20, 10, 30, 30, "Modulation");
      modulation->tooltip("Modulation Wheel");
      modulation->box(FL_OVAL_BOX);
      modulation->color(FL_BACKGROUND_COLOR);
      modulation->selection_color(FL_INACTIVE_COLOR);
      modulation->labeltype(FL_NORMAL_LABEL);
      modulation->labelfont(0);
      modulation->labelsize(10);
      modulation->labelcolor(FL_FOREGROUND_COLOR);
      modulation->maximum(127);
      modulation->step(1);
      modulation->callback((Fl_Callback*)cb_modulation);
      modulation->align(Fl_Align(FL_ALIGN_BOTTOM));
      modulation->when(FL_WHEN_CHANGED);
      o->value(part->ctl->modwheel.data);
    } // WidgetPDial* modulation
    { WidgetPDial* o = expression = new WidgetPDial(80, 10, 30, 30, "Expression");
      expression->tooltip("Expression");
      expression->box(FL_OVAL_BOX);
      expression->color(FL_BACKGROUND_COLOR);
      expression->selection_color(FL_INACTIVE_COLOR);
      expression->labeltype(FL_NORMAL_LABEL);
      expression->labelfont(0);
      expression->labelsize(10);
      expression->labelcolor(FL_FOREGROUND_COLOR);
      expression->maximum(127);
      expression->step(1);
      expression->callback((Fl_Callback*)cb_expression);
      expression->align(Fl_Align(FL_ALIGN_BOTTOM));
      expression->when(FL_WHEN_CHANGED);
      o->value(part->ctl->expression.data);
    } // WidgetPDial* expression
    { WidgetPDial* o = filterq = new WidgetPDial(140, 10, 30, 30, "Filter Q");
      filterq->tooltip("Filter Q");
      filterq->box(FL_OVAL_BOX);
      filterq->color(FL_BACKGROUND_COLOR);
      filterq->selection_color(FL_INACTIVE_COLOR);
      filterq->labeltype(FL_NORMAL_LABEL);
      filterq->labelfont(0);
      filterq->labelsize(10);
      filterq->labelcolor(FL_FOREGROUND_COLOR);
      filterq->maximum(127);
      filterq->step(1);
      filterq->callback((Fl_Callback*)cb_filterq);
      filterq->align(Fl_Align(FL_ALIGN_BOTTOM));
      filterq->when(FL_WHEN_CHANGED);
      o->value(part->ctl->filterq.data);
    } // WidgetPDial* filterq
    { WidgetPDial* o = filtercutoff = new WidgetPDial(200, 10, 30, 30, "Filter Cutoff");
      filtercutoff->tooltip("Filter Cutoff");
      filtercutoff->box(FL_OVAL_BOX);
      filtercutoff->color(FL_BACKGROUND_COLOR);
      filtercutoff->selection_color(FL_INACTIVE_COLOR);
      filtercutoff->labeltype(FL_NORMAL_LABEL);
      filtercutoff->labelfont(0);
      filtercutoff->labelsize(10);
      filtercutoff->labelcolor(FL_FOREGROUND_COLOR);
      filtercutoff->maximum(127);
      filtercutoff->step(1);
      filtercutoff->callback((Fl_Callback*)cb_filtercutoff);
      filtercutoff->align(Fl_Align(FL_ALIGN_BOTTOM));
      filtercutoff->when(FL_WHEN_CHANGED);
      o->value(part->ctl->filtercutoff.data);
    } // WidgetPDial* filtercutoff
    { WidgetPDial* o = masterbandwidth = new WidgetPDial(260, 10, 30, 30, "Bandwidth");
      masterbandwidth->tooltip("Master Bandwidth");
      masterbandwidth->box(FL_OVAL_BOX);
      masterbandwidth->color(FL_BACKGROUND_COLOR);
      masterbandwidth->selection_color(FL_INACTIVE_COLOR);
      masterbandwidth->labeltype(FL_NORMAL_LABEL);
      masterbandwidth->labelfont(0);
      masterbandwidth->labelsize(10);
      masterbandwidth->labelcolor(FL_FOREGROUND_COLOR);
      masterbandwidth->maximum(127);
      masterbandwidth->step(1);
      masterbandwidth->callback((Fl_Callback*)cb_masterbandwidth);
      masterbandwidth->align(Fl_Align(FL_ALIGN_BOTTOM));
      masterbandwidth->when(FL_WHEN_CHANGED);
      o->value(part->ctl->bandwidth.data);
    } // WidgetPDial* masterbandwidth
    { Fl_Button* o = new Fl_Button(309, 35, 50, 20, "Close");
      o->box(FL_THIN_UP_BOX);
      o->callback((Fl_Callback*)cb_Close1);
    } // Fl_Button* o
    o->copy_label(synth->getGuiMaster()->setPartWindowTitle("MIDI Controls").c_str());
    o->position(synth->getGuiMaster()->controllersX, synth->getGuiMaster()->controllersY);
    ctlmidi->end();
  } // Fl_Double_Window* ctlmidi
  { Fl_Double_Window* o = partfx = new Fl_Double_Window(385, 160, "Part\'s Insert Effects");
    partfx->user_data((void*)(this));
    { Fl_Spinner* o = inseffnocounter = new Fl_Spinner(35, 8, 35, 22);
      inseffnocounter->tooltip("Effect No.");
      inseffnocounter->labelsize(12);
      inseffnocounter->maximum(3);
      inseffnocounter->textsize(11);
      inseffnocounter->callback((Fl_Callback*)cb_inseffnocounter);
      o->value(ninseff+1);
    } // Fl_Spinner* inseffnocounter
    { Fl_Choice* o = insefftype = new Fl_Choice(104, 8, 95, 22);
      insefftype->tooltip("Effect Type");
      insefftype->box(FL_UP_BOX);
      insefftype->down_box(FL_BORDER_BOX);
      insefftype->labelsize(11);
      insefftype->callback((Fl_Callback*)cb_insefftype);
      insefftype->menu(menu_insefftype);
      o->value(part->partefx[ninseff]->geteffect());
    } // Fl_Choice* insefftype
    { inseffectuigroup = new Fl_Group(5, 37, 380, 96);
      inseffectuigroup->box(FL_FLAT_BOX);
      inseffectuigroup->color((Fl_Color)48);
      { EffUI* o = inseffectui = new EffUI(5, 38, 379, 95);
        inseffectui->box(FL_NO_BOX);
        inseffectui->color(FL_BACKGROUND_COLOR);
        inseffectui->selection_color(FL_BACKGROUND_COLOR);
        inseffectui->labeltype(FL_NORMAL_LABEL);
        inseffectui->labelfont(0);
        inseffectui->labelsize(14);
        inseffectui->labelcolor(FL_FOREGROUND_COLOR);
        inseffectui->align(Fl_Align(FL_ALIGN_TOP));
        inseffectui->when(FL_WHEN_RELEASE);
        o->init(part->partefx[ninseff], npart, ninseff);
        inseffectui->end();
      } // EffUI* inseffectui
      inseffectuigroup->end();
    } // Fl_Group* inseffectuigroup
    { Fl_Button* o = new Fl_Button(314, 136, 60, 20, "Close");
      o->box(FL_THIN_UP_BOX);
      o->callback((Fl_Callback*)cb_Close2);
    } // Fl_Button* o
    { Fl_Choice* o = sendtochoice = new Fl_Choice(244, 8, 90, 22, "To");
      sendtochoice->down_box(FL_BORDER_BOX);
      sendtochoice->labelfont(1);
      sendtochoice->labelsize(11);
      sendtochoice->callback((Fl_Callback*)cb_sendtochoice);
      sendtochoice->menu(menu_sendtochoice);
      int x=part->Pefxroute[ninseff]; if (x==127) x=1;
      o->value(x);
    } // Fl_Choice* sendtochoice
    { Fl_Check_Button* o = bypasseff = new Fl_Check_Button(55, 135, 20, 22, "Bypass");
      bypasseff->tooltip("if the effect is not used (is bypassed)");
      bypasseff->down_box(FL_DOWN_BOX);
      bypasseff->labelsize(12);
      bypasseff->callback((Fl_Callback*)cb_bypasseff);
      bypasseff->align(Fl_Align(FL_ALIGN_LEFT));
      int x=part->Pefxbypass[ninseff];o->value(x);
    } // Fl_Check_Button* bypasseff
    { Fl_Button* o = new Fl_Button(350, 3, 25, 15, "C");
      o->box(FL_THIN_UP_BOX);
      o->color((Fl_Color)179);
      o->labelfont(1);
      o->labelsize(11);
      o->labelcolor(FL_BACKGROUND2_COLOR);
      o->callback((Fl_Callback*)cb_C);
    } // Fl_Button* o
    { Fl_Button* o = new Fl_Button(350, 19, 25, 15, "P");
      o->box(FL_THIN_UP_BOX);
      o->color((Fl_Color)179);
      o->labelfont(1);
      o->labelsize(11);
      o->labelcolor(FL_BACKGROUND2_COLOR);
      o->callback((Fl_Callback*)cb_P);
    } // Fl_Button* o
    o->copy_label(synth->getGuiMaster()->setPartWindowTitle("Insert Effects").c_str());
    partfx->end();
  } // Fl_Double_Window* partfx
  { Fl_Double_Window* o = instrumentkitlist = new Fl_Double_Window(670, 370, "Instrument Kit");
    instrumentkitlist->user_data((void*)(this));
    { Fl_Button* o = new Fl_Button(569, 348, 63, 20, "Close");
      o->box(FL_THIN_UP_BOX);
      o->callback((Fl_Callback*)cb_Close3);
    } // Fl_Button* o
    { kitlist = new Fl_Scroll(0, 15, 670, 330);
      kitlist->type(2);
      kitlist->box(FL_THIN_UP_BOX);
      { Fl_Pack* o = new Fl_Pack(0, 20, 670, 320);
        for (int i=0;i<NUM_KIT_ITEMS;i++){partkititem[i]=new PartKitItem(0,0,670,20,"");partkititem[i]->init(part, i, npart, this);}
        o->end();
      } // Fl_Pack* o
      kitlist->end();
    } // Fl_Scroll* kitlist
    { Fl_Box* o = new Fl_Box(10, 0, 25, 15, "No.");
      o->labelfont(1);
      o->labelsize(11);
      o->align(Fl_Align(FL_ALIGN_BOTTOM|FL_ALIGN_INSIDE));
    } // Fl_Box* o
    { Fl_Box* o = new Fl_Box(55, 0, 25, 15, "Mute");
      o->labelfont(1);
      o->labelsize(11);
      o->align(Fl_Align(FL_ALIGN_BOTTOM|FL_ALIGN_INSIDE));
    } // Fl_Box* o
    { Fl_Box* o = new Fl_Box(235, 0, 40, 15, "Min key");
      o->labelfont(1);
      o->labelsize(11);
      o->align(Fl_Align(FL_ALIGN_BOTTOM|FL_ALIGN_INSIDE));
    } // Fl_Box* o
    { Fl_Box* o = new Fl_Box(345, 0, 40, 15, "Max key");
      o->labelfont(1);
      o->labelsize(11);
      o->align(Fl_Align(FL_ALIGN_BOTTOM|FL_ALIGN_INSIDE));
    } // Fl_Box* o
    { Fl_Box* o = new Fl_Box(410, 0, 50, 15, "ADsynth");
      o->labelfont(1);
      o->labelsize(11);
      o->align(Fl_Align(FL_ALIGN_BOTTOM|FL_ALIGN_INSIDE));
    } // Fl_Box* o
    { Fl_Box* o = new Fl_Box(470, 0, 60, 15, "SUBsynth");
      o->labelfont(1);
      o->labelsize(11);
      o->align(Fl_Align(FL_ALIGN_BOTTOM|FL_ALIGN_INSIDE));
    } // Fl_Box* o
    { Fl_Choice* o = kitMode = new Fl_Choice(35, 348, 88, 19, "Mode");
      kitMode->tooltip("Single = only 1st item in defined note range sounds");
      kitMode->down_box(FL_BORDER_BOX);
      kitMode->labelsize(11);
      kitMode->textfont(1);
      kitMode->textsize(11);
      kitMode->callback((Fl_Callback*)cb_kitMode);
      kitMode->menu(menu_kitMode);
      if (part->Pkitfade) {o->value(3);} else {o->value(part->Pkitmode);}
      partKitOn = o->value() > 0;
      if (!partKitOn) kitlist->deactivate();
    } // Fl_Choice* kitMode
    { Fl_Check_Button* o = drumMode = new Fl_Check_Button(285, 350, 15, 15, "Drum mode");
      drumMode->tooltip("Disables microtonal tuning");
      drumMode->down_box(FL_DOWN_BOX);
      drumMode->labelsize(10);
      drumMode->callback((Fl_Callback*)cb_drumMode);
      o->value(part->Pdrummode);
    } // Fl_Check_Button* drumMode
    { Fl_Box* o = new Fl_Box(620, 0, 30, 15, "FX.r.");
      o->labelfont(1);
      o->labelsize(11);
      o->align(Fl_Align(FL_ALIGN_BOTTOM|FL_ALIGN_INSIDE));
    } // Fl_Box* o
    { Fl_Box* o = new Fl_Box(540, 0, 60, 15, "PADsynth");
      o->labelfont(1);
      o->labelsize(11);
      o->align(Fl_Align(FL_ALIGN_BOTTOM|FL_ALIGN_INSIDE));
    } // Fl_Box* o
    { Fl_Box* o = new Fl_Box(137, 0, 40, 15, "Name");
      o->labelfont(1);
      o->labelsize(11);
      o->align(Fl_Align(FL_ALIGN_BOTTOM|FL_ALIGN_INSIDE));
    } // Fl_Box* o
    o->copy_label(synth->getGuiMaster()->setPartWindowTitle("kit List").c_str());
    instrumentkitlist->end();
  } // Fl_Double_Window* instrumentkitlist
  { Fl_Double_Window* o = instrumenteditwindow = new Fl_Double_Window(395, 360, "Instrument Edit");
    instrumenteditwindow->user_data((void*)(this));
    { Fl_Group* o = new Fl_Group(0, 220, 395, 110);
      o->box(FL_ENGRAVED_FRAME);
      { ADD = new Fl_Group(5, 246, 100, 79, "ADDsynth");
        ADD->box(FL_ENGRAVED_FRAME);
        ADD->labelfont(1);
        { Fl_Check_Button* o = adsynenabledcheck = new Fl_Check_Button(15, 255, 80, 20, "Enabled");
          adsynenabledcheck->tooltip("enable/disable ADsynth");
          adsynenabledcheck->box(FL_PLASTIC_UP_BOX);
          adsynenabledcheck->down_box(FL_DOWN_BOX);
          adsynenabledcheck->color((Fl_Color)228);
          adsynenabledcheck->labelfont(1);
          adsynenabledcheck->labelsize(11);
          adsynenabledcheck->callback((Fl_Callback*)cb_adsynenabledcheck);
          o->value(part->kit[0].Padenabled);
        } // Fl_Check_Button* adsynenabledcheck
        { Fl_Box* o = addbox = new Fl_Box(10, 226, 89, 18);
          addbox->box(FL_FLAT_BOX);
          if (adsynenabledcheck->value() != 0 && engine != 0) o->color(ADD_COLOUR); else o->color(BASE_COLOUR);
        } // Fl_Box* addbox
        { Fl_Button* o = adeditbutton = new Fl_Button(15, 281, 80, 34, "Edit");
          adeditbutton->box(FL_PLASTIC_UP_BOX);
          adeditbutton->color((Fl_Color)222);
          adeditbutton->selection_color((Fl_Color)220);
          adeditbutton->labelfont(1);
          adeditbutton->labelsize(13);
          adeditbutton->callback((Fl_Callback*)cb_adeditbutton1);
          adeditbutton->align(Fl_Align(FL_ALIGN_WRAP));
          if (part->kit[0].Padenabled==0) o->deactivate();
        } // Fl_Button* adeditbutton
        ADD->end();
      } // Fl_Group* ADD
      { SUB = new Fl_Group(105, 246, 100, 79, "SUBsynth");
        SUB->box(FL_ENGRAVED_FRAME);
        SUB->labelfont(1);
        { Fl_Check_Button* o = subsynenabledcheck = new Fl_Check_Button(115, 255, 80, 20, "Enabled");
          subsynenabledcheck->tooltip("enable/disable SUBsynth");
          subsynenabledcheck->box(FL_PLASTIC_UP_BOX);
          subsynenabledcheck->down_box(FL_DOWN_BOX);
          subsynenabledcheck->color((Fl_Color)228);
          subsynenabledcheck->labelfont(1);
          subsynenabledcheck->labelsize(11);
          subsynenabledcheck->callback((Fl_Callback*)cb_subsynenabledcheck);
          o->value(part->kit[0].Psubenabled);
        } // Fl_Check_Button* subsynenabledcheck
        { Fl_Box* o = subbox = new Fl_Box(110, 226, 89, 18);
          subbox->box(FL_FLAT_BOX);
          if (subsynenabledcheck->value() != 0 && engine != 0) o->color(SUB_COLOUR); else o->color(BASE_COLOUR);
        } // Fl_Box* subbox
        { Fl_Button* o = subeditbutton = new Fl_Button(115, 280, 80, 35, "Edit");
          subeditbutton->box(FL_PLASTIC_UP_BOX);
          subeditbutton->color((Fl_Color)222);
          subeditbutton->selection_color((Fl_Color)220);
          subeditbutton->labelfont(1);
          subeditbutton->labelsize(13);
          subeditbutton->callback((Fl_Callback*)cb_subeditbutton1);
          subeditbutton->align(Fl_Align(FL_ALIGN_WRAP));
          if (part->kit[0].Psubenabled==0) o->deactivate();
        } // Fl_Button* subeditbutton
        SUB->end();
      } // Fl_Group* SUB
      { PAD = new Fl_Group(205, 246, 100, 79, "PADsynth");
        PAD->box(FL_ENGRAVED_FRAME);
        PAD->labelfont(1);
        { Fl_Check_Button* o = padsynenabledcheck = new Fl_Check_Button(215, 255, 80, 20, "Enabled");
          padsynenabledcheck->tooltip("enable/disable PADsynth");
          padsynenabledcheck->box(FL_PLASTIC_UP_BOX);
          padsynenabledcheck->down_box(FL_DOWN_BOX);
          padsynenabledcheck->color((Fl_Color)228);
          padsynenabledcheck->labelfont(1);
          padsynenabledcheck->labelsize(11);
          padsynenabledcheck->callback((Fl_Callback*)cb_padsynenabledcheck);
          o->value(part->kit[0].Ppadenabled);
        } // Fl_Check_Button* padsynenabledcheck
        { Fl_Box* o = padbox = new Fl_Box(210, 226, 89, 18);
          padbox->box(FL_FLAT_BOX);
          if (padsynenabledcheck->value() != 0 && engine != 0) o->color(PAD_COLOUR); else o->color(BASE_COLOUR);
        } // Fl_Box* padbox
        { Fl_Button* o = padeditbutton = new Fl_Button(215, 280, 80, 35, "Edit");
          padeditbutton->box(FL_PLASTIC_UP_BOX);
          padeditbutton->color((Fl_Color)222);
          padeditbutton->selection_color((Fl_Color)220);
          padeditbutton->labelfont(1);
          padeditbutton->labelsize(13);
          padeditbutton->callback((Fl_Callback*)cb_padeditbutton1);
          padeditbutton->align(Fl_Align(FL_ALIGN_WRAP));
          if (part->kit[0].Ppadenabled==0) o->deactivate();
        } // Fl_Button* padeditbutton
        PAD->end();
      } // Fl_Group* PAD
      { Fl_Button* o = new Fl_Button(310, 245, 80, 35, "Kit Edit");
        o->box(FL_PLASTIC_UP_BOX);
        o->color((Fl_Color)238);
        o->selection_color((Fl_Color)220);
        o->labelfont(1);
        o->callback((Fl_Callback*)cb_Kit);
        o->align(Fl_Align(FL_ALIGN_WRAP));
      } // Fl_Button* o
      { Fl_Button* o = new Fl_Button(310, 290, 80, 35, "Effects");
        o->box(FL_PLASTIC_UP_BOX);
        o->color((Fl_Color)230);
        o->labelfont(1);
        o->labelsize(13);
        o->callback((Fl_Callback*)cb_Effects);
      } // Fl_Button* o
      o->end();
    } // Fl_Group* o
    { Fl_Group* o = new Fl_Group(0, 5, 395, 215);
      o->box(FL_ENGRAVED_FRAME);
      { Fl_Text_Display* o = new Fl_Text_Display(171, 44, 148, 4, "Author and Copyright");
        o->box(FL_NO_BOX);
        o->labelsize(12);
      } // Fl_Text_Display* o
      { Fl_Button* o = new Fl_Button(327, 25, 63, 20, "Default");
        o->tooltip("Load default author & copyright\\n+Ctrl: save current text as default");
        o->labelsize(12);
        o->callback((Fl_Callback*)cb_Default);
      } // Fl_Button* o
      { Fl_Input* o = copyright = new Fl_Input(5, 49, 385, 55);
        copyright->type(4);
        copyright->color((Fl_Color)26);
        copyright->labelsize(12);
        copyright->callback((Fl_Callback*)cb_copyright);
        copyright->align(Fl_Align(FL_ALIGN_TOP_RIGHT));
        o->maximum_size(MAX_INFO_TEXT_SIZE);
        o->value(part->info.Pauthor.c_str());
      } // Fl_Input* copyright
      { Fl_Input* o = new Fl_Input(5, 123, 385, 91, "Comments");
        o->type(4);
        o->color((Fl_Color)26);
        o->labelsize(12);
        o->callback((Fl_Callback*)cb_Comments);
        o->align(Fl_Align(FL_ALIGN_TOP_LEFT));
        o->maximum_size(MAX_INFO_TEXT_SIZE);
        o->value(part->info.Pcomments.c_str());
      } // Fl_Input* o
      { Fl_Choice* o = new Fl_Choice(5, 25, 155, 20, "Type:");
        o->down_box(FL_BORDER_BOX);
        o->labelfont(1);
        o->labelsize(11);
        o->textsize(10);
        o->callback((Fl_Callback*)cb_Type);
        o->align(Fl_Align(FL_ALIGN_TOP_LEFT));
        o->menu(menu_Type);
        o->value(part->info.Ptype);
      } // Fl_Choice* o
      o->end();
    } // Fl_Group* o
    { mwheel_val_slider_rev* o = humanise = new mwheel_val_slider_rev(8, 337, 201, 16, "Humanise");
      humanise->tooltip("Random detune of whole part in cents");
      humanise->type(5);
      humanise->box(FL_THIN_DOWN_BOX);
      humanise->color(FL_BACKGROUND_COLOR);
      humanise->selection_color(FL_BACKGROUND_COLOR);
      humanise->labeltype(FL_NORMAL_LABEL);
      humanise->labelfont(0);
      humanise->labelsize(12);
      humanise->labelcolor(FL_FOREGROUND_COLOR);
      humanise->maximum(50);
      humanise->step(1);
      humanise->callback((Fl_Callback*)cb_humanise);
      humanise->align(Fl_Align(FL_ALIGN_RIGHT));
      humanise->when(FL_WHEN_CHANGED);
      o->value(part->Pfrand);
    } // mwheel_val_slider_rev* humanise
    { Fl_Button* o = new Fl_Button(311, 335, 80, 21, "Close");
      o->box(FL_THIN_UP_BOX);
      o->labelfont(1);
      o->labelsize(13);
      o->callback((Fl_Callback*)cb_Close4);
    } // Fl_Button* o
    seteditname();
    o->copy_label(synth->getGuiMaster()->setPartWindowTitle("Instrument Edit").c_str());
    instrumenteditwindow->end();
  } // Fl_Double_Window* instrumenteditwindow
  return instrumenteditwindow;
}

int PartUI::handle(int event) {
  //
          int ret = Fl_Group::handle(event);
          switch(event)
          {
              case FL_FOCUS:
              case FL_UNFOCUS:
                  ret = 1;                break;
              case FL_SHORTCUT:           // in case widget that isn't ours has focus
              case FL_KEYDOWN:            // keyboard key pushed
              //case FL_KEYUP:              // keyboard key released
              {
                  if (lastkey != Fl::event_key())
                  {
                      lastkey = Fl::event_key();
                      //cout << "Key " << lastkey << endl;
                  }
                  break;
              }
              case FL_KEYUP:
              {
                  if (lastkey == Fl::event_key())
                      lastkey = -1;
                  break;
              }
          }
          return(ret);
}

void PartUI::send_data(int control, float value, int type, int kititem , int engine , int insert , int parameter , int par2 ) {
  //
          type |= TOPLEVEL::type::Write;
          collect_data(synth, value, (Fl::event_button() | type), control, npart, kititem, engine, insert, parameter, par2);
}

void PartUI::returns_update(CommandBlock *getData) {
  //
      float value = getData->data.value;
      unsigned char control = getData->data.control;
      unsigned char newpart = getData->data.part;
      unsigned char kititem = getData->data.kit;
      unsigned char engine = getData->data.engine;
      unsigned char insert = getData->data.insert;
      unsigned char parameter = getData->data.parameter;
      unsigned char par2 = getData->data.par2;
      bool valBool = YOSH::F2B(value);
      int valInt = lrint(value);
      string text;
      if (par2 != NO_MSG)
          text = miscMsgPop(par2);
  
      // these are specific to the mixer panel
      if (newpart >= *plgroup && newpart < (*plgroup + NUM_MIDI_CHANNELS))
      {
          int displaypart = newpart % NUM_MIDI_CHANNELS;
          switch (control)
          {
              case PART::control::volume:
                  synth->getGuiMaster()->panellistitem[displaypart]->partvolume->value(value);
                  break;
              case PART::control::panning:
                  synth->getGuiMaster()->panellistitem[displaypart]->partpanning->value(value);
                  break;
              case PART::control::midiChannel:
                  synth->getGuiMaster()->panellistitem[displaypart]->partrcv->value(valInt & 0xf);
                  if (valInt < (NUM_MIDI_CHANNELS - 1))
                      synth->getGuiMaster()->panellistitem[displaypart]->partrcv->textcolor(FL_BLACK);
                  else
                      synth->getGuiMaster()->panellistitem[displaypart]->partrcv->textcolor(FL_WHITE);
                  break;
              case PART::control::enable:
                  if (engine == 255)
                  {
                      synth->getGuiMaster()->panellistitem[displaypart]->partenabled->value(valBool);
                      if (valBool)
                          synth->getGuiMaster()->panellistitem[displaypart]->panellistitemgroup->activate();
                      else
                          synth->getGuiMaster()->panellistitem[displaypart]->panellistitemgroup->deactivate();
                  }
                  break;
              case PART::control::audioDestination:
                  int send = valInt - 1;
                  if (send < 0 or send > 2)
                      send = 0;
                  synth->getGuiMaster()->panellistitem[displaypart]->audiosend->value(send);
          }
      }
  
      if (npart != newpart)
          return;
      bool sameEff = (engine == (inseffnocounter->value() - 1));
      bool kitType = (insert == TOPLEVEL::insert::kitGroup);
      switch(control)
      {
          case PART::control::volume:
              partvol->value(value);
              break;
  
          case PART::control::velocitySense:
              velocitysense->value(value);
              break;
  
          case PART::control::panning:
              partpan->value(value);
              break;
  
          case PART::control::velocityOffset:
              velocityoffset->value(value);
              break;
  
          case PART::control::midiChannel:
              midich->value(valInt + 1);
              if (valInt < NUM_MIDI_CHANNELS)
                  midich->textcolor(FL_BLACK);
              else
                  midich->textcolor(FL_WHITE);
              break;
  
          case PART::control::keyMode:
              legatoMode->labelcolor(FL_BLACK);
              if(valInt > 1)
              {
                  keymode->value(2);
                  if (drumMode->value())
                      legatoMode->labelcolor(FL_RED);
              }
              else
                  keymode->value(valInt);
              keymode->damage(1);
              break;
  
          case PART::control::portamento:
              enportamento->value(valBool);
              break;
  
          case PART::control::enable:
          {
              if (kitType)
              {
                  switch(engine)
                  {
                      case 0:
                          partkititem[kititem]->adcheck->value(valBool);
                          if (valBool)
                          {
                              partkititem[kititem]->adeditbutton->activate();
                              instrumentaddbox->color(ADD_COLOUR);
                          }
                          else
                          {
                              partkititem[kititem]->adeditbutton->deactivate();
                              instrumentaddbox->color(BASE_COLOUR);
                          }
                          break;
                      case 1:
                          partkititem[kititem]->subcheck->value(valBool);
                          if (valBool)
                          {
                              partkititem[kititem]->subeditbutton->activate();
                              instrumentsubbox->color(SUB_COLOUR);
                          }
                          else
                          {
                              partkititem[kititem]->subeditbutton->deactivate();
                              instrumentsubbox->color(BASE_COLOUR);
                          }
                          break;
                      case 2:
                          partkititem[kititem]->padcheck->value(valBool);
                          if (valBool)
                          {
                              partkititem[kititem]->padeditbutton->activate();
                              instrumentpadbox->color(PAD_COLOUR);
                          }
                          else
                          {
                              partkititem[kititem]->padeditbutton->deactivate();
                              instrumentpadbox->color(BASE_COLOUR);
                          }
                          break;
                      default:
                          partkititem[kititem]->enabledcheck->value(valBool);
                          if (valBool)
                              partkititem[kititem]->partkititemgroup->activate();
                          else
                              partkititem[kititem]->clearLine();
                          break;
                  }
                  if (kititem == 0)
                  {
                      switch(engine)
                      {
                          case 0:
                              partkititem[kititem]->adcheck->value(valBool);
                              adsynenabledcheck->value(valBool);
                              if (valBool)
                              {
                                  adeditbutton->activate();
                                  addbox->color(ADD_COLOUR);
                                  instrumentaddbox->color(ADD_COLOUR);
                              }
                              else
                              {
                                  adeditbutton->deactivate();
                                  addbox->color(BASE_COLOUR);
                                  instrumentaddbox->color(BASE_COLOUR);
                              }
                              break;
                          case 1:
                              partkititem[kititem]->subcheck->value(valBool);
                              subsynenabledcheck->value(valBool);
                              if (valBool)
                              {
                                  subeditbutton->activate();
                                  subbox->color(SUB_COLOUR);
                                  instrumentsubbox->color(SUB_COLOUR);
                              }
                              else
                              {
                                  subeditbutton->deactivate();
                                  subbox->color(BASE_COLOUR);
                                  instrumentsubbox->color(BASE_COLOUR);
                              }
                              break;
                          case 2:
                              partkititem[kititem]->padcheck->value(valBool);
                              padsynenabledcheck->value(valBool);
                              if (valBool)
                              {
                                  padeditbutton->activate();
                                  padbox->color(PAD_COLOUR);
                                  instrumentpadbox->color(PAD_COLOUR);
                              }
                              else
                              {
                                  padeditbutton->deactivate();
                                  padbox->color(BASE_COLOUR);
                                  instrumentpadbox->color(BASE_COLOUR);
                              }
                              break;
                      }
                  }
              }
              else
              {
                  switch(engine)
                  {
                      case 0:
                          partkititem[0]->adcheck->value(valBool);
                          adsynenabledcheck->value(valBool);
                          if (valBool)
                          {
                              adeditbutton->activate();
                              addbox->color(ADD_COLOUR);
                              instrumentaddbox->color(ADD_COLOUR);
                          }
                          else
                          {
                              adeditbutton->deactivate();
                              addbox->color(BASE_COLOUR);
                              instrumentaddbox->color(BASE_COLOUR);
                          }
                          break;
                      case 1:
                          partkititem[0]->subcheck->value(valBool);
                          subsynenabledcheck->value(valBool);
                          if (valBool)
                          {
                              subeditbutton->activate();
                              subbox->color(SUB_COLOUR);
                              instrumentsubbox->color(SUB_COLOUR);
                          }
                          else
                          {
                              subeditbutton->deactivate();
                              subbox->color(BASE_COLOUR);
                              instrumentsubbox->color(BASE_COLOUR);
                          }
                          break;
                      case 2:
                          partkititem[0]->padcheck->value(valBool);
                          padsynenabledcheck->value(valBool);
                          if (valBool)
                          {
                              padeditbutton->activate();
                              padbox->color(PAD_COLOUR);
                              instrumentpadbox->color(PAD_COLOUR);
                          }
                          else
                          {
                              padeditbutton->deactivate();
                              padbox->color(BASE_COLOUR);
                              instrumentpadbox->color(BASE_COLOUR);
                          }
                          break;
                      case 255:
                          partGroupEnable->value(valBool);
                          if (valBool)
                          {
                              partgroupui->activate();
                              toSysEfx->activate();
                          }
                          else
                          {
                              partgroupui->deactivate();
                              toSysEfx->deactivate();
                          }
                          break;
                  }
              }
              instrumentlabel->copy_label(part->Pname.c_str());
              synth->getGuiMaster()->updatepanel();
              break;
          }
          case PART::control::kitItemMute:
              partkititem[kititem]->mutedcheck->value(valBool);
              break;
          case PART::control::minNote:
          case PART::control::minToLastKey: // this will have been modified for last key press
              if (kitType)
                 partkititem[kititem]->minkcounter->value(valInt);
              else
                  minkcounter->value(valInt);
              break;
  
          case PART::control::maxNote:
          case PART::control::maxToLastKey: // this will have been modified for last key press
              if (kitType)
                  partkititem[kititem]->maxkcounter->value(valInt);
              else
                  maxkcounter->value(valInt);
              break;
  
          case PART::control::resetMinMaxKey:
              if (kitType)
              {
                  partkititem[kititem]->minkcounter->value(0);
                  partkititem[kititem]->maxkcounter->value(127);
              }
              else
              {
                  minkcounter->value(0);
                  maxkcounter->value(127);
              }
              break;
  
          case PART::control::kitEffectNum:
              partkititem[kititem]->sendtoeffect->value(valInt);
              break;
  
          case PART::control::maxNotes:
              partkeylimit->value(valInt);
              break;
  
          case PART::control::keyShift:
              partkeyshift->value(valInt);
              break;
  
          case PART::control::partToSystemEffect1:
          case PART::control::partToSystemEffect2:
          case PART::control::partToSystemEffect3:
          case PART::control::partToSystemEffect4:
              psyef[control - PART::control::partToSystemEffect1]->sysend->value(value);
              break;
  
          case PART::control::humanise:
              humanise->value(valInt);
              break;
  
          case PART::control::drumMode:
              drumMode->value(valBool);
              if (valBool && keymode->value() > 1)
                  legatoMode->labelcolor(FL_RED);
              else
                  legatoMode->labelcolor(FL_BLACK);
              keymode->damage(1);
              break;
  
          case PART::control::kitMode:
              kitMode->value(valInt);
              partKitOn =  (kitMode->value() > 0);
              if (partKitOn > 0)
                  kitlist->activate();
              else
                  kitlist->deactivate();
              break;
  
          case PART::control::effectType:
              if (sameEff)
              {
                  insefftype->value(valInt);
                  part->partefx[engine]->geteffect();
                  inseffectui->refresh(part->partefx[engine], npart, engine);
              }
              break;
  
          case PART::control::effectDestination:
              if (sameEff)
                  sendtochoice->value(valInt);
              break;
  
          case PART::control::effectBypass:
              if (sameEff)
                  bypasseff->value(valBool);
              break;
  
          case PART::control::defaultInstrument: // now done in master
              break;
  
  // controllers
          case PART::control::volumeRange:
              volrng->value(valInt);
              break;
  
          case PART::control::volumeEnable:
              vol->value(valInt);
              break;
  
          case PART::control::panningWidth:
              panwidth->value(valInt);
              break;
  
          case PART::control::modWheelDepth:
              modwh->value(valInt);
              break;
  
          case PART::control::exponentialModWheel:
              expmwh->value(valInt);
              break;
  
          case PART::control::bandwidthDepth:
              bwdpth->value(valInt);
              break;
  
          case PART::control::exponentialBandwidth:
              expbw->value(valInt);
              break;
  
          case PART::control::expressionEnable:
              expr->value(valInt);
              break;
  
          case PART::control::FMamplitudeEnable:
              fmamp->value(valInt);
              break;
  
          case PART::control::sustainPedalEnable:
              sustain->value(valInt);
              break;
  
          case PART::control::pitchWheelRange:
              pwheelbrng->value(valInt);
              break;
  
          case PART::control::filterQdepth:
              filtq->value(valInt);
              break;
  
          case PART::control::filterCutoffDepth:
              fltcut->value(valInt);
              break;
  
          case PART::control::breathControlEnable:
              breath->value(valBool);
              break;
  
          case PART::control::resonanceCenterFrequencyDepth:
              cfdpth->value(valInt);
              break;
  
          case PART::control::resonanceBandwidthDepth:
              rbwdpth->value(valInt);
              break;
  
          case PART::control::portamentoTime:
              prtime->value(valInt);
              break;
  
          case PART::control::portamentoTimeStretch:
              timedu->value(valInt);
              break;
  
          case PART::control::portamentoThreshold:
              thresh->value(valInt);
              break;
  
          case PART::control::portamentoThresholdType:
              thtype->value(valInt);
              break;
  
          case PART::control::enableProportionalPortamento:
              proprt->value(valInt);
              if(value != 0)
              {
                  propta->activate();
                  proptb->activate();
              }
              else
              {
                  propta->deactivate();
                  proptb->deactivate();
              }
              break;
  
          case PART::control::proportionalPortamentoRate:
              propta->value(valInt);
              break;
  
          case PART::control::proportionalPortamentoDepth:
              proptb->value(valInt);
              break;
  
          case PART::control::receivePortamento:
              rcv->value(valInt);
              break;
  
          case PART::control::midiModWheel:
              modulation->value(value);
              break;
          case PART::control::midiExpression:
              expression->value(value);
              break;
          case PART::control::midiFilterQ:
              filterq->value(value);
              break;
          case PART::control::midiFilterCutoff:
              filtercutoff->value(value);
              break;
          case PART::control::midiBandwidth:
              masterbandwidth->value(value);
              break;
  
          case PART::control::instrumentName:
              if (!kitType)
                  checkEngines(text);
              else
                  partkititem[kititem]->labelbutton->copy_label(text.c_str());
              break;
          case PART::control::defaultInstrumentCopyright:
              if(parameter == 0)
                  copyright->value(text.c_str());
              break;
          case PART::control::resetAllControllers:
              updatecontrollers();
              break;
          default:
              break;
      }
}

PartUI::PartUI(int x,int y, int w, int h, const char *label):Fl_Group(x,y,w,h,label) {
  //
      part = NULL;
      adnoteui = NULL;
      subnoteui = NULL;
      padnoteui = NULL;
      lastkititem = -1;
}

void PartUI::updatecontrollers() {
  //
      enportamento->value(0);
      keymode->value(part->Pkeymode & 3);
      expmwh->value(part->ctl->modwheel.exponential);
      modwh->value(part->ctl->modwheel.depth);
      expbw->value(part->ctl->bandwidth.exponential);
      bwdpth->value(part->ctl->bandwidth.depth);
      pwheelbrng->value(part->ctl->pitchwheel.bendrange);
      panwidth->value(part->ctl->panning.depth);
      filtq->value(part->ctl->filterq.depth);
      fltcut->value(part->ctl->filtercutoff.depth);
      volrng->value(part->ctl->volume.data);
      expr->value(part->ctl->expression.receive);
      fmamp->value(part->ctl->fmamp.receive);
      vol->value(part->ctl->volume.receive);
      sustain->value(part->ctl->sustain.receive);
  
      cfdpth->value(part->ctl->resonancecenter.depth);
      rbwdpth->value(part->ctl->resonancebandwidth.depth);
  
      rcv->value(part->ctl->portamento.receive);
      thresh->value(part->ctl->portamento.pitchthresh);
      propta->value(part->ctl->portamento.propRate);
      proprt->value(part->ctl->portamento.proportional);
      if(proprt->value())
      {
          propta->activate();
          proptb->activate();
      }
      else
      {
          propta->deactivate();
          proptb->deactivate();
      }
      prtime->value(part->ctl->portamento.time);
      timedu->value(part->ctl->portamento.updowntimestretch);
      thtype->value(part->ctl->portamento.pitchthreshtype);
      proptb->value(part->ctl->portamento.propDepth);
}

void PartUI::init(Part *part_,int npart_,BankUI *bankui_) {
  //
      synth = part_->getSynthEngine();
      bankui = bankui_;
      part = part_;
      npart = npart_;
      plgroup = &synth->getGuiMaster()->panelgroup;
      ninseff = 0;
      make_window();
      partgroup->position(this->parent()->x() + 2, this->parent()->y() + 2);
      partgroup->show();
      lastkey = -1;
      end();
}

void PartUI::checkEngines(string instrumentName ) {
  //
      engine = 0;
      if (instrumentName == "")
          instrumentName = part->Pname;
      partname = instrumentName; // this needs improving
      if (synth->getRuntime().checksynthengines)
      {
          if (!partKitOn)
          {
              engine |= adsynenabledcheck->value();
              engine |= (subsynenabledcheck->value() << 1);
              engine |= (padsynenabledcheck->value() << 2);
          }
          else
          {
              for (int i = 0; i < NUM_KIT_ITEMS; ++i)
              {
                  if (partkititem[i]->enabledcheck->value())
                  { // nested so we don't access non existent
                      if (partkititem[i]->mutedcheck->value() == 0)
                      {
                          engine |= partkititem[i]->adcheck->value();
                          engine |= (partkititem[i]->subcheck->value() << 1);
                          engine |= (partkititem[i]->padcheck->value() << 2);
                      }
                  }
              }
          }
      }
      if (engine & 1) // addsynth
      {
          addbox->color(ADD_COLOUR);
          instrumentaddbox->color(ADD_COLOUR);
      }
      else
      {
          addbox->color(BASE_COLOUR);
          instrumentaddbox->color(BASE_COLOUR);
      }
      if (engine & 2) // subynth
      {
          subbox->color(SUB_COLOUR);
          instrumentsubbox->color(SUB_COLOUR);
      }
      else
      {
          subbox->color(BASE_COLOUR);
          instrumentsubbox->color(BASE_COLOUR);
      }
      if (engine & 4) // padsynth
      {
          padbox->color(PAD_COLOUR);
          instrumentpadbox->color(PAD_COLOUR);
      }
      else
      {
          padbox->color(BASE_COLOUR);
          instrumentpadbox->color(BASE_COLOUR);
      }
  
      ADD->damage(1);
      instrumentaddbox->damage(1);
      SUB->damage(1);
      instrumentsubbox->damage(1);
      PAD->damage(1);
      instrumentpadbox->damage(1);
      instrumentlabel->copy_label(instrumentName.c_str());
  
      if (npart >= *plgroup && npart < (*plgroup + NUM_MIDI_CHANNELS))
      {
          int num = npart % NUM_MIDI_CHANNELS;
          if (engine & 1)
              synth->getGuiMaster()->panellistitem[num]->partadd->color(ADD_COLOUR);
          else
              synth->getGuiMaster()->panellistitem[num]->partadd->color(BASE_COLOUR);
          if (engine & 2)
              synth->getGuiMaster()->panellistitem[num]->partsub->color(SUB_COLOUR);
          else
              synth->getGuiMaster()->panellistitem[num]->partsub->color(BASE_COLOUR);
          if (engine & 4)
              synth->getGuiMaster()->panellistitem[num]->partpad->color(PAD_COLOUR);
          else
              synth->getGuiMaster()->panellistitem[num]->partpad->color(BASE_COLOUR);
  
          synth->getGuiMaster()->panellistitem[num]->partadd->damage(1);
          synth->getGuiMaster()->panellistitem[num]->partsub->damage(1);
          synth->getGuiMaster()->panellistitem[num]->partpad->damage(1);
          synth->getGuiMaster()->panellistitem[num]->partname->copy_label(instrumentName.c_str());
      }
}

void PartUI::showparameters(int kititem, int engine) {
  //
      string tname;
      kitname = part->kit[kititem].Pname;
      if (engine == -1)
      {   // this is used if I want to clear the engine from the part
          if (kititem == lastkititem)
              kititem = -1;
          else
              kititem = lastkititem;
      }
      checkEngines();
  
      if (kititem != lastkititem)
      {
          if (adnoteui != NULL)
              delete adnoteui;
          if (subnoteui != NULL)
              delete subnoteui;
          if (padnoteui != NULL)
              delete padnoteui;
          adnoteui = NULL;
          subnoteui = NULL;
          padnoteui = NULL;
          lastkititem = kititem;
          if (kititem >= NUM_KIT_ITEMS)
              return; // bad kit item
          if (kititem < 0)
              return;
  
          if (part->kit[kititem].adpars)
              adnoteui = new ADnoteUI(part->kit[kititem].adpars, npart, lastkititem);
  
          if (part->kit[kititem].subpars)
              subnoteui = new SUBnoteUI(part->kit[kititem].subpars, npart, lastkititem);
  
          if (part->kit[kititem].padpars)
              padnoteui = new PADnoteUI(part->kit[kititem].padpars, npart, lastkititem);
      }
  
      if (engine == 0 && adnoteui != NULL)
          adnoteui->ADnoteGlobalParameters->show();
      if (engine == 1 && subnoteui != NULL)
          subnoteui->SUBparameters->show();
      if (engine == 2 && adnoteui != NULL)
          padnoteui->padnotewindow->show();
}

void PartUI::setinstrumentlabel(string text ) {
  //
      engine = 0;
      if (synth->getRuntime().checksynthengines)
      {
          for(int i = 0; i < NUM_KIT_ITEMS; ++i)
          {
              if (part->kit[i].Padenabled)
                  engine |= 1;
              if (part->kit[i].Psubenabled)
                  engine |= 2;
              if (part->kit[i].Ppadenabled)
                  engine |= 4;
          }
      }
      if (engine & 1)
          instrumentaddbox->color(ADD_COLOUR);
      else
          instrumentaddbox->color(BASE_COLOUR);
      if (engine & 2)
          instrumentsubbox->color(SUB_COLOUR);
      else
          instrumentsubbox->color(BASE_COLOUR);
  
      if (engine & 4)
          instrumentpadbox->color(PAD_COLOUR);
      else
          instrumentpadbox->color(BASE_COLOUR);
  
      if (part->PyoshiType)
          instrumentlabel->labelcolor(YOSHI_COLOUR);
      else
          instrumentlabel->labelcolor(FL_BLACK);
      if (text == "")
          text = part->Pname.c_str();
      partname = text;
      instrumentlabel->copy_label(text.c_str());
}

void PartUI::seteditname() {
  //
      instrumenteditwindow->copy_label(synth->getGuiMaster()->setPartWindowTitle("Edit").c_str());
}

void PartUI::ctlmidirefresh() {
  //
      modulation->value(part->ctl->modwheel.data);
      expression->value(part->ctl->expression.data);
      filterq->value(part->ctl->filterq.data);
      filtercutoff->value(part->ctl->filtercutoff.data);
      masterbandwidth->value(part->ctl->bandwidth.data);
}

PartUI::~PartUI() {
  //
      if (adnoteui)
          delete adnoteui;
      if (subnoteui)
          delete subnoteui;
      if (padnoteui)
          delete padnoteui;
      partgroup->hide();
      ctlwindow->hide();
      delete ctlwindow;
      ctlmidi->hide();
      delete ctlmidi;
      partfx->hide();
      delete partfx;
      instrumentkitlist->hide();
      delete instrumentkitlist;
      instrumenteditwindow->hide();
      delete instrumenteditwindow;
}
